.. _changelog:

Changelog
=========

The format is based on `Keep a Changelog <https://keepachangelog.com/en/1.0.0/>`_, and
we adhere to `Semantic Versioning <https://semver.org/spec/v2.0.0.html>`_.

The source code for all `releases <https://github.com/sktime/sktime/releases>`_ is
available on GitHub.

.. note::

    To stay up-to-date with sktime releases, subscribe to sktime `here
    <https://libraries.io/pypi/sktime>`_ or follow us on `LinkedIn <https://www.linkedin.com/company/scikit-time/>`_.

For our long-term plan, see our :ref:`roadmap`.

Version 0.38.5 - 2025-08-21
---------------------------

Highlights
~~~~~~~~~~

* Residual Boosting Forecaster, can be used to add exogenous or probabilistic capability to forecasters (:pr:`8582`) :user:`Sanchay117`
* ``TinyTimeMixer`` forecaster now supports exogenous data (:pr:`8709`) :user:`akshathmangudi`
* ``InceptionTimeClassifier`` now supports class weights (:pr:`8509`) :user:`Virgile-Foussereau`
* New Dataset Downloaders for TS Datasets (:pr:`8505`) :user:`jgyasu`
* percentage forecasting metrics now allow ``relative_to=y_pred`` (:pr:`8335`) :user:`OnePunchMonk`
* Jarque-Bera, variance break, and Ljung-Box tests/statistics (:pr:`8017`) :user:`HarshvirSandhu`

Dependency changes
~~~~~~~~~~~~~~~~~~

* ``temporian`` has been removed from the recommended ``transformations``
  dependency set, as it appears to be unmaintained
* ``esig`` has been removed as a soft dependency
* ``arch`` (forecasting soft dependency) bounds have been updated to ``<7.3``


Core interface changes
~~~~~~~~~~~~~~~~~~~~~~

Data sets and data loaders
^^^^^^^^^^^^^^^^^^^^^^^^^^

Most ``sktime`` dataset loaders now use ``huggingface`` datasets as a configurable
primary backend. Source files are hosted in the ``sktime`` huggingface organization.

If ``huggingface`` is not installed or available alternative backends are used, such as
direct download from UCR/UEA archive.

Time series classification
^^^^^^^^^^^^^^^^^^^^^^^^^^

A new tag ``capability:class_weight : bool`` has been added to indicate support for
class weights. If set, a ``class_weight`` parameter can be passed to the
constructor of classifiers with this tag, to specify class weights for training.


Enhancements
~~~~~~~~~~~~

BaseObject and base framework
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] add more common packages in standard ``show_versions`` return (:pr:`8484`) :user:`fkiraly`
* [ENH] tests for ``parallelize`` backend abstraction utility (:pr:`8622`) :user:`Sanchay117`

Benchmarking, Metrics, Splitters
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] change ``MeanAbsolutePercentageError`` parent to ``BaseForecastingErrorMetric`` (:pr:`8632`) :user:`fkiraly`
* [ENH] ``relative_to=y_pred`` support for percentage error forecasting metric classes (:pr:`8335`) :user:`OnePunchMonk`
* [ENH] MASE efficient ``_evaluate_by_index`` (:pr:`8611`) :user:`thearshkumar`
* [ENH] implement efficient ``_evaluate_by_index`` for ``GeometricMeanAbsoluteError`` (:pr:`7095`):user:`KaustubhUp025`,  :user:`fkiraly`
* [ENH] Refactor Benchmarking Classes (:pr:`8666`) :user:`jgyasu`

Data sets and data loaders
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] New Dataset Downloaders for TS Datasets (:pr:`8505`) :user:`jgyasu`

Forecasting
^^^^^^^^^^^

* [ENH] ``LTSFNLinearForecaster``, ``LTSFDLinearForecaster``,  and ``LTSFLinearForecaster`` ``get_test_params`` returns two sets (:pr:`8528`) :user:`thearshkumar`
* [ENH] Added tag to ``PytorchForecastingTFT`` and removed from ``tests/_config`` (:pr:`8559`) :user:`thearshkumar`
* [ENH] ``darts`` compatibility patch for ``darts 0.35.0`` and higher (:pr:`8584`) :user:`fkiraly`
* [ENH] ``patchtst`` deep learning model for forecasting (:pr:`6787`) :user:`julian-fong`
* [ENH] Residual Booster Forecaster (:pr:`8582`) :user:`Sanchay117`
* [ENH] split forecasting tuners module into individual files (:pr:`8418`) :user:`fkiraly`
* [ENH] Exogenous Handling in ``TinyTimeMixer`` Forecaster (:pr:`8709`) :user:`akshathmangudi`
* [ENH] Minor ``statsforecast ``updates (:pr:`8692`) :user:`yarnabrina`
* [ENH] in-sample prediction capability for `ARCH` forecaster :user:`SzymonStolarski`

Parameter estimation and hypothesis testing
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] Jarque-Bera, variance break, and Ljung-Box tests/statistics (:pr:`8017`) :user:`HarshvirSandhu`

Time series classification
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] ensure that any change in ``classification.sklearn`` triggers the classification tests (:pr:`8609`) :user:`fkiraly`
* [ENH] return histogram option in ``IndividualBOSS`` (:pr:`8636`) :user:`Pradyumn-cloud`
* [ENH] Move ``FCNClassifier`` test skip rule to estimator tag (:pr:`8603`) :user:`sinemkilicdere`
* [ENH] Allows 1 mismatch in ``RotationForest`` tests (:pr:`8628`) :user:`akshathmangudi`
* [ENH] remove ``esig`` soft dependency and move ``esig`` based estimators to own test VM (:pr:`8679`) :user:`fkiraly`
* [ENH] remove customized ``attentionLSTM`` layer. Replace with ``keras`` attention (:pr:`8721`) :user:`jnrusson1`
* [ENH] add class weight to ``InceptionTimeClassifier`` and capabability tag (:pr:`8509`) :user:`Virgile-Foussereau`
* [ENH] add tests for TSC ``evaluate`` parallelization backends  (:pr:`8737`) :user:`thisisrick25`
* [ENH] improve classifier ``evaluate`` defaults and documentation (:pr:`8739`) :user:`fkiraly`

Time series clustering
^^^^^^^^^^^^^^^^^^^^^^

* [ENH] accept str distances in ``TimeSeriesDBSCAN``, allow distance parameters (:pr:`8608`) :user:`Burnie-Murray`

Transformations
^^^^^^^^^^^^^^^

* [ENH] Replace deprecated ``_transform_single_feature`` with transform in ``_drcif_feature`` (:pr:`8599`) :user:`Anamika457`
* [ENH] Second test parameter set for ``MiniRocketMultivariate``, ``MiniRocketMultivariateVariable`` and ``MultiRocket``  (:pr:`8631`) :user:`IsaiasRT`
* [ENH] Move ``WindowSummarizer`` test skip to estimator tag (:pr:`8671`) :user:`Pranavsingh431`
* [ENH] remove ``esig`` soft dependency and move ``esig`` based estimators to own test VM (:pr:`8679`) :user:`fkiraly`

Test framework
^^^^^^^^^^^^^^

* [ENH] Added tag to ``PytorchForecastingTFT`` and removed from ``tests/_config`` (:pr:`8559`) :user:`thearshkumar`
* [ENH] tests for ``parallelize`` backend abstraction utility (:pr:`8622`) :user:`Sanchay117`

Documentation
~~~~~~~~~~~~~

* [DOC] improve formatting and clarity in ``python_dependencies`` tag description (:pr:`8517`) :user:`fkiraly`
* [DOC] Add guide for module-level soft dependency imports (#7690) (:pr:`8386`):user:`fkiraly`,  :user:`aarsh1a`
* [DOC] fix import location of ``_safe_import`` in developer guide (:pr:`8577`) :user:`fkiraly`
* [DOC] correct private docstrings for forecasting metrics (:pr:`8644`) :user:`fkiraly`
* [DOC] fix some broken links on the "decision making" page (:pr:`8583`) :user:`fkiraly`
* [DOC] add GC.OS donation mechanism to ``FUNDING.yml`` (:pr:`8623`) :user:`fkiraly`
* [DOC] Add ``plot_windows`` to API documentation (:pr:`8286`) :user:`aarushitandon0`
* [DOC] document metric tags in the tags API (:pr:`8638`) :user:`fkiraly`
* [DOC] correct and improve ``_percentage_error`` docstring and related docstrings (:pr:`8640`) :user:`fkiraly`
* [DOC] add links from estimator type specific API reference to subsection of tags API reference (:pr:`8637`) :user:`fkiraly`
* [DOC] improved formatting and clarity in docstrings of forecasting metrics (:pr:`8633`) :user:`fkiraly`
* [DOC] Level 2 page-toc (:pr:`8657`) :user:`thearshkumar`
* [DOC] add ``ResidualBoostingForecaster`` to the API reference (:pr:`8675`) :user:`fkiraly`
* [DOC] Add ``ClassificationBenchmark`` to API Reference (:pr:`8676`) :user:`jgyasu`
* [DOC] math formula and ``evaluate_by_index`` explanation for ``MeanLinexError`` (:pr:`8627`) :user:`sinemkilicdere`
* [DOC] improved docstrings for forecasting performance metrics (:pr:`8682`) :user:`fkiraly`
* [DOC] Corrected typos in ``examples/02 classification.ipynb`` (:pr:`8689`) :user:`hudeqiWH`
* [DOC] minor fixes to documentation (:pr:`8695`) :user:`fkiraly`
* [DOC] minor formatting improvement in dependency handling guide (:pr:`8720`) :user:`fkiraly`
* [DOC] various minor docstring formatting fixes (:pr:`8669`) :user:`fkiraly`

Maintenance
~~~~~~~~~~~

* [MNT] separate dependency set for notebooks, reduce dependencies in notebook CI (:pr:`8598`) :user:`fkiraly`
* [MNT] update notebook CI python version to 3.11 (:pr:`8604`) :user:`fkiraly`
* [MNT] remove unmaintained (?) package ``temporian`` from recommended ``transformations`` depset (:pr:`8485`) :user:`fkiraly`
* [MNT] reorder CI steps to minimize expected runtime (:pr:`8557`) :user:`fkiraly`
* [MNT] Update ``pytest-xdist`` requirement from ``<3.8,>=3.3`` to ``>=3.3,<3.9`` (:pr:`8470`) :user:`dependabot[bot]`
* [MNT] granular test runs in CI in single-estimator VM (:pr:`8647`) :user:`fkiraly`
* [MNT] Fix ``shellcheck`` line ending issues on Windows (:pr:`8502`) :user:`XAheli`
* [MNT] Bump ``actions/download-artifact`` from ``4`` to ``5`` (:pr:`8668`) :user:`dependabot[bot]`
* [MNT] CI: change ``macos-13`` runners to ``macos-latest``, of arm64 Architecture (:pr:`7715`) :user:`abhishek-iitmadras`
* [MNT] partial revert of #7715 for ``test-cython-estimators`` job. (:pr:`8680`) :user:`fkiraly`
* [MNT] Bump ``actions/checkout`` from ``4`` to ``5`` (:pr:`8687`) :user:`dependabot[bot]`
* [MNT] pre-commit autoupdate (:pr:`8694`) :user:`yarnabrina`
* [MNT] Check versions in wheels workflow (:pr:`8718`) :user:`szepeviktor`
* [MNT] ensure release depends on ``check_tag`` (:pr:`8726`) :user:`fkiraly`
* [MNT] Exclude Python 3.13 + macos-13 combo from CI to fix torch issue (#8127) (:pr:`8304`) :user:`adityagarwal15`
* [MNT] remove ``requires_cython`` tag and separate VM handling in favour of ``tests:vm`` (:pr:`8674`) :user:`fkiraly`
* [MNT] Improved changelog generator to sort by subsection (:pr:`8132`) :user:`Mujeeb4`
* [MNT] improved changelog generator: group PRs by module labels like Forecasting and Classification (:pr:`8579`) :user:`sinemkilicdere`
* [MNT] Update test_vms to use ``macos-latest`` in CI and configure osx setup in github scripts to dynamically install dependencies (:pr:`8624`) :user:`julian-fong`
* [MNT] Upgrade CI to set ``test-full`` to use ``macos-latest`` runners (:pr:`8670`) :user:`julian-fong`
* [MNT] Turn off ``mps`` for macos runners on ``tests:vm`` estimators and fixes ``momentfm`` CI failures (:pr:`8642`) :user:`julian-fong`
* [MNT] update ``arch`` bound to ``arch<7.3`` (:pr:`8743`) :user:`fkiraly`

Fixes
~~~~~

BaseObject and base framework
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] fix ``ray`` backend unintended side effects on ``backend_params`` by replacing ``list.pop`` with ``list.get`` (:pr:`8162`) :user:`LHoelper`
* [BUG] ensure ``deps`` dependency inspection is compatible with disjunctions in estimator dependency tags (:pr:`8585`) :user:`fkiraly`

Benchmarking, Metrics, Splitters
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] fix ``backend`` and ``backend_params`` in TSC ``evaluate`` being ignored (:pr:`8702`) :user:`fkiraly`

Forecasting
^^^^^^^^^^^

* [BUG] Fix the predictions from the ``ARCH`` model implementation (:pr:`8610`) :user:`SzymonStolarski`
* [BUG] RRF sometimes creates the wrong PeriodIndex when the frequency is higher than 1 (:pr:`8606`) :user:`LHoelper`
* [ENH] Add full exogenous variable support for statsmodels adapter _update() method when update_params=False (:pr:`8626`) :user:`Alexis-Fauxbaton`
* [BUG] Fix failing tests for pytorch forecasting models. (:pr:`7844`) :user:`Sohaib-Ahmed21`
* [BUG] suppressing ``dict`` while running TTM doctest (:pr:`8738`) :user:`akshathmangudi`

Time series anomalies, changepoints, segmentation
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] fix ``np.ndarray`` incompatibility in ``BaseDetector.fit_transform`` (:pr:`8329`) :user:`Imvedansh`
* [BUG] Fix missing input conversion in ``BaseDetector`` (:pr:`8328`) :user:`Rajdeep-naha`

Time series classification
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] decouple classifier, clusterer, regressor extension contract from ``n_jobs`` parameter (:pr:`8549`) :user:`fkiraly`
* [BUG] CNTCClassifier throws error when you provide callbacks. (:pr:`8660`) :user:`garar`
* [BUG] fix ``backend`` and ``backend_params`` in TSC ``evaluate`` being ignored (:pr:`8702`) :user:`fkiraly`
* [BUG] fix parallelization and pickling in TSC ``evaluate`` (:pr:`8741`) :user:`fkiraly`

Time series clustering
^^^^^^^^^^^^^^^^^^^^^^

* [BUG] decouple classifier, clusterer, regressor extension contract from ``n_jobs`` parameter (:pr:`8549`) :user:`fkiraly`

Time series regression
^^^^^^^^^^^^^^^^^^^^^^

* [BUG] decouple classifier, clusterer, regressor extension contract from ``n_jobs`` parameter (:pr:`8549`) :user:`fkiraly`

Contributors
~~~~~~~~~~~~

:user:`aarsh1a`,
:user:`aarushitandon0`,
:user:`abhishek-iitmadras`,
:user:`adityagarwal15`,
:user:`akshathmangudi`,
:user:`Alexis-Fauxbaton`,
:user:`Anamika457`,
:user:`Burnie-Murray`,
:user:`fkiraly`,
:user:`garar`,
:user:`HarshvirSandhu`,
:user:`hudeqiWH`,
:user:`Imvedansh`,
:user:`IsaiasRT`,
:user:`jgyasu`,
:user:`jnrusson1`,
:user:`julian-fong`,
:user:`LHoelper`,
:user:`Mujeeb4`,
:user:`OnePunchMonk`,
:user:`Pradyumn-cloud`,
:user:`Pranavsingh431`,
:user:`Rajdeep-naha`,
:user:`Sanchay117`,
:user:`sinemkilicdere`,
:user:`Sohaib-Ahmed21`,
:user:`szepeviktor`,
:user:`SzymonStolarski`,
:user:`thearshkumar`,
:user:`thisisrick25`,
:user:`Virgile-Foussereau`,
:user:`XAheli`,
:user:`yarnabrina`


Version 0.38.4 - 2025-07-17
---------------------------

Release focusing on bugfixes and ``scikit-learn`` downwards compatibility after 1.7.0
and increasing test framework reliability.


Enhancements
~~~~~~~~~~~~

Forecasting
^^^^^^^^^^^

* [ENH] The trend argument for ARDL forecaster can now also be 'ctt' (:pr:`8062`) :user:`ericjb`
* [ENH] remove internal broadcasting in ``ChronosForecaster`` in favour of programmatic broadcasting (:pr:`8561`) :user:`fkiraly`

Time series classification
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] more robust tag cloning in multiplexers for classification and regression (:pr:`8550`) :user:`fkiraly`

Test framework
^^^^^^^^^^^^^^

* [ENH] move test skip config to estimators (:pr:`8496`) :user:`fkiraly`
* [ENH] move test skips to estimators for estimators with their own VM (:pr:`8514`) :user:`fkiraly`
* [ENH] fix some failing doctests (:pr:`8536`) :user:`fkiraly`
* [ENH] ``tests:libs`` tag to specify library dependencies of estimators for differential testing (:pr:`8513`) :user:`fkiraly`
* [ENH] ``scikit-learn`` and ``pandas`` downwards compatibility patch (:pr:`8552`) :user:`fkiraly`
* [ENH] loosen condition for ``skpro`` dependency exception in ``BaseForecaster.predict_proba`` (:pr:`8554`) :user:`fkiraly`
* [ENH] add conditional testing to ``transformations.hierarchical.reconcile`` module (:pr:`8494`) :user:`fkiraly`
* [ENH] Move test skip config of ``TapNetClassifier`` from ``tests._config`` to estimator tags (:pr:`8516`) :user:`xenonnn4w`
* [ENH] Move test skip config of ``CNTCRegressor`` from ``tests._config`` to estimator tags (:pr:`8527`) :user:`Ghxst07`
* [ENH] Moved test skip config of ``DistanceFeatures`` from ``tests._config`` to estimator tags (:pr:`8520`) :user:`IsaiasRT`
* [ENH] Moved test skip config of ``ResNetClassifier`` from ``tests._config`` to estimator tags  (:pr:`8564`) :user:`Burnie-Murray`

Documentation
~~~~~~~~~~~~~

* [DOC] Notebook Demonstrating Benchmarking of Classifiers (:pr:`8373`) :user:`jgyasu`
* [DOC] Correct note about unequal-length time series support in ``sktime`` (:pr:`8510`) :user:`jgyasu`
* [DOC] fix ``TimeMoEForecaster`` doctest (:pr:`8541`) :user:`fkiraly`
* [DOC] Update the broken ``all-contributors.org`` website link to the correct GitHub repository URL (:pr:`8539`) :user:`Tirath5504`
* [DOC] Note about package names in ``_check_soft_dependencies`` (:pr:`8529`) :user:`jgyasu`
* [DOC] fix broken API reference of ``ColumnSelect`` and ``IndexSubset`` (:pr:`8504`) :user:`fkiraly`
* [DOC] A typo in ``test_all_estimators`` (:pr:`8534`) :user:`phoeenniixx`

Maintenance
~~~~~~~~~~~

* [MNT] do not trigger VM tests for non-core estimators on framework changes (:pr:`8497`) :user:`fkiraly`
* [MNT] CI steps to test by estimator with estimator specific dependencies, controlled by tag for separate VM (:pr:`7087`) :user:`fkiraly`, :user:`julianfong`
* [MNT] fix two instances of empty strategy in GHA (:pr:`8500`) :user:`fkiraly`
* [MNT] [Dependabot](deps): Bump ``actions/setup-python`` from ``4`` to ``5`` (:pr:`8507`) :user:`dependabot[bot]`
* [MNT] full test run on mid-to-lower dependency version range, 2023 state of core deps (:pr:`4016`) :user:`fkiraly`
* [MNT] replace ``dorny/paths-filter`` third party action with ``git diff`` call in ``detect-package-change`` (:pr:`8556`) :user:`fkiraly`

Fixes
~~~~~

BaseObject and base framework
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] fix ``sklearn`` tag inspection in ``scikit-learn < 1.6`` (:pr:`8546`) :user:`fkiraly`

Forecasting
^^^^^^^^^^^

* [BUG] Fix ``TimesFM`` ``_safe_import`` (:pr:`8511`) :user:`thearshkumar`

Test framework
^^^^^^^^^^^^^^

* [BUG] fix ``run_test_for_module`` usage in ``tests:libs`` tag (:pr:`8548`) :user:`fkiraly`

Contributors
~~~~~~~~~~~~

:user:`Burnie-Murray`,
:user:`ericjb`,
:user:`fkiraly`,
:user:`Ghxst07`,
:user:`IsaiasRT`,
:user:`jgyasu`,
:user:`julianfong`,
:user:`phoeenniixx`,
:user:`thearshkumar`,
:user:`Tirath5504`,
:user:`xenonnn4w`


Version 0.38.3 - 2025-07-04
---------------------------

Hotfix for failures of ``ChronosForecaster`` and ``TinyTimeMixerForecaster``.

Contents
~~~~~~~~

* [BUG] fix accidental removal of dataclass types in ``ChronosForecaster`` and ``TinyTimeMixerForecaster`` (:pr:`8488`) :user:`fkiraly`

Version 0.38.2 - 2025-07-03
---------------------------

``transformers 4.53`` compatibility patch, minor maintenance and documentation updates.

Contents
~~~~~~~~

* [MNT] CI: ``Add ubuntu-22.04-arm`` runners to enhance arm aarch64 architecture testing and maintenance (:pr:`7695`) :user:`abhishek-iitmadras`
* [MNT] fix: add ``aarch64`` installation constraint for ``esig`` and ``ts2vg`` (:pr:`8471`) :user:`abhishek-iitmadras`
* [MNT] Skip mlflow test jobs if ``sktime`` folder or ``pyproject.toml`` is untouched (:pr:`8474`) :user:`yarnabrina`
* [MNT] replace unsafe imports from ``torch`` and ``transformers`` with ``_safe_import`` pattern (:pr:`8476`) :user:`fkiraly`
* [MNT] update ``transformers`` imports for 4.53 compatibility (:pr:`8478`) :user:`fkiraly`
* [DOC] use clearer language in extension template preamble (:pr:`8466`) :user:`fkiraly`
* [DOC] add missing API reference for ``GreykiteForecaster`` (:pr:`8472`) :user:`fkiraly`

Contributors
~~~~~~~~~~~~

:user:`abhishek-iitmadras`,
:user:`fkiraly`,
:user:`yarnabrina`


Version 0.38.1 - 2025-06-26
---------------------------

``scikit-learn 1.7`` compatibility hotfix, thanks go to :user:`andretheronsa`.

Contents
~~~~~~~~

* [BUG] fix forecasting metric functions incompatible with ``scikit-learn 1.7`` (:pr:`8459`) :user:`andretheronsa`
* [MNT] revert docs to pre-8385 state (:pr:`8454`, :pr:`8444`) :user:`fkiraly`, :user:`yarnabrina`

Contributors
~~~~~~~~~~~~

:user:`andretheronsa`,
:user:`fkiraly`,
:user:`yarnabrina`


Version 0.38.0 - 2025-06-24
---------------------------

Maintenance release with scheduled deprecations and change actions.

For the last non-maintenance content update, see 0.37.1.

Dependency changes
~~~~~~~~~~~~~~~~~~

* ``numpy`` (core dependency) bounds have been updated to ``<2.4``
* ``pandas`` (core dependency) bounds have been updated to ``<2.4``
* ``scikit-learn`` (core dependency) bounds have been updated to ``<1.8``
* ``scipy`` (core dependency) bounds have been updated to ``<1.17``

Deprecations and removals
~~~~~~~~~~~~~~~~~~~~~~~~~

Benchmarking, Metrics, Splitters
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* deprecated methods from ``BaseBenchmark`` have been removed
* ``forecasting_validation`` utility has been removed - users should call ``ForecastingBenchmark`` instead

Data sets and data loaders
^^^^^^^^^^^^^^^^^^^^^^^^^^

* unused copies datasets have been removed from ``sktime.datasets.data``.
  Users should replace any direct read of data files in ``sktime.datasets.data`` with loading
  via dataset classes or loader functions. For example, reading ``ArrowHead_TRAIN.tsv``
  should be replaced by calling ``load`` from
  ``sktime.datasets.classification.ArrowHead``.

Forecasting
^^^^^^^^^^^

* removed: the ``proba`` module has been removed from ``sktime``. Users should replace
  imports from ``sktime.proba`` with imports from ``skpro.distributions``, in the ``skpro`` package.

Maintenance
~~~~~~~~~~~

* [MNT] [Dependabot](deps): Update pandas requirement from ``<2.3.0,>=1.1`` to ``>=1.1,<2.4.0`` (:pr:`8349`) :user:`dependabot[bot]`
* [MNT] lint ``conf.py`` (:pr:`8437`) :user:`fkiraly`
* [MNT] increase ``joblib`` bound to ``joblib<1.7`` (:pr:`8424`) :user:`fkiraly`
* [MNT] revert documentation PR 8385 (:pr:`8442`) :user:`fkiraly`
* [MNT] add ``scipy<1.16`` bounds to incompatible estimators (:pr:`8447`) :user:`fkiraly`
* [MNT] raise ``numpy`` bound to ``numpy<2.4`` (:pr:`8414`) :user:`fkiraly`
* [MNT] 0.38.0 deprecations and change actions (:pr:`8429`) :user:`fkiraly`
* [MNT] Delete Redundant Dataset Files (:pr:`8441`) :user:`jgyasu`
* [MNT] ``sklearn 1.7`` compatibility (:pr:`8439`) :user:`fkiraly`
* [MNT] raise ``scikit-learn`` bound to  ``<1.8.0`` (:pr:`8402`) :user:`fkiraly`
* [MNT] Delete Redundant Dataset Files (:pr:`8441`) :user:`jgyasu`

Documentation
~~~~~~~~~~~~~

* [DOC] Add new reconcilers to API reference (:pr:`8440`) :user:`felipeangelimvieira`

Fixes
~~~~~

* [BUG] Documentation ``conf.py`` is missing mandatory extensions (:pr:`8435`) :user:`felipeangelimvieira`
* [BUG] fix sphinx changelog link generation and panel overview (:pr:`8432`) :user:`fkiraly`

Contributors
~~~~~~~~~~~~

:user:`felipeangelimvieira`,
:user:`fkiraly`,
:user:`jgyasu`,
:user:`yarnabrina`


Version 0.37.1 - 2025-06-22
---------------------------

Highlights
~~~~~~~~~~

* new reconciler module, new non-negative reconciliation (:pr:`7697`) :user:`felipeangelimvieira`
* ``ClassificationBenchmark`` and ``evaluate`` utility for benchmarking time series classifiers (:pr:`8267`, :pr:`8357`) :user:`ksharma6`, :user:`jgyasu`
* ``momentfm`` foundation model forecaster (:pr:`6570`) :user:`julian-fong`
* ``momentfm`` foundation model time series classifier  (:pr:`8263`) :user:`julian-fong`
* ``ForecastKnownValues`` can now handle multi-index prescribed forecasts (:pr:`8236`) :user:`RobKuebler`
* sliding greedy splitter (:pr:`8168`) :user:`marrov`
* forecast ``evaluate`` utility can now handle temporal and global splits (:pr:`8064`) :user:`benHeid`
* ``SkforecastRecursive`` now supports in-sample ``predict_quantiles`` (:pr:`8255`) :user:`nahcol10`

Dependency changes
~~~~~~~~~~~~~~~~~~

* ``optuna`` (tuning soft dependency) bounds have been updated to ``<4.5``

Enhancements
~~~~~~~~~~~~

BaseObject and base framework
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] improve formatting of ``_safe_import`` docstrings (:pr:`8226`) :user:`fkiraly`
* [ENH] ``_placeholder_record`` to allow mirroring of multiple locations, update of ``skchange`` import locations (:pr:`8232`) :user:`fkiraly`
* [ENH] avoid all-tags retrieval, add package name to tag aliaser (:pr:`8401`) :user:`fkiraly`

Benchmarking, Metrics, Splitters
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] Add temporal global split to forecast ``evaluate`` utility (:pr:`8064`) :user:`benHeid`
* [ENH] sliding greedy splitter (:pr:`8168`) :user:`marrov`
* [ENH] make ``numpy`` output coercions consistent in metrics and distances (:pr:`8194`) :user:`fkiraly`
* [ENH] Visualisation utility for global splits (:pr:`8204`) :user:`benHeid`
* [ENH] Add ``relative_to`` parameter to percentage error metrics to enable relative-by-prediction metrics - part 1, functions (:pr:`8266`) :user:`OmBiradar`
* [ENH] refactor forecasting metrics into individual private submodules (:pr:`8279`) :user:`fkiraly`
* [ENH] enforce ``MeanSquaredErrorPercentage`` to be positive (:pr:`8318`) :user:`fkiraly`

Data sets and data loaders
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] Use ``sktime`` Provided Dataset in ``TSC`` Dataset Loaders (:pr:`8416`) :user:`jgyasu`

Data types, checks, conversions
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] Add ``is_hierarchical`` method to check whether a dataframe is hierarchical (:pr:`8170`) :user:`gbilleyPeco`

Documentation build
^^^^^^^^^^^^^^^^^^^

* [ENH] Speed up docs building and minor docs fixes (:pr:`8385`) :user:`mateuszkasprowicz`

Forecasting
^^^^^^^^^^^

* [ENH] interfacing ``momentfm`` forecaster as a deep learning module  (:pr:`6570`) :user:`julian-fong`
* [ENH] make ``ForecastKnownValues`` multiindex-ready (:pr:`8236`) :user:`RobKuebler`
* [ENH] Add regularization hyperparameter in ``ReconcilerForecaster`` (:pr:`7660`) :user:`HarshvirSandhu`
* [ENH] ``Greykite`` forecaster integration (:pr:`7902`) :user:`vedantag17`
* [ENH] change forecaster default tag value of `capability:categorical_in_X` to `True` to enable composition case (:pr:`8231`) :user:`fkiraly`
* [ENH] ``SkforecastRecursive`` - support in-sample ``predict_quantiles`` (:pr:`8255`) :user:`nahcol10`
* [ENH] enable univariate mode for ``DynamicFactor`` forecaster (:pr:`8345`) :user:`fkiraly`
* [ENH] minor improvements to ``MultiplexForecaster`` (:pr:`8422`) :user:`fkiraly`

MLOps & Deployment
^^^^^^^^^^^^^^^^^^

* [ENH] Fix MLflow 3.0 compatibility while maintaining 2.x support (:pr:`8395`) :user:`amanmogal`

Time series anomalies, changepoints, segmentation
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] ``skchange`` homogenization: variable identification + minor fixes (:pr:`7509`) :user:`Tveten`
* [ENH] update of ``skchange`` import locations (:pr:`8232`) :user:`fkiraly`

Time series classification
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] Extending categorical framework support in ``X`` to time series classifiers (:pr:`8114`) :user:`Ankit-1204`
* [ENH] Make grid search parameters in ``ShapeDTW`` configurable to enable faster testing (:pr:`8324`) :user:`benHeid`
* [ENH] ``momentfm`` classifier  (:pr:`8263`) :user:`julian-fong`
* [ENH] ``evaluate`` for TSC and TSR (:pr:`8267`, :pr:`6888`) :user:`jgyasu`, :user:`ksharma6`
* [ENH] Second Set of Test Parameters ``TimeSeriesForest`` (:pr:`8337`) :user:`nmwitzig`
* [ENH] Add ``predict_proba`` tag for classifier to estimator overview table (:pr:`8344`) :user:`jgyasu`
* [ENH] Add parallelization support for TSC ``evaluate`` (:pr:`8347`) :user:`jgyasu`
* [ENH] ``ClassificationBenchmark`` for benchmarking time series classifiers (:pr:`8357`) :user:`jgyasu`
* [ENH] Tests for TSC ``evaluate`` Parallel Backend (:pr:`8359`) :user:`jgyasu`

Time series distances and kernels
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] make ``numpy`` output coercions consistent in metrics and distances (:pr:`8194`) :user:`fkiraly`

Time series regression
^^^^^^^^^^^^^^^^^^^^^^

* [ENH] Extending categorical framework support in ``X`` to time series regressors (:pr:`8114`) :user:`Ankit-1204`
* [ENH] ``evaluate`` for TSC and TSR (:pr:`8267`, :pr:`6888`) :user:`jgyasu`, :user:`ksharma6`

Transformations
^^^^^^^^^^^^^^^

* [ENH] Enable ``EnbPIForecaster`` to work with ``sktime`` native bootstrap algorithms (:pr:`7562`) :user:`benHeid`
* [ENH] Simplify ``HampelFilter`` code and add a unit test (:pr:`8249`) :user:`RobKuebler`
* [ENH] Add missing space to ``Pipeline`` constructor warning (:pr:`8275`) :user:`yury-fedotov`
* [ENH] Implement reconcilers as transformations, and add new non-negative reconciliation (:pr:`7697`) :user:`felipeangelimvieira`
* [ENH] faster ``MovingBlockBootstrapTransformer`` tests, improved docstring (:pr:`8420`) :user:`fkiraly`

Test Framework
^^^^^^^^^^^^^^

* [ENH] move ``run_doctest`` to ``scikit-base`` (:pr:`8319`) :user:`fkiraly`
* [ENH] refactor test flag logic to ``tests._config`` (:pr:`8000`) :user:`fkiraly`
* [ENH] test framework: "core classes" and non-core classes with different test trigger conditions (:pr:`8408`) :user:`fkiraly`
* [ENH] core dependency changes also trigger estimator tests (:pr:`8415`) :user:`fkiraly`
* [ENH] remove some unstable and long running estimators from the core testing set (:pr:`8421`) :user:`fkiraly`

Documentation
~~~~~~~~~~~~~

* [DOC] mathematical reference for probabilistic forecasting metrics (:pr:`8213`) :user:`fkiraly`
* [DOC] improve ``VARReduce`` docstring (:pr:`8179`) :user:`fkiraly`
* [DOC] GC.OS sponsoring badge in ``README.md`` (:pr:`8320`) :user:`fkiraly`
* [DOC] add missing imports in ``fracdiff`` docstrings (:pr:`8317`) :user:`fkiraly`
* [DOC] fix broken docstring of ``KNeighborsTimeSeriesClassifierTslearn`` (:pr:`8341`) :user:`fkiraly`
* [DOC] mathematical formulae for MASE and MedASE (:pr:`8339`) :user:`piyushbiraje`
* [DOC] Add reference to the updated roadmap page in ``contributing.rst`` (:pr:`8350`) :user:`jgyasu`
* [DOC] fix ``KNeighborsTimeSeriesClassifierTslearn`` docstring (:pr:`8410`) :user:`fkiraly`
* [DOC] Fix citation formatting in ``lower_bounding.py`` to resolve doc warnings (:pr:`8389`) :user:`mohamed-halemo`
* [DOC] Fix failing doctest in ``ARLagOrderSelector`` example (:pr:`8407`) :user:`andoriyaprashant`
* [DOC] fix ``MomentFMClassifier`` docstring example (:pr:`8419`) :user:`fkiraly`
* [DOC] Update ``glossary.rst`` (:pr:`8214`) :user:`pcpp94`
* [DOC] Improves documentation in ``Testing and continuous integration`` webpage (:pr:`8247`) :user:`julian-fong`
* [DOC] Fix Docstring Example of Distance Based Classifiers (:pr:`8313`) :user:`jgyasu`
* [DOC] Update ``utils.rst`` API reference to add ``plot_windows`` (:pr:`7993`) :user:`Prahitha`
* [DOC] Fix documentation typos throughout the code base5 (:pr:`8301`) :user:`szepeviktor`

Maintenance
~~~~~~~~~~~

* [MNT] remove soft dependency from ``ForecastingOptunaSearchCV`` docstring example (:pr:`8202`) :user:`fkiraly`
* [MNT] fix ``VECM`` docstring example skip (:pr:`8207`) :user:`fkiraly`
* [MNT] fix ``apply_split`` doctest and skip ``SARIMAX`` failures (:pr:`8220`) :user:`fkiraly`
* [MNT] remove ``stefanzweifel/git-auto-commit-action`` from ``all-contributors`` workflow (:pr:`8369`) :user:`fkiraly`
* [MNT] add ``scipy<1.16`` bound to ``statsforecast`` and ``pmdarima`` based forecasters (:pr:`8427`) :user:`fkiraly`
* [MNT] [Dependabot](deps): Update ``pytest-timeout`` requirement from ``<2.4,>=2.1`` to ``>=2.1,<2.5`` (:pr:`8242`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update ``pytest-xdist`` requirement from ``<3.7,>=3.3`` to ``>=3.3,<3.8`` (:pr:`8303`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update ``pytest`` requirement from ``<8.4,>=7.4`` to ``>=7.4,<8.5`` (:pr:`8338`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update ``pytorch-forecasting`` requirement from ``<1.4.0,>=1.0.0`` to ``>=1.0.0,<1.5.0`` (:pr:`8399`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update ``optuna`` requirement from ``<4.3`` to ``<4.4`` (:pr:`8197`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update ``optuna`` requirement from ``<4.4`` to ``<4.5`` (:pr:`8400`) :user:`dependabot[bot]`

Fixes
~~~~~

BaseObject and base framework
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] fix links to documentation from estimator html repr (:pr:`8178`) :user:`mateuszkasprowicz`
* [BUG] ``_safe_import`` to avoid failures due to soft dependency chains in ``sktime/libs/uni2ts/forecast.py`` (:pr:`8192`) :user:`jgyasu`
* [BUG] fix ``_check_soft_dependencies`` error message if version is wrong (:pr:`8430`) :user:`fkiraly`

Benchmarking, Metrics, Splitters
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] Fix ``fh`` handling in greedy splitters (:pr:`8200`) :user:`marrov`
* [BUG] Fix ``"kkwargs"`` typo in ``ForecastingBenchmark`` (:pr:`8306`) :user:`yury-fedotov`
* [BUG] Fix boundary equality in ``EmpiricalCoverage`` (:pr:`8372`) :user:`marrov`

Forecasting
^^^^^^^^^^^

* [BUG] Fix aggregation function assignment in ``EnbPI`` class (:pr:`8230`) :user:`marrov`
* [BUG] fix recursive reduction tests (:pr:`8274`) :user:`fkiraly`
* [BUG] fix pandas future warning in ``pytorch-forecasting`` adapter due to in-place modification of a copy (:pr:`8269`) :user:`jobs-git`
* [BUG] fix: use names keyword instead of name (:pr:`8257`) :user:`RobKuebler`
* [BUG] fix wrong return of fit in doc tests of ``MoiraiForecaster`` and ``TimeLLM`` (:pr:`8326`) :user:`benHeid`
* [BUG] fix incorrect scitype inference in forecasting pipelines for polymorphic forecasters (:pr:`8237`) :user:`nahcol10`
* [BUG] remove broken reducer tests (:pr:`8412`) :user:`fkiraly`

Time series alignment
^^^^^^^^^^^^^^^^^^^^^

* [BUG] Fixed ``AlignerDTW`` when ``window_size`` needs to be passed given ``window_type`` (:pr:`8124`) :user:`OmBiradar`

Time series classification
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] fix ``RotationForest`` for a custom ``base_estimator`` (:pr:`8270`) :user:`fkiraly`
* [BUG] reindex features in ``TSFreshClassifier.predict_proba`` to match training columns (:pr:`8285`) :user:`Pranavsingh431`

Transformations
^^^^^^^^^^^^^^^

* [BUG] Fix ``Aggregator`` ``inverse_transform`` being skipped (:pr:`8358`) :user:`felipeangelimvieira`

Test framework
^^^^^^^^^^^^^^

* [BUG] fix accidental failure in fixture generating utility ``_get_parallel_test_fixtures``, (:pr:`8193`) :user:`fkiraly`
* [BUG] fix differential testing logic for ``DateTimeFeatures`` specific test (:pr:`8293`) :user:`andoriyaprashant`

Contributors
~~~~~~~~~~~~

:user:`amanmogal`,
:user:`andoriyaprashant`,
:user:`Ankit-1204`,
:user:`benHeid`,
:user:`felipeangelimvieira`,
:user:`fkiraly`,
:user:`gbilleyPeco`,
:user:`HarshvirSandhu`,
:user:`jgyasu`,
:user:`jobs-git`,
:user:`julian-fong`,
:user:`ksharma6`,
:user:`marrov`,
:user:`mateuszkasprowicz`,
:user:`mohamed-halemo`,
:user:`nahcol10`,
:user:`nmwitzig`,
:user:`OmBiradar`,
:user:`pcpp94`,
:user:`piyushbiraje`,
:user:`Prahitha`,
:user:`Pranavsingh431`,
:user:`RobKuebler`,
:user:`szepeviktor`,
:user:`Tveten`,
:user:`vedantag17`,
:user:`yury-fedotov`


Version 0.37.0 - 2025-04-12
---------------------------

Maintenance release with scheduled deprecations and change actions.

For the last non-maintenance content update, see 0.36.1.

Dependency changes
~~~~~~~~~~~~~~~~~~

* ``keras-self-attention`` (deep learning soft dependency) is no longer a soft dependency.
  The package has been abandoned and is now vendored in ``sktime``.

Core interface changes
~~~~~~~~~~~~~~~~~~~~~~

Forecasting and transformation pipelines can now be built with an ``scikit-learn``
estimator directly, without needing to wrap in ``TabularToSeriesAdaptor``.

The behaviour is the same as before, but the ``TabularToSeriesAdaptor`` is now optional.

Deprecations and removals
~~~~~~~~~~~~~~~~~~~~~~~~~

Forecasting
^^^^^^^^^^^

* deprecated: the ``handles-missing-data`` tag is deprecated and renamed to ``capability:missing_values``,
  to be consistent with other estimator types. The old tag name ``handles-missing-data`` can be used until 1.0.0,
  when it will be removed, but will raise a deprecation warning.
* removed: the deprecated ``HierarchyEnsembleForecaster.fitted_list`` parameter has been removed.
  Users should use ``get_fitted_params`` or ``forecasters_`` instead.

Time Series Anomalies, Changepoints, Segmentation
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* removed: the deprecated ``annotation`` module has been removed. Users should replace
  imports from ``sktime.annotation`` with imports from ``sktime.detection``.
* removed: the deprecated ``Y`` argument in detector methods has been removed.
  Instead, users should use the ``y`` argument.

Enhancements
~~~~~~~~~~~~

BaseObject and base framework
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] ``_safe_import`` to allow multiple inheritance from multiple mock classes (:pr:`8061`) :user:`fkiraly`

Data types, checks, conversions
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] refactor ``datatypes`` registry to ``scikit-base`` records (:pr:`7816`) :user:`fkiraly`

Forecasting
^^^^^^^^^^^

* [ENH] remove accidental ``univariate-only`` tags from forecasters (:pr:`8180`) :user:`fkiraly`
* [ENH] start rename of ``handles-missing-data`` tag to ``capability:missing_values`` (:pr:`7917`) :user:`fkiraly`
* [ENH] automatic transformer coercion in explicit forecasting pipeline specification syntax (:pr:`8153`) :user:`fkiraly`

Transformations
^^^^^^^^^^^^^^^

* [ENH] automatic transformer coercion in explicit transformer pipeline specification syntax (:pr:`8160`) :user:`fkiraly`

Maintenance
~~~~~~~~~~~

* [MNT] ``0.37.0`` deprecations and change actions (:pr:`8148`) :user:`fkiraly`
* [MNT] skip some known failing tests (:pr:`8152`) :user:`fkiraly`
* [MNT] docstring example fixes and test skips (:pr:`8159`) :user:`fkiraly`
* [MNT] temporary skip ``SCINetForecaster`` (:pr:`8171`) :user:`fkiraly`
* [MNT] remove ``tsbootstrap`` soft dependency from ``all_extras_pandas2`` dependency set (:pr:`8174`) :user:`fkiraly`
* [MNT] vendor abandoned ``keras-self-attention`` library (:pr:`8155`) :user:`fkiraly`
* [MNT] skip tests with ``ray`` parallelization fixtures (:pr:`8188`) :user:`fkiraly`
* [MNT] skip ``VECM`` doctest due to ``pandas 1`` incompatibility (:pr:`8187`) :user:`fkiraly`

Fixes
~~~~~

* [BUG] fix ``scitype`` return in case ``coerce_to_list=False`` and ``force_single_scitype=False`` if two or more types are detected (:pr:`8133`) :user:`fkiraly`
* [BUG] Stop Importing Modules if Raised an Exception in ``_safe_import`` (:pr:`8182`) :user:`jgyasu`

Contributors
~~~~~~~~~~~~

:user:`fkiraly`,
:user:`jgyasu`


Version 0.36.1 - 2025-04-04
---------------------------

Highlights
~~~~~~~~~~

* ``Time-LLM`` forecaster (:pr:`7663`) :user:`jgyasu`
* ``TimeMoE`` forecaster (:pr:`7869`) :user:`PranavBhatP`
* support for ``chronos-bolt`` in ``ChronosForecaster`` (:pr:`7718`) :user:`PranavBhatP`
* ``simdkalman``-based Kalman filter transformers (:pr:`8030`) :user:`oseiskar`
* ``ray`` parallelization backend (:pr:`8031`) :user:`LHoelper`
* ``HierarchyEnsembleForecaster`` can now select different parallelization backends (:pr:`7954`) :user:`LHolper`
* ``ADIDA`` intermittency forecaster from ``statsforecast`` (:pr:`7754`) :user:`vedantag17`
* ``SeasonalDummies`` - one hot encoding for seasonal categorical variable transformer (:pr:`7915`) :user:`ericjb`
* Revised Forecasting Benchmarking Module (:pr:`7603`) :user:`benHeid`

Dependency changes
~~~~~~~~~~~~~~~~~~

* ``tensorflow`` (deep learning soft dependency) bounds have been updated to ``<2.20``
* ``dask`` (data container and parallelization back-end soft dependency) bounds have been updated to ``<2025.2.1,>2024.8.2``
* ``ray`` is now a soft dependency (parallelization back-end)

Core interface changes
~~~~~~~~~~~~~~~~~~~~~~

* all native parallelization locations now accept ``"ray"`` as a parallelization backend, for example
    forecasting parameter tuning, or hierarchical parallelization via ``set_config``

* ``ForecastingBenchmark`` has been reworked:

  * accepts ``sktime``-in-memory data formats and dataset loaders
  * provides different handlers for benchmarking outputs, including ``json``, ``csv``, and ``parquet``.
  * supports global forecasters

Enhancements
~~~~~~~~~~~~

BaseObject and base framework
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] Add utility ``_safe_import`` for programmatic soft dependency isolation (:pr:`7702`) :user:`jgyasu`
* [ENH] private utilities for safe argument passing to function with unknown signature (:pr:`7766`) :user:`fkiraly`
* [ENH] extend ``_check_soft_dependencies`` to allow dependency disjunctions (:pr:`7943`) :user:`fkiraly`
* [ENH] refactor ``scitype`` detection logic and meta-estimator clone logic to include ``sklearn`` estimator types (:pr:`8131`) :user:`fkiraly`

Benchmarking, Metrics, Splitters
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] Extend forecasting benchmark to global setting (:pr:`6774`) :user:`XinyuWuu`
* [ENH] Add error handling to ``cINNForecaster``'s ``CurveFitForecaster`` (:pr:`7602`) :user:`Utkarsh-Aggarwal`
* [ENH] Revision Forecasting Benchmarking Module (:pr:`7603`) :user:`benHeid`
* [ENH] Extend benchmarking to accept sktime-in-memory data formats (:pr:`5055`) :user:`hazrulakmal`
* [ENH] benchmarking: make write to ``csv`` file optional (:pr:`7850`) :user:`fkiraly`
* [ENH] speed up forecasting ``evaluate`` benchmark input checks (:pr:`7899`) :user:`fkiraly`
* [ENH] coerce scalar forecasting metric outputs to ``float`` (:pr:`8074`) :user:`fkiraly`
* [ENH] Ensure Forecasting Metrics Return ``np.float64`` (:pr:`8099`) :user:`amitsubhashchejara`

Data sets and data loaders
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] Data loader functions for datasets to return ``y`` with numeric ``dtype`` (:pr:`7588`) :user:`vedantag17`

Forecasting
^^^^^^^^^^^

* [ENH] ``STLForecaster`` - added method ``plot_components`` (:pr:`6423`) :user:`ericjb`
* [ENH] ``ADIDA`` intermittency forecaster from ``statsforecast`` (:pr:`7754`) :user:`vedantag17`
* [ENH] add clusterer use to ``GroupByCategoryForecaster`` and docstrings (:pr:`7782`) :user:`fkiraly`
* [ENH] Implement support for ``chronos-bolt`` in ``ChronosForecaster`` (:pr:`7718`) :user:`PranavBhatP`
* [ENH] ``HierarchyEnsembleForecaster`` parallelization backends (:pr:`7954`) :user:`LHoelper`
* [ENH] improve methodology test coverage for ``DirectReductionForecaster`` and ``RecursiveReductionForecaster`` (:pr:`7770`) :user:`PranavBhatP`
* [ENH] reducer - minor code clarity refactor (:pr:`7556`) :user:`fkiraly`
* [ENH] add ``fit_strategy`` for ``TinyTimeMixerForecaster`` (:pr:`7648`) :user:`Sohaib-Ahmed21`
* [ENH] TimeLLM for Forecasting (vendored) (:pr:`7663`) :user:`jgyasu`
* [ENH] Enable the HF Transformers Forecaster to pass model as object (:pr:`7689`) :user:`Spinachboul`
* [ENH] ES-RNN Forecaster (:pr:`7772`) :user:`Ankit-1204`
* [ENH] move naive forecasters to separate folder (:pr:`8067`) :user:`fkiraly`
* [ENH] ``TimeMoE`` forecaster (vendored) (:pr:`7869`) :user:`PranavBhatP`

Parameter estimation
^^^^^^^^^^^^^^^^^^^^

* [ENH] Extended parameter estimator base class with y in ``fit`` (:pr:`7737`) :user:`satvshr`
* [ENH] test parameter estimator ``update`` in suite tests (:pr:`7952`) :user:`fkiraly`

Registry and search
^^^^^^^^^^^^^^^^^^^

* [ENH] change ``imports`` utility to produce public import paths (:pr:`8073`) :user:`fkiraly`

Test Framework
^^^^^^^^^^^^^^

* [ENH] Test case to ensure an ``AssertionError`` is thrown if ``EXCLUDED_TESTS_BY_TEST`` is not updated (:pr:`7622`) :user:`satvshr`
* [ENH] fix ``test_excluded_tests_by_test`` for ``HFTransformersForecaster`` (:pr:`7882`) :user:`fkiraly`
* [ENH] improve condition and error message in ``test_excluded_tests_by_test`` (:pr:`7904`) :user:`fkiraly`
* [ENH] trigger differential tests if core framework modules change (:pr:`7923`) :user:`fkiraly`
* [ENH] add some missing differential test skips (:pr:`8004`) :user:`fkiraly`
* [ENH] ``check_estimator`` verbose output on passed and failed tests if ``raise_exceptions=True`` (:pr:`8047`) :user:`fkiraly`
* [ENH] handle ``BaseForecaster.predict_proba`` ``skpro`` dependency in ``TestAllEstimators`` (:pr:`8023`) :user:`fkiraly`
* [ENH] minor linting fix in ``tests._config`` (:pr:`7912`) :user:`fkiraly`
* [ENH] Relax Panel-To-Panel transformations to allow changing the number of instances (:pr:`7991`) :user:`felipeangelimvieira`
* [ENH] catch ``test_fit_idempotent`` ``predict_proba`` soft dependency error (:pr:`8076`) :user:`fkiraly`

Time Series Anomalies, Changepoints, Segmentation
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] Time Series AUPRC Anomaly detection metric based on QuoVadisTAD (:pr:`7729`) :user:`Ankit-1024`

Transformations
^^^^^^^^^^^^^^^

* [ENH] param sets for ``MiniRocket`` (:pr:`7814`) :user:`Bergschaf`
* [ENH] added test parameters to ``Rocket`` estimator (:pr:`7813`) :user:`fkiraly`
* [ENH] Adds Seasonal dummies features via a transformer ``SeasonalDummies`` (one hot encoding for seasonal categorical variable) (:pr:`7915`) :user:`ericjb`
* [ENH] repeater bootstrap (:pr:`5854`) :user:`fkiraly`
* [ENH] Use ``RBFLayer``  to do the transformations in ``RBFTransformer`` and move ``RBFLayer`` and ``RBFNetwork`` to ``networks`` (:pr:`7730`) :user:`phoeenniixx`
* [ENH] Use valid covariance matrices in Kalman filter unit tests (:pr:`8029`) :user:`oseiskar`
* [ENH] move Kalman filter transformers into folder module (:pr:`8066`) :user:`fkiraly`
* [ENH] Add ``simdkalman``-based Series and Panel transformers (:pr:`8030`) :user:`oseiskar`
* [ENH] Allow ``Merger`` to work on hierarchical inputs (:pr:`8071`) :user:`wilsbj`

Documentation
~~~~~~~~~~~~~

* [DOC] minor fixes to data types documentation (:pr:`7777`) :user:`fkiraly`
* [DOC] fix link to developer guide in new contributor instructions (:pr:`7842`) :user:`fkiraly`, :user:`yarnabrina`
* [DOC] update enbpi docstrings (:pr:`7835`) :user:`Spinachboul`
* [DOC] Creating template for performance metrics for detection (:pr:`7740`) :user:`Ankit-1204`
* [DOC] fixing examples link (:pr:`7911`) :user:`fkiraly`
* [DOC] ``FCNClassifier`` - add Wang et al reference (:pr:`7884`) :user:`itsbharatj`
* [DOC] added docstring to the ``HierarchicalDask`` class (:pr:`7684`) :user:`TomatoChocolate12`
* [DOC] clarify assumptions on function ``fun`` in ``utils.parallel.parallelize`` (:pr:`7823`) :user:`fkiraly`
* [DOC] minor typo fix in ``add_estimators.rst`` (:pr:`7956`) :user:`fkiraly`
* [DOC] Added example for ``AlignerNaive`` and ``AlignerLuckyDtw`` (:pr:`7795`) :user:`haroon0x`
* [DOC] fix ``RotationForest`` docstring example (:pr:`7978`) :user:`fkiraly`
* [DOC] minor linting improvement (:pr:`7987`) :user:`fkiraly`
* [DOC] extension templates improvements (:pr:`7898`) :user:`fkiraly`
* [DOC] improved API reference for ``python_dependencies`` tag (:pr:`8022`) :user:`fkiraly`
* [DOC] fix ``FCNClassifier`` docstring (:pr:`8044`) :user:`tapyu`
* [DOC] fix a few broken glossary refs (:pr:`8050`) :user:`fkiraly`
* [DOC] add clear reference to ``ReconcilerForecaster`` in ``Reconciler`` documentation (:pr:`8045`) :user:`fkiraly`
* [DOC] remove some failing docstring examples (:pr:`8121`) :user:`fkiraly`
* [DOC] docstring example fixes - functions (:pr:`8126`) :user:`fkiraly`

Maintenance
~~~~~~~~~~~

* [MNT] Removes ``MiniRocket`` from ``EXCLUDED_TESTS_BY_TEST`` list to fix CI failures (:pr:`7860`) :user:`satvshr`
* [MNT] Add LLM prompt to template (:pr:`7851`) :user:`felipeangelimvieira`
* [MNT] Avoid skipping of unit tests of several forecasters (:pr:`7826`) :user:`yarnabrina`
* [MNT] temporary skip of ``MACNNClassifier`` failing tests (:pr:`7959`) :user:`fkiraly`
* [MNT] temporary skip of ``MCDCNNClassifier`` failing tests (:pr:`7960`) :user:`fkiraly`
* [MNT] remove ``tj-actions`` (:pr:`7989`) :user:`fkiraly`
* [MNT] move release to trusted publishers (:pr:`7990`) :user:`fkiraly`
* [MNT] temporary skip of ``VARMAX`` tests due to timeout (:pr:`7986`) :user:`fkiraly`
* [MNT] isolate ``pykan`` imports inside estimator (:pr:`6885`) :user:`fkiraly`
* [MNT] temporary skip of ``pytorch-forecasting`` tests until resolution of #7997 (:pr:`7998`) :user:`fkiraly`
* [MNT] Updating pre-commit hooks and running all hooks on all files (:pr:`7996`) :user:`yarnabrina`
* [MNT] temporary skip of ``STDBSCAN`` clusterer (:pr:`8024`) :user:`fkiraly`
* [MNT] For ``TSFreshFeatureExtractor`` remove upper bound of ``scipy`` set lower for ``tsfresh`` (:pr:`7847`) :user:`benHeid`
* [MNT] lint ``test_kalman_filter`` (:pr:`8054`) :user:`fkiraly`
* [MNT] increase ``pytorch-forecasting`` bound (:pr:`7783`) :user:`fkiraly`
* [MNT] Update ``pyproject.toml`` to install tensorflow up until python 3.12 (:pr:`7865`) :user:`Reckadon`
* [MNT] remove ``numpy 2`` dependency handler from ``BaseObject`` (:pr:`7955`) :user:`fkiraly`
* [MNT] address ``numpy`` array assignment deprecation (:pr:`7919`) :user:`fkiraly`
* [MNT] address some ``pandas`` deprecation warnings (:pr:`7866`) :user:`fkiraly`
* [MNT] temporary skip for ``DistanceFeatures`` until fix of known failures (:pr:`8078`) :user:`fkiraly`
* [MNT] temporary skip for ``TimeSeriesKvisibility`` until fix of known failures (:pr:`8079`) :user:`fkiraly`
* [MNT] Removes ``MiniRocket`` from ``EXCLUDED_TESTS_BY_TEST`` list to fix CI failures (:pr:`7860`) :user:`satvshr`
* [MNT] temporary skip of ``pytorch-forecasting`` tests until resolution of #7997 (:pr:`7998`) :user:`fkiraly`
* [MNT] Temporarily remove ``RecursiveReductionForecaster`` from unit tests (:pr:`8081`) :user:`felipeangelimvieira`
* [MNT] skip early classifier ``TEASER`` in ``test_multiprocessing_idempotent`` (:pr:`8085`) :user:`fkiraly`
* [MNT] skip ``test_transformation_can_return_new_instances`` until resolution of #8084 (:pr:`8086`) :user:`fkiraly`
* [MNT] remove ``dask`` from 3.13 dep sets due to failure of dependency resolution (:pr:`8101`) :user:`fkiraly`
* [MNT] Remove debugging line from test_check_estimator (:pr:`8104`) :user:`felipeangelimvieira`
* [MNT] update ``PyKANForecaster`` dependency set (:pr:`8109`) :user:`fkiraly`
* [MNT] remove ``CNTCRegressor`` parameter test skip (:pr:`8122`) :user:`fkiraly`
* [MNT] prevent ``torch`` installation on ``python 3.13`` and macos (:pr:`8143`) :user:`fkiraly`
* [MNT] increase ``tensorflow`` bound to ``<2.20`` (:pr:`8119`) :user:`fkiraly`
* [MNT] update ``dask`` version to ``dask<2025.2.1,>2024.8.2`` (:pr:`8083`) :user:`fkiraly`
* [MNT] [Dependabot](deps): Update ``sphinx-gallery`` requirement from ``<0.19.0`` to ``<0.20.0`` (:pr:`7819`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update ``dask`` requirement from ``<2024.8.1`` to ``<2025.2.1`` (:pr:`7857`) :user:`dependabot[bot]`

Fixes
~~~~~

BaseObject and base framework
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] Fix ``_safe_import`` and Add Tests (:pr:`7888`) :user:`jgyasu`
* [BUG] safer context manager for ``pandas 2.2`` warning suppression (:pr:`7910`) :user:`fkiraly`
* [BUG] fix ``_check_estimator_deps`` in disjunction case (:pr:`8025`) :user:`fkiraly`

Data sets and data loaders
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] Add missing frequencies to ``load_forecastingdata`` (:pr:`7575`) :user:`benHeid`
* [BUG] fix ``load_fpp3`` with fallback URL to avoid failure from changing CRAN URLs (:pr:`7799`) :user:`ericjb`

Data Types, Checks, Conversions
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] conversion ``Series``-``pd.DataFrame`` to ``Series``-``pd.Series`` now retains original column name as attr name in ``pd.Series`` (:pr:`7762`) :user:`ericjb`
* [BUG] fix unpack error from ``check_align`` in ``datatypes.alignment`` (:pr:`7821`) :user:`geetu040`

Forecasting
^^^^^^^^^^^

* [BUG] fix ``BaggingForecaster.predict_proba`` (:pr:`7791`) :user:`fkiraly`
* [BUG] fix (str, forecaster, count) parametrization for ``EnsembleForecaster`` (:pr:`7785`) :user:`fkiraly`
* [BUG] fix ``statsmodels`` adapter variable name for ``pd.Series`` (:pr:`7832`) :user:`fkiraly`
* [BUG] ``test_get_test_params_coverage`` throws an error when all tests are triggered (:pr:`7878`) :user:`satvshr`
* [BUG] Fix ``RecursiveReductionForecaster`` failing ``test_hierarchical_with_exogeneous`` (:pr:`7927`) :user:`felipeangelimvieira`
* [BUG] hack-fix for round trip conversions of ``pandas`` time series (:pr:`7925`) :user:`fkiraly`
* [BUG] ensure ``statsforecast`` adapter keeps track of trained forecaster (:pr:`7983`) :user:`yarnabrina`
* [BUG] Fix ``HierarchyEnsembleForecaster`` test failure (:pr:`7992`) :user:`wilsbj`
* [BUG] fix ``_HeterogenousEnsembleForecaster`` parameter inspection (:pr:`7984`) :user:`fkiraly`
* [BUG] fix ``_HeterogenousMetaForecaster`` handling of ``forecasters_`` (:pr:`8020`) :user:`fkiraly`
* [BUG] Use ``_DelegatedForecaster`` in ``HierarchicalProphet``, add upper bound to ``prophetverse`` version (:pr:`7980`) :user:`felipeangelimvieira`
* [BUG] MAPA forecaster - missing clone, using exogenous data (:pr:`7872`) :user:`satvshr`
* [BUG] fix timestamp format change in ``fh.to_absolute`` (:pr:`7914`, :pr:`8110`) :user:`XinyuWuu`
* [BUG] fix ``freq`` loss in ``NaiveForecaster`` (:pr:`8091`) :user:`XinyuWuu`

Parameter estimation
^^^^^^^^^^^^^^^^^^^^

* [BUG] fix parameter estimator missing univariate scenario and masked bugs (:pr:`7932`) :user:`fkiraly`

Test Framework
^^^^^^^^^^^^^^

* [BUG] fix failing ``TestAllForecasters`` test collection due to ``pytest`` inheritance bug (:pr:`7789`) :user:`yarnabrina`
* [BUG] fix ``check_estimator`` integration for ``TestAllGlobalForecasters`` (:pr:`7800`) :user:`fkiraly`, :user:`sohaib-ahmed21`
* [BUG] in tests, handle soft dependency in ``BaseForecaster.predict_proba`` on ``skpro`` (:pr:`7981`) :user:`fkiraly`
* [BUG] Testing util ``retrieve_scenarios should`` select scenarios for forecasters, clusterers, and classifiers (:pr:`7971`) :user:`wilsbj`
* [BUG] catch ``test_fit_idempotent`` ``predict_proba`` soft dependency error - secondary fix (:pr:`8080`) :user:`fkiraly`
* [BUG] ensure ``test_doctest_examples`` checks doctests correctly (:pr:`8065`) :user:`fkiraly`

Time Series Anomalies, Changepoints, Segmentation
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] ``BaseDetector`` - Incorrect docstring and tests for ``segments_to_change_points`` (:pr:`7640`) :user:`satvshr`

Time Series Classification
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] fix sporadic out-of-bounds error in ``ProximityStump`` and WDTW (:pr:`7836`) :user:`fkiraly`
* [BUG] skip ``RocketClassifier`` expected output test until resolved (:pr:`7922`) :user:`fkiraly`
* [BUG] Fix serialization errors in tests of ``MACNNClassifier`` (:pr:`8057`) :user:`benHeid`

Time Series Clustering
^^^^^^^^^^^^^^^^^^^^^^

* [BUG] ``TimeSeriesKVisibility`` - fix missing ``python_dependencies`` tag (:pr:`7972`) :user:`fkiraly`
* [BUG] fix broken clustering tests in ``TestAllClusterers`` (:pr:`7977`) :user:`fkiraly`
* [BUG] Fix failing tests for ``SklearnClustererPipeline``, ``TimeSeriesDBSCAN``, ``ClustererPipeline`` (:pr:`8028`) :user:`wilsbj`

Time Series Regression
^^^^^^^^^^^^^^^^^^^^^^

* [BUG] squeeze output of ``CNTCRegressor`` (:pr:`8116`) :user:`benHeid`

Transformations
^^^^^^^^^^^^^^^

* [BUG] ``sklearn 1.6.X`` compatibility for ``TabularToSeriesAdaptor`` - handle ``stateless`` tag by ``requires_fit`` in ``adapt.py`` (:pr:`7845`) :user:`benHeid`
* [BUG] Fix infinite recursion in ``_SuppressWarningPattern`` and ``LossySetitemError`` in ``SummaryTransformer`` (:pr:`7903`) :user:`celestinoxp`
* [BUG] fix ``Series``-to-``Primitives`` transformer output index for hierarchical data (:pr:`8037`) :user:`fkiraly`
* [BUG] Handle hierarchical mtype in ``ClustererAsTransformer`` (:pr:`8013`) :user:`felipeangelimvieira`
* [BUG] Hierarchical data passed to ``ClustererAsTransformer`` fails (:pr:`8053`) :user:`wilsbj`
* [BUG] fix expected output length tests for hierarchical transformations (:pr:`8069`) :user:`fkiraly`
* [BUG] Make ``_TransformChangeNInstances`` capable of handling hierarchical test scenarios (:pr:`8092`) :user:`felipeangelimvieira`
* [BUG] Handle hierarchical input types in ``ColumnConcatenator`` correctly (:pr:`8070`) :user:`wilsbj`

On-board library: ``vmdpy``
^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] Fix VMD odd length data returns even length decomposition (:pr:`8094`) :user:`danferns`, :user:`LorchZachery`

Contributors
~~~~~~~~~~~~

:user:`amitsubhashchejara`,
:user:`Ankit-1204`,
:user:`benHeid`,
:user:`Bergschaf`,
:user:`celestinoxp`,
:user:`danferns`,
:user:`ericjb`,
:user:`felipeangelimvieira`,
:user:`fkiraly`,
:user:`geetu040`,
:user:`haroon0x`,
:user:`hazrulakmal`,
:user:`itsbharatj`,
:user:`jgyasu`,
:user:`LHoelper`,
:user:`LorchZachery`,
:user:`oseiskar`,
:user:`phoeenniixx`,
:user:`PranavBhatP`,
:user:`Reckadon`,
:user:`satvshr`,
:user:`Sohaib-Ahmed21`,
:user:`Spinachboul`,
:user:`tapyu`,
:user:`TomatoChocolate12`,
:user:`Utkarsh-Aggarwal`,
:user:`vedantag17`,
:user:`wilsbj`,
:user:`XinyuWuu`,
:user:`yarnabrina`


Version 0.36.0 - 2025-02-03
---------------------------

Maintenance release with scheduled updates to version bounds.

For the last non-maintenance content update, see 0.35.1.

Dependency changes
~~~~~~~~~~~~~~~~~~

* ``numpy`` (core dependency) bounds have been updated to ``<2.3.0``
* ``scikit-learn`` (core dependency) bounds have been updated to ``<1.7.0``

Contents
~~~~~~~~

* [ENH] ``sklearn 1.6.X`` compatibility patch (:pr:`7751`, :pr:`7755`) :user:`fkiraly`
* [ENH] fix minor typos in error messages (:pr:`7750`) :user:`fkiraly`
* [MNT] [Dependabot](deps): Update ``numpy`` requirement from ``<2.2,>=1.21`` to ``>=1.21,<2.`` (:pr:`7675`, :pr:`7747`) :user:`dependabot[bot]`
* [MNT] raise ``scikit-learn`` bound to ``<1.7.0`` (:pr:`7742`) :user:`fkiraly`
* [MNT] fix some faulty instances of dependency handling (:pr:`7760`) :user:`fkiraly`
* [BUG] fix ``BaseDatatype.__call__`` dispatching to private, not public method (:pr:`7748`) :user:`fkiraly`


Version 0.35.1 - 2025-02-02
---------------------------

Highlights
~~~~~~~~~~

* Forecasting metrics ``__call__`` can be passed ``by_index`` to return per-index metric ``evaluate_by_index`` (:pr:`7608`) :user:`benHeid`
* MAPA forecaster (:pr:`7620`) :user:`phoeenniixx`
* Interface to ``skforecast.recursive.ForecasterRecursive`` (:pr:`7554`) :user:`yarnabrina`
* Native reducers (2nd generation) now support arbitrary imputation strategies (:pr:`7535`, :pr:`7646`) :user:`lenaklosik`
* New detection metrics: RAND Index, windowed F1-score (:pr:`7533`, :pr:`7628`) :user:`gavinkatz001`
* forecasting ``evaluate`` now allows returning fitted estimators via ``return_model`` parameter (:pr:`7637`) :user:`marrov`
* Tags and object API for Datasets (:pr:`7398`) :user:`felipeangelimvieira`
* K-visibility clustering algorithm (:pr:`7592`) :user:`seigpe`
* Interface to ``statmodels`` ``ar_select_order`` for lag order estimation (:pr:`7693`) :user:`satvshr`

Dependency changes
~~~~~~~~~~~~~~~~~~

* ``skpro`` (probability distributions soft dependency) bounds have been updated to ``>=2,<2.10.0``
* ``numba`` (computation soft dependency) bounds have been updated to ``<0.62``
* ``optuna`` (hyperparameter optimization soft dependency) bounds have been updated to ``<4.3``
* ``pykan`` (forecasting soft dependency) bounds have been updated to ``>=0.2.1,<0.2.9``
* ``dask`` (data container and parallelization back-end soft dependency) bounds have been updated to ``<2025.1.1``

Core interface changes
~~~~~~~~~~~~~~~~~~~~~~

Data sets and data loaders
^^^^^^^^^^^^^^^^^^^^^^^^^^

* a unified API has been introduced for data sets and data loaders,
following the ``scikit-base`` pattern.
A unified ``load`` method is now available for all data loaders,
with further unified API points such as ``keys`` and tags for retrieval.
For further details, see :ref:`datasets_ref` reference.

Forecasting
^^^^^^^^^^^

* All Forecasting metrics can now be constructed with a ``by_index=True`` argument.
This will result in a direct call returning the metric per time index.
This is equivalent to a call of the ``evaluate_by_index`` method.
``by_index=False`` is the default, and dispatches, as currently, to the ``evaluate``
method of the metric.

Deprecations and removals
~~~~~~~~~~~~~~~~~~~~~~~~~

In ``HierarchyEnsembleForecaster``, the ``fitted_list`` attribute is deprecated.
To access the fitted estimators, users should use instead either the ``get_fitted_params`` method,
or the attribute ``forecasters_``.
Given a fitted instance ``f``, a deprecated read call to ``f.fitted_list`` can be replaced
by ``f.get_fitted_params()['forecasters']`` or ``f.forecasters_``.

Enhancements
~~~~~~~~~~~~

BaseObject and base framework
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] html display of estimators - tag and consistent handling of via ``_steps_attr`` in ``HeterogenousMetaEstimator`` descendants (:pr:`7233`) :user:`mateuszkasprowicz`
* [ENH] sync dependency checkers with ``scikit-base`` (:pr:`7529`) :user:`fkiraly`

Benchmarking, Metrics, Splitters
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] base design for detection metrics (:pr:`7515`) :user:`fkiraly`
* [ENH] refactor ``InstanceSplitter`` to a utility ``apply_split`` to apply an ``sklearn`` split to a time series collection (:pr:`7330`) :user:`ksharma6`
* [ENH] Detection metrics - coercion to detection type in boilerplate (:pr:`7546`) :user:`fkiraly`
* [ENH] reduce requested metadata in forecasting metric input check (:pr:`7514`) :user:`fkiraly`
* [ENH] Expose ``evaluate`` params to ``add_task`` of forecasting benchmark (:pr:`7574`) :user:`benHeid`
* [ENH] Implement efficient ``_evaluate_by_index`` for ``MedianSquaredError`` (:pr:`7615`) :user:`satvshr`
* [ENH] RAND Index metric for time series segmentation (:pr:`7533`) :user:`gavinkatz001`
* [ENH] forecasting ``evaluate``: new ``return_model`` parameter to return fitted estimator states (:pr:`7637`) :user:`marrov`
* [ENH] windowed F1-score for detection (:pr:`7628`) :user:`gavinkatz001`
* [ENH] Implement efficient ``_evaluate_by_index`` for MdAPE (:pr:`7606`) :user:`HarshvirSandhu`
* [ENH] Forecasting metrics dispatch of ``__call__`` to ``evaluate`` vs ``evaluate_by_index`` (:pr:`7608`) :user:`benHeid`

Data sets and data loaders
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] Dataset object interface (:pr:`7398`) :user:`felipeangelimvieira`

Data types, checks, conversions
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] Remove ``gluonts dependency`` in ``gluonts_ListDataset_panel`` mtype (:pr:`7558`) :user:`PranavBhatP`
* [ENH] data types: early check for python type and host module to improve performance and dependency isolation (:pr:`7736`) :user:`fkiraly`
* [ENH] refactor `Alignment` and `Proba` datatypes to `scikit-base` records (:pr:`7739`) :user:`fkiraly`

Forecasting
^^^^^^^^^^^

* [ENH] deprecate ``fitted_list`` attribute of ``HierarchyEnsembleForecaster`` and  (:pr:`7423`) :user:`sanskarmodi8`
* [ENH] refactor forecasting metric tests prep - object_type tag ``metric_forecasting`` (:pr:`7516`) :user:`fkiraly`
* [ENH] Add ``SplineTrendForecaster`` (:pr:`7487`, :pr:`7502`) :user:`Dehelaan`, :user:`jgyasu`
* [ENH] Interface to ``skforecast.recursive.ForecasterRecursive`` (:pr:`7554`) :user:`yarnabrina`
* [ENH] naive thresholding detector (:pr:`7576`) :user:`fkiraly`
* [ENH] Forecaster imputer for ``RecursiveReductionForecaster`` (:pr:`7535`) :user:`lenaklosik`
* [ENH] ``TinyTimeMixer`` Validation split efficiency fix (:pr:`7647`) :user:`RHYTHM2405`
* [ENH] allow arbitrary imputation transformers in 2nd generation reducers (:pr:`7646`) :user:`fkiraly`
* [ENH] MAPA forecaster (:pr:`7620`) :user:`phoeenniixx`
* [ENH] Set ``context_len`` and ``horizon_len`` per default in ``TimesFMForecaster`` (:pr:`7597`) :user:`tanvincible`

Parameter estimation and hypothesis testing
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] Interface to ``statmodels`` ``ar_select_order`` (:pr:`7693`) :user:`satvshr`

Registry and search
^^^^^^^^^^^^^^^^^^^

* [ENH] change ``all_estimators`` retrieval to be entirely tag based (:pr:`7555`) :user:`fkiraly`

Time series anomalies, changepoints, segmentation
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] detection module rework - populate author and maintainer tags (:pr:`7510`) :user:`fkiraly`
* [ENH] Fix ``BaseDetector`` for segmentation and HMM estimators (:pr:`7480`) :user:`y-mx`, :user:`fkiraly`
* [ENH] refactor checks for detector outputs into separate module (:pr:`7542`) :user:`fkiraly`
* [ENH] detection base class input checks and conversions (:pr:`7577`) :user:`fkiraly`
* [ENH] ``ClaSPSegmentation`` fixes for new detection interface (:pr:`7585`) :user:`fkiraly`
* [ENH] ``PyODDetector`` fixes for new detector interface (:pr:`7584`) :user:`fkiraly`
* [ENH] window based time series segmentation via clustering (:pr:`7612`) :user:`Ankit-1204`
* [ENH] ``BinarySegmentation`` fixes for new detection interface (:pr:`7504`) :user:`Alex-JG3`
* [ENH] ``GreedyGaussianSegmentation`` fixes for new detection interface (:pr:`7472`) :user:`Spinachboul`

Time series classification
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] add ``sklearn`` compliance to ``RotationForest`` (:pr:`7638`) :user:`PranavBhatP`

Time series clustering
^^^^^^^^^^^^^^^^^^^^^^

* [ENH] improvements to clusterer base class and tests (:pr:`7665`) :user:`fkiraly`
* [ENH] K-visibility clustering algorithm (:pr:`7592`) :user:`seigpe`
* [ENH] clusterers: improved checking for ``X`` in ``fit`` and ``predict`` in ``capability:out_of_sample = False`` case, minor improvements to ``predict_proba`` default (:pr:`7593`) :user:`fkiraly`

Transformations
^^^^^^^^^^^^^^^

* [ENH] Add multiple test parameter sets for ``YtoX`` transformer (:pr:`7469`) :user:`tanvincible`
* [ENH] create ``rbf_forecaster.py`` using ``RBFTransformer`` Neural networks (:pr:`7334`) :user:`phoeenniixx`

Test framework
^^^^^^^^^^^^^^

* [ENH] Refactor test class registry to type records (:pr:`7525`) :user:`fkiraly`
* [ENH] migrate tests for point forecasting metrics to test class (:pr:`7532`) :user:`fkiraly`
* [ENH] clusterer test suite (:pr:`7589`) :user:`fkiraly`

Documentation
~~~~~~~~~~~~~

* [DOC] Add contributor Gavin Katz to .all-contributorsrc file (:pr:`7513`) :user:`gavinkatz001`
* [DOC] Added Note in docstring of InceptionTimeClassifier for fixing #7453 (:pr:`7508`) :user:`skinan`
* [DOC] Fixing some typos in ``transformation.rst`` (:pr:`7520`) :user:`phoeenniixx`
* [DOC] docstring usage examples for ``AlignerDTW`` and ``AlignerDTWfromDist`` (:pr:`7381`) :user:`Adarsh2345`
* [DOC] API reference documentation for ``SeriesXarray`` mtype (:pr:`7494`) :user:`SABARNO-PRAMANICK`
* [DOC] add proper credits to hfawaz and dl-4-tsc in various time series classifiers (:pr:`7518`) :user:`fkiraly`
* [DOC] API specification docstrings for ``TablePdDataFrame`` and ``TablePdSeries`` mtypes (:pr:`7540`) :user:`VjayRam`
* [DOC] API reference for mtype PanelGluontsList (:pr:`7539`) :user:`b9junkers`
* [DOC] document new ``visual_block_kind`` tag (:pr:`7524`) :user:`fkiraly`
* [DOC] API reference for ``TableNp1D`` mtype (:pr:`7553`) :user:`RUPESH-KUMAR01`
* [DOC] Add missing docstring for functions in ``/transformations/panel/catch22.py`` (:pr:`7527`) :user:`PranavBhatP`
* [DOC] Added docstrings for TableNp2d and TableListOfDict classes (:pr:`7563`) :user:`VjayRam`
* [DOC] minor formatting improvement in ``hf_transformers_forecaster`` (:pr:`7659`) :user:`fkiraly`
* [DOC] Update the docstring of sameloc splitter with a proper mathematical description (:pr:`7550`) :user:`keitaVigano`
* [DOC] AutoREG docstring includes non-existent arguments #7653 (:pr:`7654`) :user:`cheachu`
* [DOC] minor improvements in data loader docs (:pr:`7633`) :user:`fkiraly`
* [DOC] Fixed ``TablePolarsEager`` rendering issues related to recent merged PR #7666 (:pr:`7699`) :user:`fnhirwa`
* [DOC] improved formatting and clarity in release manager guide (:pr:`7705`) :user:`fkiraly`
* [DOC] improvements to git workflow guide, note about avoiding rebase (:pr:`7670`) :user:`fkiraly`
* [DOC] API reference for detection metrics (:pr:`7722`) :user:`fkiraly`
* [DOC] improved docstring for grouped/clustering forecaster compositors (:pr:`7709`) :user:`fkiraly`
* [DOC] add newer patterns to handle multivariate data in tutorial (:pr:`7362`) :user:`PranavBhatP`
* [DOC] update GitHub name of NoaWegerhoff (:pr:`7682`) :user:`fkiraly`
* [DOC] Fix typo in example code in documentation requiring double brackets to slice dataframe. DeepAR (:pr:`7641`) :user:`gbilleyPeco`
* [DOC] Fix typo in Add Estimators Documentation (:pr:`7519`) :user:`jgyasu`
* [DOC] Fixes #7623 Invalid Link  (:pr:`7625`) :user:`jgyasu`
* [DOC] Added Description for ``TablePolarsEager`` (:pr:`7666`) :user:`RHYTHM2405`
* [DOC] Fix invalid link to elections repository in sktime's website (:pr:`7631`) :user:`tanvincible`
* [DOC] Fix typo in example code in documentation requiring double brackets to slice dataframe. (:pr:`7639`) :user:`gbilleyPeco`
* [DOC] update ttm docstring to inform about zero-shot/fine-tuning (:pr:`7280`) :user:`geetu040`

Maintenance
~~~~~~~~~~~

* [MNT] Bump ``statsforecast`` to latest version (:pr:`7573`) :user:`yarnabrina`
* [MNT] ``tsfresh`` estimators - temporary bound on ``scipy`` (:pr:`7624`) :user:`fkiraly`
* [MNT] temporary skip of ``test_st_on_unit_test`` (:pr:`7726`) :user:`fkiraly`
* [MNT] fix: add ``aarch64`` installation constraint for ``temporian`` (:pr:`7692`) :user:`abhishek-iitmadras`
* [MNT] [Dependabot](deps): Update ``pykan`` requirement from ``<0.2.7,>=0.2.1`` to ``>=0.2.1,<0.2.9`` (:pr:`7396`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update ``dask`` requirement from ``<2024.8.1`` to ``<2025.1.1`` (:pr:`7481`, :pr:`7545`, :pr:`7658`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update ``skpro`` requirement from ``<2.9.0,>=2`` to ``>=2,<2.10.0`` (:pr:`7704`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update ``numba`` requirement from ``<0.61`` to ``<0.62`` (:pr:`7677`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update ``optuna`` requirement from ``<4.2`` to ``<4.3`` (:pr:`7676`) :user:`dependabot[bot]`

Fixes
~~~~~

BaseObject and base framework
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] Accepting prereleases as valid python version (:pr:`7544`) :user:`Abelarm`

Forecasting
^^^^^^^^^^^

* [BUG] fix ``get_fitted_params`` access to wrapped estimators in ``_HeterogenousEnsembleForecaster`` descendants (:pr:`7522`) :user:`fkiraly`
* [BUG] fix use of ``Imputer`` in ``RecursiveReductionForecaster`` (:pr:`7706`) :user:`Salzemann`

Neural networks
^^^^^^^^^^^^^^^

* [BUG] ``AttentionLSTM`` - Remove activity regularizers (:pr:`7582`) :user:`marcosfelt`

Registry and search
^^^^^^^^^^^^^^^^^^^

* [BUG] fixing spurious retrieval of fallback ``Normal`` distribution (:pr:`7720`) :user:`fkiraly`
* [BUG] fix ``all_estimators`` lookup in case a tag is used that is not scitype specific (:pr:`7679`) :user:`fkiraly`

Time series anomalies, changepoints, segmentation
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] Ensured that all ``_fit`` etc have lower case ``y`` (:pr:`7673`) :user:`KrishBakshi`

Time series classification
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] fix expected outputs tests of ``ShapeletTransformClassifier`` post shapelet transform fix #7499 (:pr:`7734`) :user:`fkiraly`
* [BUG] fix bugs in ``MACNNClassifier``, ``MACNNRegressor`` (:pr:`7651`) :user:`KrishBakshi`


Transformations
^^^^^^^^^^^^^^^

* [BUG] Fix inconsistency in ``_online_shapelet_distance`` std computation (:pr:`7499`) :user:`fnhirwa`
* [BUG] ``TSFreshFeatureExtractor`` and ``TSFreshRelevantFeatureExtractor``: fix distributor not getting passed through to ``extract_features`` (:pr:`7541`) :user:`marcosfelt`
* [BUG] in transformers, do not pass ``y`` to inner in case of scitype mismatch (:pr:`7733`) :user:`fkiraly`


Contributors
~~~~~~~~~~~~

:user:`Abelarm`,
:user:`abhishek-iitmadras`,
:user:`Adarsh2345`,
:user:`Alex-JG3`,
:user:`Ankit-1204`,
:user:`b9junkers`,
:user:`benHeid`,
:user:`cheachu`,
:user:`Dehelaan`,
:user:`felipeangelimvieira`,
:user:`fkiraly`,
:user:`fnhirwa`,
:user:`gavinkatz001`,
:user:`gbilleyPeco`,
:user:`geetu040`,
:user:`HarshvirSandhu`,
:user:`jgyasu`,
:user:`keitaVigano`,
:user:`KrishBakshi`,
:user:`ksharma6`,
:user:`lenaklosik`,
:user:`marcosfelt`,
:user:`marrov`,
:user:`mateuszkasprowicz`,
:user:`phoeenniixx`,
:user:`PranavBhatP`,
:user:`RHYTHM2405`,
:user:`RUPESH-KUMAR01`,
:user:`SABARNO-PRAMANICK`,
:user:`Salzemann`,
:user:`sanskarmodi8`,
:user:`satvshr`,
:user:`seigpe`,
:user:`skinan`,
:user:`Spinachboul`,
:user:`tanvincible`,
:user:`VjayRam`,
:user:`y-mx`,
:user:`yarnabrina`


Version 0.35.0 - 2024-12-09
---------------------------

Maintenance release with scheduled deprecations and change actions.

For the last non-maintenance content update, see 0.34.1.

Dependency changes
~~~~~~~~~~~~~~~~~~

* ``scikit-base`` bounds have been updated to ``>=0.6.1,<0.13.0``
* ``skpro`` (probability distributions soft dependency) bounds have been updated to ``>=2,<2.9.0``

Deprecations and removals
~~~~~~~~~~~~~~~~~~~~~~~~~

* From ``sktime 0.38.0``, forecasters' ``predict_proba`` will
  require ``skpro`` to be present in the python environment,
  for distribution objects to represent distributional forecasts.
  Since ``sktime 0.35.0``, an error is raised upon call of
  forecaster ``predict_proba`` if ``skpro`` is not present
  in the environment.
  Users of forecasters' ``predict_proba`` should ensure
  that ``skpro`` is installed in the environment.

* The probability distributions module ``sktime.proba`` deprecated and will
  be fully replaced by ``skpro`` in ``sktime 0.38.0``.
  Until ``sktime 0.38.0``, imports from ``sktime.proba`` will continue working,
  defaulting to ``sktime.proba`` if ``skpro`` is not present,
  otherwise redirecting imports to ``skpro`` objects.
  Since ``sktime 0.35.0``, an error is raised if ``skpro`` is not present
  in the environment, otherwise imports are redirected to ``skpro``.
  Direct or indirect users of ``sktime.proba`` should ensure ``skpro`` is
  installed in the environment.
  Direct users of the ``sktime.proba`` module should,
  in addition, replace any imports from
  ``sktime.proba`` with imports from ``skpro.distributions``.

* in ``neuralforecast`` facing estimator interfaces, the default for the
  ``broadcasting`` parameter has been consistently changed to ``False``.

Maintenance
~~~~~~~~~~~

* [MNT] [Dependabot](deps): Update scikit-base requirement from ``<0.12.0,>=0.6.1`` to ``>=0.6.1,<0.13.0`` (:pr:`7392`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update skpro requirement from ``<2.8.0,>=2`` to ``>=2,<2.9.0`` (:pr:`7406`) :user:`dependabot[bot]`
* [MNT] bound ``peft<0.14.0`` (:pr:`7495`) :user:`fkiraly`
* [MNT] 0.35.0 deprecations and change actions (:pr:`7485`) :user:`fkiraly`
* [MNT] remove top level import of transformers (:pr:`7491`) :user:`yarnabrina`
* [MNT] add upper bound to skforecast autoreg adapter (:pr:`7488`) :user:`yarnabrina`
* [DOC] fix failing cells in detection notebook after ``skchange`` update (:pr:`7483`) :user:`fkiraly`
* [BUG] Fix codec error on traditional Chinese Windows systems (:pr:`7498`) :user:`fnhirwa`

Contributors
~~~~~~~~~~~~

:user:`fkiraly`,
:user:`fnhirwa`,
:user:`yarnabrina`


Version 0.34.1 - 2024-11-29
---------------------------

Highlights
~~~~~~~~~~

* Full rework of detectors API, module is now maturing. :user:`tveten`, :user:`alex-jg3`, :user:`fkiraly`, :user:`alyssadsouza`, :user:`ShivamJ07`, :user:`RobotPsychologist`
* in forecasting metrics, allow a callable to be passed as ``sample_weight`` for dynamic weight generation (:pr:`7288`) :user:`MarkusSagen`
* Interfaces to new ``neuralforecast`` estimators (:pr:`7434`) :user:`yarnabrina`
* Box-Cox bias adjustment for forecasters (:pr:`7268`) :user:`sanskarmodi8`, :user:`talat-khattatov`
* SCINet forecaster (:pr:`7400`) :user:`Sohaib-Ahmed21`
* Spatio-Temporal DBSCAN clusterer (:pr:`7353`) :user:`vagechirkov`, :user:`vectornd`
* Signature moments transformer  (:pr:`7320`) :user:`VectorNd`

Dependency changes
~~~~~~~~~~~~~~~~~~

* ``dask`` (data container and parallelization back-end soft dependency) bounds have been updated to ``<2024.11.3``

Core interface changes
~~~~~~~~~~~~~~~~~~~~~~

Forecasting
^^^^^^^^^^^

Forecasting metrics now allow a callable to be passed as ``sample_weight`` for dynamic weight generation.
The precise contract the callables need to satisfy is documented in the docstrings.

Time series anomalies, changepoints, segmentation
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

The core API for time series detectors has changed, and has been homogenized with the API of ``skchange``.

The changes are in parts breaking, and require adjustments in the user code.
The changes were necessary to ensure a consistent API for time series detectors.

* ``BaseDetector.predict`` now returns a ``pd.DataFrame``. This ``DataFrame`` always
  has a ``RangeIndex``, with individual rows corresponding to individual events.
  The ``DataFrame`` has at least a column ``"ilocs"``, which contains the integer indices of the detected events,
  in reference to the argument ``X`` passed to ``predict``.
  The format, for an entry, can be a single integer or a left-closed ``pd.Interval`` of integers,
  indicating either a single point or a segment of points.
* an additional column ``"labels"`` may be present in cases of labelled events.
* ``BaseDetector.predict_points`` and ``predict_segments`` now also return ``pd.DataFrame``,
  following the same format as ``predict``, with the difference that ``predict_points``
  coerces detected events to points, taking start and end points of segments as separate points.
  ``predict_segments`` coerces detected events to segments, possibly single-index segments.
* ``BaseDetector.transform`` now always returns a ``pd.DataFrame`` with, which has
  at least a column ``"transform"`` containing the transformed series.

Enhancements
~~~~~~~~~~~~

BaseObject and base framework
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] refactor ``_check_estimator_types`` to use record class interface (:pr:`7395`) :user:`fkiraly`
* [ENH] parity of ``_HeterogenousMetaEstimator._check_estimator`` with ``skbase`` and fixes in ``EnsembleForecaster.__init__`` (:pr:`7429`) :user:`fkiraly`

Benchmarking, Metrics, Splitters
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] MSRE-percent forecasting metric (:pr:`7394`) :user:`jusssch`, :user:`fkiraly`

Forecasting
^^^^^^^^^^^

* [ENH] add ``RecursiveReductionForecaster`` to module exports, tests, and documentation (:pr:`4806`) :user:`fkiraly`
* [ENH] ``EnsembleForecaster`` option to specify multiple copies of same forecaster easily (:pr:`7424`) :user:`ericjb`
* [ENH] Add new arguments to neuralforecast rnn and lstm (:pr:`7422`) :user:`yarnabrina`
* [ENH] Box-Cox bias adjustment for forecasters (:pr:`7268`) :user:`sanskarmodi8`, :user:`talat-khattatov`
* [ENH] in forecasting metrics, allow a callable to be passed as ``sample_weight`` for dynamic weight generation (:pr:`7288`) :user:`MarkusSagen`
* [ENH] SCINet forecaster (:pr:`7400`) :user:`Sohaib-Ahmed21`
* [ENH] Reduce memory footprint of ``statsmodels`` adapter - save necessary ``_y`` info to remove need for ``_y`` (:pr:`7417`) :user:`hudsonhoch`
* [ENH] Interface new ``neuralforecast`` estimators (:pr:`7434`) :user:`yarnabrina`

Time series anomalies, changepoints, segmentation
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] Test parameter set for ``STRAY`` (:pr:`7420`) :user:`tajir0`
* [ENH] add ``_transform_score`` template and remove dead ``fmt`` related code from detectors (:pr:`7425`) :user:`ShivamJ07`
* [ENH] homogenization of sktime and skchange detection API - base class ``predict`` return type (:pr:`7433`) :user:`alyssadsouza`
* [ENH] rename private ``make_annotation_problem`` to ``make_detection_problem`` (:pr:`7436`) :user:`fkiraly`
* [ENH] minor improvements to ``BaseDetector`` (:pr:`7435`) :user:`fkiraly`
* [ENH] move detector non-suite tests to ``detection`` folder (:pr:`7445`) :user:`fkiraly`
* [ENH] homogenization of ``sktime`` and ``skchange`` detection API - part 1 - base class and ``y`` argument (:pr:`7342`) :user:`fkiraly`
* [ENH] homogenization of sktime and skchange detection API - part 2 - base class ``transform`` return type (:pr:`7432`) :user:`alyssadsouza`
* [ENH] move detector classes to ``detection`` module (:pr:`7448`) :user:`fkiraly`
* [ENH] conditional testing and imports for estimator specific tests in ``detection`` module (:pr:`7446`) :user:`fkiraly`
* [ENH] add detector specific tags to the tag registry and tags API reference (:pr:`7443`) :user:`liya-zhu`
* [ENH] detector dummies (:pr:`7440`) :user:`fkiraly`
* [ENH] Changed scitype name ``"series-annotator"`` to ``"detector"`` (:pr:`7361`) :user:`jgyfutub`
* [ENH] homogenization of ``sktime`` and ``skchange`` detection API - base class ``predict_scores`` return type (:pr:`7460`) :user:`alyssadsouza`
* [ENH] homogenization of ``sktime`` and ``skchange`` detection API - base class ``predict_points`` return type (:pr:`7459`) :user:`alyssadsouza`
* [ENH] ``skchange`` rename of ``Capa`` to ``CAPA`` (:pr:`7457`) :user:`fkiraly`
* [ENH] move detector tests to ``detection`` module (:pr:`7455`, :pr:`7464`) :user:`fkiraly`
* [ENH] renaming of detector suite tests (:pr:`7465`) :user:`fkiraly`
* [ENH] fix API incompatibility of ``SubLOF`` detector (:pr:`7468`) :user:`fkiraly`
* [ENH] add ``skchange`` change point detectors as placeholder records (:pr:`7458`) :user:`ShivamJ07`, :user:`fkiraly`
* [ENH] add placeholder records for ``skchange`` segment anomaly detectors (:pr:`7470`) :user:`fkiraly`
* [ENH] update ``DetectorPipeline`` and ``DetectorAsTransformer`` inner calls and docstrings (:pr:`7475`) :user:`fkiraly`
* [ENH] homogenization of sktime and skchange detection API - ``predict``, ``predict_points``, ``predict_segments`` (:pr:`7476`) :user:`fkiraly`

Time series classification
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] second test parameter to ``Arsenal`` classifier  (:pr:`7335`) :user:`jusssch`

Time series clustering
^^^^^^^^^^^^^^^^^^^^^^

* [ENH] Spatio-Temporal DBSCAN clusterer (:pr:`7353`) :user:`vagechirkov`, :user:`vectornd`

Time series regression
^^^^^^^^^^^^^^^^^^^^^^

* [ENH] Test parameter sets for ``ComposableTimeSeriesForestRegressor`` (:pr:`7431`) :user:`Dehelaan`

Transformations
^^^^^^^^^^^^^^^

* [ENH] Signature Moments transformer  (:pr:`7320`) :user:`VectorNd`
* [ENH] added test parameter set for ColumnTransformer (:pr:`7442`) :user:`sanskarmodi8`
* [ENH] second test parameter set in ``_multirocket_multivariate`` (:pr:`7344`) :user:`medha-14`

Test framework
^^^^^^^^^^^^^^

* [ENH] detection module suite tests coverage extension for methods (:pr:`6958`) :user:`Alex-JG3`

Documentation
~~~~~~~~~~~~~

* [DOC] fix typos in changelog, better explanation of scoring parameters (:pr:`7324`) :user:`fkiraly`
* [DOC] in docstring, rename ``Example``  to ``Examples`` sections (:pr:`7341`) :user:`fkiraly`
* [DOC] add docstring example for ``DropNA`` (:pr:`7327`) :user:`SSROCKS30`
* [DOC] Fixed sktime logo positioning in the README (:pr:`7322`) :user:`Akhsuna07`
* [DOC] Add uni2ts in libs/README.md (:pr:`7348`) :user:`pranavvp16`
* [DOC] Small typo on explanation of regression (:pr:`7366`) :user:`manolotis`
* [DOC] Add Binary Segmentation Estimator to API reference (:pr:`7379`) :user:`Dehelaan`
* [DOC] Add ``timesfm`` in libs/README.md (:pr:`7358`) :user:`geetu040`
* [DOC] categories for clustering algorithms in API reference (:pr:`7369`) :user:`fkiraly`
* [DOC] API reference for data representations (:pr:`7231`) :user:`fkiraly`
* [DOC] Improving the ``installation`` instructions to improve clarity (:pr:`7339`) :user:`julian-fong`
* [DOC] fixes to the mtype API reference (:pr:`7393`) :user:`fkiraly`
* [DOC] fix duplications of the word "correspond" (:pr:`7403`) :user:`fkiraly`
* [DOC] Add import location to HolidayFeatures docs (:pr:`7401`) :user:`mjste`
* [DOC] add rubric for time series detectors to estimator overview (:pr:`7389`) :user:`gavinkatz001`
* [DOC] provide proper mathematical description in docstring of sliding window splitter. (:pr:`7376`) :user:`keitaVigano`
* [DOC] add detector tags to estimator overview, fix API reference (:pr:`7473`) :user:`fkiraly`
* [DOC] improve formatting of forecasting metrics (:pr:`7474`) :user:`fkiraly`

Maintenance
~~~~~~~~~~~

* [MNT] allow ``optuna<4.2`` and test 3.13 support (:pr:`7384`) :user:`fkiraly`
* [MNT] ``detection`` module - move CI from ``annotation`` module (:pr:`7456`) :user:`fkiraly`
* [MNT] updating versions of pre-commit hooks (:pr:`7461`) :user:`yarnabrina`
* [MNT] [Dependabot](deps): Update ``dask`` requirement from ``<2024.8.1`` to ``<2024.11.3`` (:pr:`7387`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update ``pytest-randomly`` requirement from ``<3.16,>=3.15`` to ``>=3.15,<3.17`` (:pr:`7338`) :user:`dependabot[bot]`

Fixes
~~~~~

Forecasting
^^^^^^^^^^^

* [BUG] rectify ``ignores-exogeneous-X`` tag value in ``Croston`` (:pr:`7404`) :user:`yarnabrina`

Time series anomalies, changepoints, segmentation
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] fix ``BaseDetector`` methods for case of no points detected (:pr:`7439`) :user:`fkiraly`
* [BUG] ensure ``BaseDetector.transform`` uses ``iloc`` indexing (:pr:`7444`) :user:`fkiraly`
* [BUG] fix ``BaseDetector.change_points_to_segments`` (:pr:`7452`) :user:`fkiraly`

Time series classification
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] fix input shape in ``CNTCClassifier`` and ``CNTCRegressor`` (:pr:`7269`) :user:`sanskarmodi8`

Time series clustering
^^^^^^^^^^^^^^^^^^^^^^

* [BUG] fix input shape in ``CNTCClassifier`` (:pr:`7269`) :user:`sanskarmodi8`

Time series regression
^^^^^^^^^^^^^^^^^^^^^^

* [BUG] fix input shape in ``CNTCRegressor`` (:pr:`7269`) :user:`sanskarmodi8`

Test framework
^^^^^^^^^^^^^^

* [BUG] fix ``check_estimator`` test in case of failure (:pr:`7430`) :user:`fkiraly`

Contributors
~~~~~~~~~~~~

:user:`Akhsuna07`,
:user:`Alex-JG3`,
:user:`alyssadsouza`,
:user:`Dehelaan`,
:user:`ericjb`,
:user:`fkiraly`,
:user:`gavinkatz001`,
:user:`geetu040`,
:user:`hudsonhoch`,
:user:`jgyfutub`,
:user:`julian-fong`,
:user:`jusssch`,
:user:`keitaVigano`,
:user:`liya-zhu`,
:user:`manolotis`,
:user:`MarkusSagen`,
:user:`medha-14`,
:user:`mjste`,
:user:`pranavvp16`,
:user:`sanskarmodi8`,
:user:`ShivamJ07`,
:user:`Sohaib-Ahmed21`,
:user:`SSROCKS30`,
:user:`tajir0`,
:user:`talat-khattatov`,
:user:`vagechirkov`,
:user:`VectorNd`,
:user:`yarnabrina`

Version 0.34.0 - 2024-10-19
---------------------------

Maintenance release:

* full support for ``python 3.13``
* scheduled deprecations and change actions.

For last non-maintenance content updates, see 0.33.2.

Dependency changes
~~~~~~~~~~~~~~~~~~

* ``numpy`` bounds have been updated to ``>=1.21,<2.2``
* ``scikit-base`` bounds have been updated to ``>=0.6.1,<0.12.0``
* ``holidays`` (transformations soft dependency) bounds have been updated to ``>=0.29,<0.59``

Deprecations and removals
~~~~~~~~~~~~~~~~~~~~~~~~~

* The ``annotation`` module will be renamed to ``detection``, starting with 0.34.0.
  Until a future release not earlier than 0.37.0 or 1.0.0, the module will be available
  under both names to ensure downwards compatibility of imports.
* The ``annotation`` soft dependency set will be renamed to ``detection``.
  The ``annotation`` soft dependency set will be available until a future release
  not earlier than 0.37.0 or 1.0.0,
  to ensure downwards compatibility of imports.

Maintenance
~~~~~~~~~~~

* [MNT] python 3.13 support in ``pyproject.toml`` and CI (:pr:`7198`) :user:`fkiraly`
* [MNT] disable ``numpy<2`` bound for ``prophet`` (:pr:`6740`) :user:`fkiraly`
* [MNT] 0.34.0 deprecations and change actions (:pr:`7302`) :user:`fkiraly`
* [MNT] prepare rename ``annotation`` module to ``detection`` - mapped imports (:pr:`7294`) :user:`fkiraly`
* [MNT] deduplicate ``sktime`` and ``skbase`` ``BaseEstimator`` (:pr:`7213`) :user:`fkiraly`
* [MNT] [Dependabot](deps): Update numpy requirement from ``<2.1,>=1.21`` to ``>=1.21,<2.2`` (:pr:`7103`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update scikit-base requirement from ``<0.9.0,>=0.6.1`` to ``>=0.6.1,<0.12.0`` (:pr:`7238`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update holidays requirement from ``<0.55,>=0.29`` to ``>=0.29,<0.59`` (:pr:`7308`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update sphinx-issues requirement from ``<5.0.0`` to ``<6.0.0`` (:pr:`7307`) :user:`dependabot[bot]`

Documentation
~~~~~~~~~~~~~

* [DOC] replace documentation references to "annotation" with "detection" (:pr:`7299`) :user:`fkiraly`
* [DOC] change imports in detection tutorial to ``detection`` module (:pr:`7306`) :user:`fkiraly`


Version 0.33.2 - 2024-10-17
---------------------------

Highlights
~~~~~~~~~~

* new forecaster: interface to Chronos (zero-shot) foundation model forecaster (:pr:`7001`) :user:`Z-Fran`, :user:`geetu040`, :user:`benHeid`, :user:`rigvedmanoj`
* new classifiers: GRU-based time series classifiers (:pr:`6952`) :user:`fnhirwa`
* new transformer: temporal radial basis function features (:pr:`7261`) :user:`phoeenniixx`
* new ``ExpandingSlidingWindowSplitter``, switching from expanding window to sliding window at cutoff point (:pr:`7193`) :user:`MarkusSagen`
* ``pytorch-forecasting`` and ``neuralforecast`` models now provide probabilistic forecasts for global forecasting (:pr:`6628`, :pr:`6666`) :user:`XinyuWuu`
* ``PolynomialTrendForecaster`` now can make probabilistic forecasts (:pr:`6424`) :user:`ericjb`
* ``TimesFMForecaster`` now allows to select the source package, and zero-shot usage has been memory optimized (:pr:`7204`, :pr:`7212`) :user:`Prtm2110`, :user:`fkiraly`

Dependency changes
~~~~~~~~~~~~~~~~~~

* ``skpro`` (forecasting soft dependency) bounds have been updated to ``>=2,<2.8.0``
* ``u8darts`` (forecasting soft dependency) bounds have been updated to ``>=0.29.0,<0.32.0``
* ``dask`` (data container and parallelization back-end soft dependency) bounds have been updated to ``<2024.10.1``

Core interface changes
~~~~~~~~~~~~~~~~~~~~~~

Performance metrics for probabilistic forecasting, for interval and quantile returns,
can now optionally be constructed with an ``alpha`` (quantile forecasts) or ``coverage`` (interval forecasts) parameter,
for example ``EmpiricalCoverage(coverage=0.7)`` for "empirical coverage at nominal interval coverage 70 percent".

These are for use with benchmarking or tuning interfaces, where a metric is provided,
but ``predict_interval`` or ``predict_quantiles`` are not explicitly called.

In such a case, the parameter of the metric will be used by the tuner or benchmark utility to
tune with the metric at that quantile ``alpha`` or interval ``coverage``.

For example, ``ForecastingGridSearchCV(fcst, cv, scoring=PinballLoss(alpha=[0.3, 0.7]))``,
to tune the forecaster ``fcst`` scored by the pinball loss at quantiles 0.3 and 0.7.

Enhancements
~~~~~~~~~~~~

BaseObject and base framework
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] version tag for objects and estimators (:pr:`3629`) :user:`fkiraly`
* [ENH] add test that html repr of objects does not crash (:pr:`7151`) :user:`fkiraly`
* [ENH] decorators for singleton and multiton oop pattern (:pr:`7203`) :user:`fkiraly`

Benchmarking, Metrics, Splitters
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] ``ExpandingSlidingWindowSplitter``, switching from expanding window to sliding window at cutoff point (:pr:`7193`) :user:`MarkusSagen`
* [ENH] added ``coverage`` parameter to all metrics of ``pred_interval`` type (:pr:`7278`) :user:`talat-khattatov`

Data types, checks, conversions
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] refactor ``datatypes`` module to ``scikit-base`` classes and data records (:pr:`7161`) :user:`fkiraly`
* [ENH] Fix polars ``PerformanceWarning`` when object is of type ``polars.LazyFrame`` (:pr:`7221`) :user:`shivanshsinghal-22`

Forecasting
^^^^^^^^^^^

* [ENH] Added method ``predict_interval`` to ``PolynomialTrendForecaster`` (:pr:`6424`) :user:`ericjb`
* [ENH] Quantile Forecast for ``pytorch-forecasting`` Models with Global Forecast API (:pr:`6628`) :user:`XinyuWuu`
* [ENH] Global Forecast API for ``NeuralForecast`` interface (:pr:`6666`) :user:`XinyuWuu`
* [ENH] testing global forecasters: reduces number of obs in ``_make_hierarchical`` for test data generation to ensure shorter runtimes (:pr:`6948`) :user:`julian-fong`
* [ENH] interface to Chronos (zero-shot) foundation model forecaster (:pr:`7001`) :user:`Z-Fran`, :user:`geetu040`, :user:`benHeid`, :user:`rigvedmanoj`
* [ENH] Added ``get_test_params`` in ``ThetaLinesTransformer``  (:pr:`7199`) :user:`Anuragwagh`
* [ENH] cached ``timesfm`` instance in case of repeated use (:pr:`7204`) :user:`fkiraly`
* [ENH] refactor probabilistic prediction default dispatching logic to mixin class (:pr:`7230`) :user:`fkiraly`
* [ENH] ``TimesFMForecaster`` dependencies now depends on ``use_source_package`` (:pr:`7212`) :user:`Prtm2110`
* [ENH] python 3.13 compatibility - ``SquaringResiduals`` (:pr:`7244`) :user:`fkiraly`

Registry and search
^^^^^^^^^^^^^^^^^^^

* [ENH] python 3.13 compatibility - ``craft`` (:pr:`7251`) :user:`fkiraly`

Time series classification
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] GRU-based time series classifiers (:pr:`6952`) :user:`fnhirwa`

Transformations
^^^^^^^^^^^^^^^

* [ENH] ``HOG1D`` Transformer add new test parameter set to ``get_test_params`` (:pr:`7183`) :user:`Humorloos`
* [ENH] Added second parameters example to ``get_test_params`` of ``Filter`` (:pr:`7178`) :user:`KarlKolibri`
* [ENH] temporal radial basis function feature transformer (:pr:`7261`) :user:`phoeenniixx`

Test framework
^^^^^^^^^^^^^^

* [ENH] ``get_test_params`` cases in composites conditional on soft dependencies to use ``_check_estimator_deps`` (:pr:`7225`) :user:`shivanshsinghal-22`

Documentation
~~~~~~~~~~~~~

* [DOC] Added reference of  ``load-tecator``  (:pr:`7171`) :user:`vedantag17`
* [DOC] Add example to ``HOG1DTransformer`` (:pr:`7180`) :user:`Humorloos`
* [DOC] add docstring example for ``PaddingTransformer`` (:pr:`7179`) :user:`jan-mue`
* [DOC] Added docstring example for ``HurstExponentTransformer`` (:pr:`7185`) :user:`Dehelaan`
* [DOC] add docstring example to ``Filter`` transformer (:pr:`7175`) :user:`fkiraly`
* [DOC] clearer install instructions (:pr:`7206`) :user:`fkiraly`
* [DOC] Added MOIRAIforecaster to the API docs, create new section on pretrained FM (:pr:`7223`) :user:`Dehelaan`
* [DOC] improved docstrings for k-nearest neighbours classifier and regressor (:pr:`7241`) :user:`fkiraly`
* [DOC] ``SlidingWindowSplitter`` - proper mathematical description (:pr:`7195`) :user:`fkiraly`
* [DOC] anomaly and changepoint detection notebook from ODSC 2024 (:pr:`7284`) :user:`alex-jg3`, :user:`fkiraly`
* [DOC] Fixes Time Series Segmentation with sktime and ClaSP notebook example (:pr:`7283`) :user:`RobotPsychologist`
* [DOC] Fixed minor grammatical errors in README.md (:pr:`7262`) :user:`Smoothengineer`
* [DOC] added missing import statements in ReverseAugmenter docstring example (:pr:`7265`) :user:`sanskarmodi8`
* [DOC] clarify how ``fh`` in forecasting methods is interpreted (:pr:`7227`) :user:`ericjb`

Maintenance
~~~~~~~~~~~

* [MNT] Removes coverage upload steps from CI (:pr:`7012`) :user:`Prtm2110`
* [MNT] [Dependabot](deps): Update ``skpro`` requirement from ``<2.6.0,>=2`` to ``>=2,<2.8.0`` (:pr:`7245`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update ``sphinx-gallery`` requirement from ``<0.18.0`` to ``<0.19.0`` (:pr:`7264`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update ``u8darts`` requirement from ``<0.31,>=0.29.0`` to ``>=0.29.0,<0.32`` (:pr:`7272`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update ``dask`` requirement from ``<2024.8.1`` to ``<2024.10.1`` (:pr:`7292`) :user:`dependabot[bot]`

Fixes
~~~~~

Benchmarking, Metrics, Splitters
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] Fix ``ExpandingCutoffSplitter`` when ``step_length > 1`` (:pr:`7290`) :user:`ninedigits`

Data sets and data loaders
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] skip the test ``load_fpp3`` if ``rdata`` is not installed (:pr:`7181`) :user:`jan-mue`

Data types, checks, conversions
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] fixed ``dask.dataframe`` import error in ``dask_to_pd`` module (:pr:`7260`) :user:`sanskarmodi8`

Forecasting
^^^^^^^^^^^

* [BUG] fix ``ForecastingHorizon.to_absolute`` with multiple frequencies (:pr:`7172`) :user:`tianjiqx`
* [BUG] in ``ReconcilerForecaster``, fix ``return_totals`` parameter for all strategies (:pr:`7208`) :user:`SaiRevanth25`
* [BUG] Fix ``DartsLinearRegression`` failing instead of giving a warning (:pr:`7235`) :user:`fnhirwa`
* [BUG] Fix ``Prophet`` not tagged as ``handles-missing-data`` (:pr:`7267`) :user:`Garve`
* [BUG] fix singular matrices in ``test_reconcilerforecaster_return_totals`` (:pr:`7293`) :user:`fkiraly`

Contributors
~~~~~~~~~~~~

:user:`alex-jg3`,
:user:`Anuragwagh`,
:user:`benHeid`,
:user:`Dehelaan`,
:user:`ericjb`,
:user:`fkiraly`,
:user:`fnhirwa`,
:user:`Garve`,
:user:`geetu040`,
:user:`Humorloos`,
:user:`jan-mue`,
:user:`julian-fong`,
:user:`KarlKolibri`,
:user:`MarkusSagen`,
:user:`ninedigits`,
:user:`phoeenniixx`,
:user:`Prtm2110`,
:user:`RobotPsychologist`,
:user:`rigvedmanoj`,
:user:`SaiRevanth25`,
:user:`sanskarmodi8`,
:user:`shivanshsinghal-22`,
:user:`Smoothengineer`,
:user:`talat-khattatov`,
:user:`tianjiqx`,
:user:`vedantag17`,
:user:`XinyuWuu`,
:user:`Z-Fran`


Version 0.33.1 - 2024-09-26
---------------------------

Small feature release for showcase at pydata Paris.

Highlights
~~~~~~~~~~

* interface for MOIRAI foundation model (:pr:`6746`) :user:`pranavvp16`, :user:`benHeid`
* ``GroupbyCategoryForecaster`` for applying panel forecasting by category or segment (:pr:`7066`) :user:`felipeangelimvieira`
* In ``ReconcilerForecaster``, users can now choose to return a dataframe without ``__total`` (:pr:`7127`) :user:`SaiRevanth25`
* time series segmentation via clustering (:pr:`6782`) :user:`ankit-1204`
* logger transformer for logging pipeline inputs and outputs (:pr:`7074`) :user:`fkiraly`

Dependency changes
~~~~~~~~~~~~~~~~~~

* ``optuna`` (hyperparameter optimization soft dependency) bounds have been updated to ``<4.1``
* ``mne`` (transformations soft dependency) bounds have been updated to ``>=1.5,<1.9``

Enhancements
~~~~~~~~~~~~

BaseObject and base framework
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] ``is_scitype`` utility for scitype checking, improve support of estimators with multiple object types (:pr:`7143`) :user:`benHeid`

Data types, checks, conversions
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] Hierarchical scitype support for ``polars`` (:pr:`6697`) :user:`pranavvp16`
* [ENH] refactor ``datatypes`` example fixtures to ``BaseObject`` classes (:pr:`7133`) :user:`fkiraly`

Forecasting
^^^^^^^^^^^

* [ENH] Add interface for MOIRAI foundation model (:pr:`6746`) :user:`pranavvp16`, :user:`benHeid`
* [ENH] ``ThetaForecaster`` - add one more parameter set (:pr:`7055`) :user:`fkiraly`
* [ENH] ``GroupbyCategoryForecaster`` for applying panel forecasting by category or segment (:pr:`7066`) :user:`felipeangelimvieira`
* [ENH] Adding a parameter to ``ReconcilerForecaster`` to return a dataframe without the dunder levels (:pr:`7127`) :user:`SaiRevanth25`
* [ENH] add ``_predict_var`` in ``test_pred_int_tag`` (:pr:`7154`) :user:`fkiraly`

Registry and search
^^^^^^^^^^^^^^^^^^^

* [ENH] retrieval utilities for all functions or classes in a module (:pr:`7089`) :user:`fkiraly`

Time series anomalies, changepoints, segmentation
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] time series segmentation via clustering (:pr:`6782`) :user:`ankit-1204`

Transformations
^^^^^^^^^^^^^^^

* [ENH] logger transformer for logging pipeline inputs and outputs (:pr:`7074`) :user:`fkiraly`

Documentation
~~~~~~~~~~~~~

* [DOC] correct incorrect bounds mentioned in 0.33.0 changelog (:pr:`7114`) :user:`fkiraly`
* [DOC] Added a docstring example to TimeSeriesKernelKMeans (:pr:`7124`) :user:`Saptarshi-Bandopadhyay`
* [DOC] update core developers on team page, formatting (:pr:`7140`) :user:`fkiraly`
* [DOC] minor documentation fixes (:pr:`7141`) :user:`fkiraly`
* [DOC] add quicklinks at top of README box (:pr:`7159`) :user:`fkiraly`
* [DOC] remove 2024 elections registration news item (:pr:`7158`) :user:`fkiraly`
* [DOC] remove references to ``nested_univ`` from extension templates (:pr:`7058`) :user:`fkiraly`

Maintenance
~~~~~~~~~~~

* [MNT] Updating pre-commit hooks and corresponding changes (:pr:`7109`) :user:`yarnabrina`
* [MNT] [Dependabot](deps): Update ``optuna`` requirement from ``<3.7`` to ``<4.1`` (:pr:`7104`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update ``mne`` requirement from ``<1.8,>=1.5`` to ``>=1.5,<1.9`` (:pr:`7129`) :user:`dependabot[bot]`
* [MNT] temporarily skip ``temporian`` related failure of ``test_complex_function`` until #7040 is resolved (:pr:`7147`) :user:`fkiraly`
* [MNT] fix FPP3 download link (:pr:`7164`) :user:`fkiraly`, :user:`ericjb`
* [MNT] bound ``SignatureTransformer`` to ``numpy<2`` (:pr:`7163`) :user:`fkiraly`
* [MNT] remove ptf install from example notebooks (:pr:`7165`) :user:`XinyuWuu`
* [MNT] remove python version bound from ``pytorch-forecasting`` based estimators (:pr:`7102`) :user:`fkiraly`

Fixes
~~~~~

Forecasting
^^^^^^^^^^^

* [BUG] Fix pykan forecaster (:pr:`7150`) :user:`benHeid`
* [BUG] fix probabilistic forecasts if only ``_predict_var`` is implemented (:pr:`7153`) :user:`fkiraly`

Transformations
^^^^^^^^^^^^^^^

* [BUG] fix ``drop_na`` and update mode of ``Differencer`` transformation (:pr:`7115`) :user:`fkiraly`
Test framework

Contributors
~~~~~~~~~~~~

:user:`ankit-1204`,
:user:`benHeid`,
:user:`ericjb`,
:user:`fkiraly`,
:user:`pranavvp16`,
:user:`SaiRevanth25`,
:user:`Saptarshi-Bandopadhyay`,
:user:`XinyuWuu`,
:user:`yarnabrina`


Version 0.33.0 - 2024-09-09
---------------------------

Maintenance release, with scheduled deprecations and change actions.

For last non-maintenance content updates, see 0.32.4 and 0.32.2.

Dependency changes
~~~~~~~~~~~~~~~~~~

* ``scikit-base`` (core dependency) bounds have been updated to ``>=0.6.1,<0.10.0``
* ``holidays`` (transformations soft dependency) bounds have been updated to ``>=0.29,<0.57``
* ``pykan`` (deep learning soft dependency) bounds have been updated to ``>=0.2,<0.2.7``
* ``mne`` (transformations soft dependency) bounds have been updated to ``>=1.5,<1.9``
* ``dask`` (data container and parallelization back-end soft dependency) bounds have been updated to ``<2024.8.3``
* ``pytorch-forecasting`` (forecasting soft dependency) bounds have been updated to ``>=1.0.0,<1.2.0``

Deprecations and removals
~~~~~~~~~~~~~~~~~~~~~~~~~

* in ``DirectReductionForecaster`` the default for ``windows_identical`` has changed
  to ``False``.

Maintenance
~~~~~~~~~~~

* [MNT] Try to reduce load for the runners (:pr:`7061`) :user:`benHeid`
* [MNT] 0.33.0 deprecations and change actions (:pr:`7091`) :user:`fkiraly`
* [MNT] ffp3 datasets URLs changed on CRAN; updated ``_fpp3_loaders.py`` accordingly (:pr:`7084`) :user:`ericjb`
* [MNT] remove <3.11 restriction for ``pytorch-forecasting``, add upper bound (:pr:`7092`) :user:`fkiraly`
* [MNT] [Dependabot](deps): Update ``dask`` requirement from ``<2024.8.2`` to ``<2024.8.3`` (:pr:`7062`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update ``numpy`` requirement from ``<2.1,>=1.21`` to ``>=1.21,<2.2`` (:pr:`7007`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update ``scikit-base`` requirement from ``<0.9.0,>=0.6.1`` to ``>=0.6.1,<0.10.0`` (:pr:`7035`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update ``holidays`` requirement from ``<0.56,>=0.29`` to ``>=0.29,<0.57`` (:pr:`7096`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update ``pykan`` requirement from ``<0.2.2,>=0.2`` to ``>=0.2,<0.2.7`` (:pr:`7010`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update ``mne`` requirement from ``<1.8,>=1.5`` to ``>=1.5,<1.9`` (:pr:`7004`) :user:`dependabot[bot]`

Documentation
~~~~~~~~~~~~~

* [DOC] Adds :user:`SaiRevanth25`` contributions to all-contributors file (:pr:`7085`) :user:`SaiRevanth25`
* [DOC] fix typo and formatting in installation docs (:pr:`7060`) :user:`Saptarshi-Bandopadhyay`

Enhancements
~~~~~~~~~~~~

* [ENH] change ``test_inheritance`` to be more lenient to framework level extensions (:pr:`7067`) :user:`fkiraly`

Contributors
~~~~~~~~~~~~

:user:`benHeid`,
:user:`ericjb`,
:user:`fkiraly`,
:user:`SaiRevanth25`,
:user:`Saptarshi-Bandopadhyay`


Version 0.32.4 - 2024-09-06
---------------------------

Small feature and fix release for:

* colab compatibility, hotfix for ``polars`` dependency incompatibility
* compatibility with ``skchange`` 2nd party integration
* improvements to the anomalies, changepoints, segmentation framework
* documentation update related to upcoming ``sktime`` elections

Core interface changes
~~~~~~~~~~~~~~~~~~~~~~

* A scitype adaptation framework is introduced, allowing use of an estimator of one type in
  a slot for another, via type coercion. The coercion framework covers ``sklearn``, ``skpro``, and ``sktime`` estimators
  currently, and is extensible. A user and developer shorthand for such coercion is provided
  as the ``registry.coerce_scitype`` function, which dispatches to individual coercion mechanisms.
* Time series clusterers that produce a cluster assignment can be coerced to transformations,
  enabling their use in any pipeline slot for transformations.
* Anomaly and changepoint detectors can now be pipelined with transformations, resulting in a detector.
  Dunder concatenation ``transformer * detector`` will default to this.
* Anomaly and changepoint detectors can be coerced to transformations, enabling their use in any
  pipeline slot for transformations.

Enhancements
~~~~~~~~~~~~

BaseObject and base framework
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] decouple registry from base modules, scitype specific data records for documentation of estimator types  (:pr:`6998`) :user:`fkiraly`
* [ENH] scitype coercion and checking utility (:pr:`6969`) :user:`fkiraly`

Time series anomalies, changepoints, segmentation
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] Add padded f1 score for evaluating change point detection algorithms (:pr:`7034`) :user:`Alex-JG3`
* [ENH] improvements to ``BaseSeriesAnnotator`` base class for anomaly, changepoint, segments (:pr:`7073`) :user:`fkiraly`
* [ENH] pipeline for anomaly, changepoint detectors and segmenters (:pr:`7071`) :user:`fkiraly`
* [ENH] coercion to use time series anomaly, changepoint detectors as transformers (:pr:`7072`) :user:`fkiraly`

Time series clustering
^^^^^^^^^^^^^^^^^^^^^^

* [ENH] enable use of clusterers as transformations, enable ``TransformSelectForecaster`` use of clusterers for group selection (:pr:`7068`) :user:`fkiraly`

Transformations
^^^^^^^^^^^^^^^

* [ENH] Hurst exponent feature extraction transformer (:pr:`7065`) :user:`phoeenniixx`

Documentation
~~~~~~~~~~~~~

* [DOC] Add SVG version of the sktime logo with no text  (:pr:`7024`) :user:`wirrywoo`
* [DOC] Improve documentation for ``TinyTimeMixer`` (:pr:`7009`) :user:`geetu040`
* [DOC] fix broken links in continuous integration docs (:pr:`7059`) :user:`Saptarshi-Bandopadhyay`
* [DOC] split list of transformation pipeline components into subcategories (:pr:`7075`) :user:`fkiraly`

Fixes
~~~~~

* [BUG] fix ``sktime`` crash with older ``polars`` versions (:pr:`7057`) :user:`fkiraly`
* [BUG] Fix ``ForecastX.update`` when the ``forecaster_X_exogeneous`` is set to ``"complement"`` (:pr:`7041`) :user:`fnhirwa`
* [BUG] fix ``ExpandingCutoffSplitter`` for case where ``fh`` is not continuous (:pr:`7053`) :user:`ninedigits`

Contributors
~~~~~~~~~~~~

:user:`Alex-JG3`,
:user:`fkiraly`,
:user:`fnhirwa`,
:user:`geetu040`,
:user:`ninedigits`,
:user:`phoeenniixx`,
:user:`Saptarshi-Bandopadhyay`,
:user:`wirrywoo`

Version 0.32.3 - 2024-08-27
---------------------------

Hotfix release with bugfix for html representation of forecasting pipelines.

For last non-maintenance content updates, see 0.32.2.

Contents
~~~~~~~~

* [BUG] fix html display for ``TransformedTargetForecaster`` and ``ForecastingPipeline``

Version 0.32.2 - 2024-08-26
---------------------------

Highlights
~~~~~~~~~~

* ``HierarchicalProphet`` forecaster from ``prophetverse`` (:pr:`7028`) :user:`felipeangelimvieira`
* Regularized VAR reduction forecaster, ``VARReduce`` (:pr:`6725`) :user:`meraldoantonio`
* Interface to TimesFM Forecaster (:pr:`6571`) :user:`geetu040`
* Subsequence Extraction Transformer (:pr:`6967`) :user:`wirrywoo`
* Framework support for categorical data has been extended to transformers and pipelines (:pr:`6924`) :user:`Abhay-Lejith`
* Clusterer tags for capability to assign cluster centers (:pr:`7018`) :user:`fkiraly`

Dependency changes
~~~~~~~~~~~~~~~~~~

* ``holiday`` (transformations soft dependency) bounds have been updated to ``>=0.29,<0.56``
* ``dask`` (data container and parallelization back-end) bounds have been updated to ``<2024.8.2``

Core interface changes
~~~~~~~~~~~~~~~~~~~~~~

New tags for clusterers have been added to characterize capabilities
to assign cluster centers. The following boolean tags have been added:

* ``capability:predict``, whether the clusterer can assign cluster labels via ``predict``
* ``capability:predict_proba``, for probabilistic cluster assignment
* ``capability:out_of_sample``, for out-of-sample cluster assignment.
  If False, the clusterer can only assign clusters to data points seen during fitting.

Enhancements
~~~~~~~~~~~~

BaseObject and base framework
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] placeholder record decorator (:pr:`7029`) :user:`fkiraly`

Data sets and data loaders
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] Hierarchical sales toydata generator from workshops (:pr:`6953`) :user:`marrov`
* [ENH] Convert the date column to a period with daily frequency in ``load_m5`` (:pr:`6990`) :user:`SaiRevanth25`

Data types, checks, conversions
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] Polars ``Series`` scitype supports  (:pr:`6485`) :user:`pranavvp16`
* [ENH] Polars ``Panel`` scitype support  (:pr:`6552`) :user:`pranavvp16`
* [ENH] Addition of ``feature_kind`` metadata attribute to ``gluonts`` datatypes (:pr:`6871`) :user:`shlok191`

Forecasting
^^^^^^^^^^^

* [ENH] interface to TimesFM Forecaster (:pr:`6571`) :user:`geetu040`
* [ENH] New regularized VAR reduction forecaster, ``VARReduce`` (:pr:`6725`) :user:`meraldoantonio`
* [ENH] Add ``HierarchicalProphet`` estimator to ``prophetverse`` module (:pr:`7028`) :user:`felipeangelimvieira`

Time series clustering
^^^^^^^^^^^^^^^^^^^^^^

* [ENH] clusterer tags for capability to assign cluster centers (:pr:`7018`) :user:`fkiraly`

Transformations
^^^^^^^^^^^^^^^

* [ENH] Extending categorical support in X to transformers and pipelines (:pr:`6924`) :user:`Abhay-Lejith`
* [ENH] Subsequence Extraction Transformer (:pr:`6967`) :user:`wirrywoo`

Documentation
~~~~~~~~~~~~~

* [DOC] minor improvements to docstring of ``Bollinger`` (bands) (:pr:`6978`) :user:`fkiraly`
* [DOC] Update ``.all-contributorsrc`` with council roles (:pr:`6962`) :user:`fkiraly`
* [DOC] update soft dependency handling guide for estimators (:pr:`7000`) :user:`fkiraly`
* [DOC] improvements to docstrings for panel tasks - time series classification, regression, clustering (:pr:`6991`) :user:`fkiraly`
* [DOC] update XinyuWuu's user name (:pr:`7030`) :user:`fkiraly`
* [DOC] fixes to ``TransformedTargetForecaster`` docstring (:pr:`7002`) :user:`fkiraly`
* [DOC] update intro notebook with material from ISF and EuroSciPy 2024 (:pr:`7013`) :user:`fkiraly`
* [DOC] Fix docstring for ``ExpandingCutoffSplitter`` (:pr:`7033`) :user:`ninedigits`
* [DOC] fix incorrect import in ``EnbPIForecaster`` docstring (:pr:`7015`) :user:`fkiraly`

Maintenance
~~~~~~~~~~~

* [MNT] Refactor ``show_versions`` to use ``dependencies`` module (:pr:`6883`) :user:`fkiraly`
* [MNT] sync changelog with hotfix branch ``anirban-sktime-0.31.2`` (:pr:`6963`) :user:`yarnabrina`
* [MNT] add ``numpy 2`` incompatibility flag to ``pmdarima`` dependency (:pr:`6974`) :user:`fkiraly`
* [MNT] decorate ``test_auto_arima`` with ``numpy 2`` skip until final fix/diagnosis (:pr:`6973`) :user:`fkiraly`
* [MNT] remove ``tsbootstrap`` dependency from public dependency sets (:pr:`6966`) :user:`fkiraly`
* [MNT] rename base class ``TimeSeriesLloyds`` to ``BaseTimeSeriesLloyds`` (:pr:`6992`) :user:`fkiraly`
* [MNT] remove module level ``numba`` import warnings (:pr:`6999`) :user:`fkiraly`
* [MNT] ``esig`` based estimators: add ``numpy<2`` bound (:pr:`7036`) :user:`fkiraly`
* [MNT] [Dependabot](deps): Bump ``tj-actions/changed-files`` from 44 to 45 (:pr:`7019`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update ``holidays`` requirement from ``<0.55,>=0.29`` to ``>=0.29,<0.56`` (:pr:`7006`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update ``dask`` requirement from ``<2024.8.1`` to ``<2024.8.2`` (:pr:`7005`) :user:`dependabot[bot]`

Fixes
~~~~~

BaseObject and base framework
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] fix ``test_softdep_error`` dependency handling check if environment marker tag is not satisfied (:pr:`6961`) :user:`fkiraly`
* [BUG] fix dependency checkers in case of multiple distributions available in environment, e.g., on databricks (:pr:`6986`) :user:`fkiraly`, :user:`toandaominh1997`

Benchmarking and Metrics
^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] Fix ``ForecastingBenchmark`` giving an error when the dataloader returns the tuple (y, X) (:pr:`6971`) :user:`SaiRevanth25`

Data sets and data loaders
^^^^^^^^^^^^^^^^^^^^^^^^^^

Data types, checks, conversions
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] Fix ``nested_univ`` converter inconsistent handling of index level names (:pr:`7026`) :user:`pranavvp16`

Forecasting
^^^^^^^^^^^

* [BUG] ``TinyTimeMixerForecaster``: fix truncating index and update ``test_params`` (:pr:`6965`) :user:`geetu040`
* [BUG] Do not add season condition names as extra regressors in Prophet (:pr:`6988`) :user:`wpdonders`
* [BUG] Fix ``Prophet`` ``_get_fitted_params ``error when the timeseries is constant (:pr:`7011`) :user:`felipeangelimvieira`

Contributors
~~~~~~~~~~~~

:user:`Abhay-Lejith`,
:user:`felipeangelimvieira`,
:user:`fkiraly`,
:user:`geetu040`,
:user:`marrov`,
:user:`meraldoantonio`,
:user:`ninedigits`,
:user:`pranavvp16`,
:user:`SaiRevanth25`,
:user:`shlok191`,
:user:`toandaominh1997`,
:user:`wirrywoo`,
:user:`wpdonders`,
:user:`yarnabrina`


Version 0.32.1 - 2024-08-12
---------------------------

Hotfix release for using ``make_reduction`` with not fully ``sklearn`` compliant
tabular regressors such as from ``catboost``.

For last non-maintenance content updates, see 0.31.1.

Contents
~~~~~~~~

* [BUG] fix ``make_reduction`` type inference for non-sklearn estimators


Version 0.32.0 - 2024-08-11
---------------------------

Maintenance release, with scheduled deprecations and change actions.

For last non-maintenance content updates, see 0.31.1.

Dependency changes
~~~~~~~~~~~~~~~~~~

* ``skpro`` (soft dependency) bounds have been updated to ``>=2,<2.6.0``
* ``skforecast`` (forecasting soft dependency) bounds have been updated to ``<0.14.0``.

Core interface changes
~~~~~~~~~~~~~~~~~~~~~~

* all ``sktime`` estimators and objects are now required to have at least
  two test parameter sets in
  ``get_test_params`` to be compliant with ``check_estimator`` contract tests.
  This requirement was previously stated in the extension template but not enforced.
  It is now also included in the automated tests via ``check_estimator``.
  Estimators without (unreserved) parameters, i.e., where two
  distinct parameter sets are not possible, are excepted from this.

Deprecations and removals
~~~~~~~~~~~~~~~~~~~~~~~~~

* From ``sktime 0.38.0``, forecasters' ``predict_proba`` will
  require ``skpro`` to be present in the python environment,
  for distribution objects to represent distributional forecasts.
  Until ``sktime 0.35.0``, ``predict_proba`` will continue working without ``skpro``,
  defaulting to return objects in ``sktime.proba`` if ``skpro`` is not present.
  From ``sktime 0.35.0``, an error will be raised upon call of
  forecaster ``predict_proba`` if ``skpro`` is not present
  in the environment.
  Users of forecasters' ``predict_proba`` should ensure
  that ``skpro`` is installed in the environment.

* The probability distributions module ``sktime.proba`` deprecated and will
  be fully replaced by ``skpro`` in ``sktime 0.38.0``.
  Until ``sktime 0.38.0``, imports from ``sktime.proba`` will continue working,
  defaulting to ``sktime.proba`` if ``skpro`` is not present,
  otherwise redirecting imports to ``skpro`` objects.
  From ``sktime 0.35.0``, an error will be raised if ``skpro`` is not present
  in the environment, otherwise imports are redirected to ``skpro``.
  Direct or indirect users of ``sktime.proba`` should ensure ``skpro`` is
  installed in the environment.
  Direct users of the ``sktime.proba`` module should,
  in addition, replace any imports from
  ``sktime.proba`` with imports from ``skpro.distributions``.

Contents
~~~~~~~~

* [MNT] 0.32.0 deprecations and change actions (:pr:`6916`) :user:`fkiraly`
* [MNT] [Dependabot](deps): Update ``skpro`` requirement from ``<2.5.0,>=2`` to ``>=2,<2.6.0`` (:pr:`6897`) :user:`dependabot[bot]`
* [MNT] remove ``numpy 2`` incompatibility flag from ``numba`` based estimators (:pr:`6915`) :user:`fkiraly`
* [MNT] isolate ``joblib`` (:pr:`6385`) :user:`fkiraly`
* [MNT] handle more ``pandas`` deprecations (:pr:`6941`) :user:`fkiraly`
* [MNT] deprecation of ``proba`` module in favour of ``skpro`` soft dependency (:pr:`6940`) :user:`fkiraly`
* [MNT] update versions of ``pre-commit`` hooks (:pr:`6947`) :user:`yarnabrina`
* [MNT] 0.32.0 release action - revert temporary skip ``get_test_params`` number check for 0.21.1 and 0.22.0 release (:pr:`5114`) :user:`fkiraly`
* [MNT] Bump ``skforecast`` to ``0.13`` version allowing support for python ``3.12`` (:pr:`6946`) :user:`yarnabrina`
* [BUG] Fix ``Xt_msg`` type in ``transformations.base`` (:pr:`6944`) :user:`hliebert`

Contributors
~~~~~~~~~~~~

:user:`fkiraly`,
:user:`hliebert`,
:user:`yarnabrina`


Version 0.31.2 - 2024-08-13
---------------------------

Hotfix release, released after hotfix release 0.32.1,
to apply the same hotfix to 0.31.X versions as well.

Hotfix for using ``make_reduction`` with not fully ``sklearn`` compliant
tabular regressors such as from ``catboost``.

For last non-maintenance content updates, see 0.31.1.

Contents
~~~~~~~~

* [BUG] fix ``make_reduction`` type inference for non-sklearn estimators

Notes
^^^^^

This is a hotfix for 0.31.1 release, fixing a regression. This release is not contained
in the 0.32.0 or 0.32.1 releases.


Version 0.31.1 - 2024-08-10
---------------------------

Highlights
~~~~~~~~~~

* html representation of objects now has a button linking to documentation page (:pr:`6876`) :user:`mateuszkasprowicz`
* interface to TinyTimeMixer foundation model (:pr:`6712`) :user:`geetu040`
* interface to ``autots`` ensemble (:pr:`5948`) :user:`MBristle`
* interface to  ``darts`` reduction models (:pr:`6712`) :user:`fnhirwa`, :user:`yarnabrina`
* ``LTSFTransformer`` based on ``cure-lab`` research code base (:pr:`6202`) :user:`geetu040`
* MVTS transformer classifier (:pr:`6791`) :user:`geetu040`
* forecasters can now support categorical ``X``, as per tag (:pr:`6704`, :pr:`6732`) :user:`Abhay-Lejith`
* ``DirectReductionForecaster`` now has a ``windows_identical`` option (:pr:`6650`) :user:`hliebert`
* ``ForecastingOptunaSearchCV`` can now be passed custom samplers and "higher is better" scores (:pr:`6823`, :pr:`6846`) :user:`bastisar`, :user:`gareth-brown-86`, :user:`mk406`

Dependency changes
~~~~~~~~~~~~~~~~~~

* ``holiday`` (transformations soft dependency) bounds have been updated to ``>=0.29,<0.54``
* ``dask`` (data container and parallelization back-end) bounds have been updated to ``<2024.8.1``

Core interface changes
~~~~~~~~~~~~~~~~~~~~~~

BaseObject and base framework
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* implementers no longer need to set the ``package_import_alias`` tag
  when estimator dependencies have a different import name than the PEP 440 package name.
  All internal logic now only uses the PEP 440 package name.
  There is no need to remove the tag if already set, but it is no longer required.
* estimators now have a tag ``capability:categorical_in_X: bool`` to indicate
  that the estimator can handle categorical features in the input data ``X``.
  Such estimator can be used with categorical and string-valued features
  if ``X`` is passed in one of the ``pandas`` based mtypes.
* the html representation of all objects now includes a link to the documentation
  of the object, and is now in line with the ``sklearn`` html representation.

Enhancements
~~~~~~~~~~~~

BaseObject and base framework
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] improved environment package version check (:pr:`6776`) :user:`fkiraly`
* [ENH] Remove package import alias related internal logic and tags (:pr:`6821`) :user:`fkiraly`
* [ENH] Adding tag for categorical support in ``X`` (:pr:`6704`) :user:`Abhay-Lejith`
* [ENH] Adding categorical support: Raising error in yes/no case (:pr:`6732`) :user:`Abhay-Lejith`
* [ENH] Link to docs in object's html repr (:pr:`6876`) :user:`mateuszkasprowicz`

Data sets and data loaders
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] Data Loader for M5 dataset (:pr:`6731`) :user:`SaiRevanth25`

Data types, checks, conversions
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] ``check_pdmultiindex_panel`` to return names of invalid ``object`` columns if there are any (:pr:`6797`) :user:`SaiRevanth25`
* [ENH] Allow object dtype in series (:pr:`5886`) :user:`yarnabrina`
* [ENH] converter framework tests in ``datatypes`` to cover all types, including those requiring soft dependencies (:pr:`6838`) :user:`fkiraly`
* [ENH] add missing ``feature_kind`` metadata fields to ``gluonts`` based data container checkers (:pr:`6861`) :user:`fkiraly`
* [ENH] added ``feature_kind`` metadata in datatype checks (:pr:`6490`) :user:`Abhay-Lejith`
* [ENH] Adding support for ``gluonts`` ``PandasDataset`` object (:pr:`6668`) :user:`shlok191`
* [ENH] Added support for ``gluonts`` ``PandasDataset`` as a ``Series`` scitype (:pr:`6837`) :user:`shlok191`

Forecasting
^^^^^^^^^^^

* [ENH] interface to ``autots`` ensemble (:pr:`5948`) :user:`MBristle`
* [ENH] ``darts`` Reduction Models adapter (:pr:`6712`) :user:`fnhirwa`, :user:`yarnabrina`
* [ENH] Extension Template For Global Forecasting API (:pr:`6699`) :user:`XinyuWuu`
* [ENH] enable multivariate data passed to ``autots`` interface (:pr:`6805`) :user:`fkiraly`
* [ENH] Add Sampler to ``ForecastingOptunaSearchCV`` (:pr:`6823`) :user:`bastisar`
* [ENH] Improve ``TestAllGlobalForecasters`` (:pr:`6845`) :user:`XinyuWuu`
* [ENH] Add scoring direction to ``ForecastingOptunaSearchCV`` (:pr:`6846`) :user:`gareth-brown-86`, :user:`mk406`
* [ENH] de-novo implementation of ``LTSFTransformer`` based on ``cure-lab`` research code base (:pr:`6202`) :user:`geetu040`
* [ENH] Add ``windows_identical`` to ``DirectReductionForecaster`` (:pr:`6650`) :user:`hliebert`
* [ENH] updates type inference in ``make_reduction`` to use central scitype inference and allow proba tabular regressors (:pr:`6893`) :user:`fkiraly`
* [ENH] DeepAR and NHiTS and refinements for ``pytorch-forecasting`` interface (:pr:`6551`) :user:`XinyuWuu`
* [ENH] Interface to TinyTimeMixer foundation model (:pr:`6712`) :user:`geetu040`
* [ENH] remove now superfluous try-excepts in forecasting API test suite (:pr:`6906`) :user:`fkiraly`
* [ENH] improve ``test_global_forecasting_tag`` (:pr:`6929`) :user:`geetu040`

Registry and search
^^^^^^^^^^^^^^^^^^^

* [ENH] in estimator html repr, make version retrieval safer and more flexible (:pr:`6923`) :user:`fkiraly`

Time series anomalies, changepoints, segmentation
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] time series annotation (outliers, changepoints) - test class and full ``check_estimator`` integration (:pr:`6843`) :user:`fkiraly`
* [ENH] Add Windowed Local Outlier Factor Anomaly Detector (:pr:`6524`) :user:`Alex-JG3`
* [ENH] Add binary segmentation annotator for change point detection (:pr:`6723`) :user:`Alex-JG3`

Time series classification
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] Pytorch Classifier intermediate base class for TSC (:pr:`6791`) :user:`geetu040`
* [ENH] MVTS transformer classifier (:pr:`6791`) :user:`geetu040`

Transformations
^^^^^^^^^^^^^^^

* [ENH] add second test params dict to ``Aggregator`` (:pr:`6759`) :user:`fr1ll`
* [ENH] ``pandas`` inner type and global pooling for ``TabularToSeriesAdaptor`` (:pr:`6752`) :user:`fkiraly`
* [ENH] alternative returns for ``VmdTransformer`` - mode spectra and central frequencies (:pr:`6857`) :user:`fkiraly`
* [ENH] simplify dictionaries and alias handling in ``Catch22`` (:pr:`6104`) :user:`fkiraly`
* [ENH] making ``self._is_vectorized`` access more defensive in ``BaseTransformer`` (:pr:`6863`) :user:`fkiraly`

Test framework
^^^^^^^^^^^^^^

* [ENH] make ``pyproject.toml`` parsing for differential testing more robust against non-package relevant changes (:pr:`6882`) :user:`fkiraly`

Vendor and onboard libraries
^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] Vendor fracdiff library (:pr:`6777`) :user:`DinoBektesevic`
* [ENH] improvements to vendored ``fracdiff`` library (:pr:`6912`) :user:`fkiraly`

Documentation
~~~~~~~~~~~~~

* [DOC] Notebook and Template For Global Forecasting API (:pr:`6699`) :user:`XinyuWuu`
* [DOC] Add authorship credits to ``MatrixProfileTransformer`` for Stumpy authors (:pr:`6762`) :user:`alexander-lakocy`
* [DOC] add examples to ``StatsForecastGARCH`` and ``StatsForecastARCH`` docstrings (:pr:`6761`) :user:`melinny`
* [DOC] Add alignment notebook example (:pr:`6768`) :user:`alexander-lakocy`
* [DOC] fix transformers type table in API reference in accordance with sphinx guidelines (:pr:`6771`) :user:`alexander-lakocy`
* [DOC] Modify editable install to make cross-platform (:pr:`6758`) :user:`fr1ll`
* [DOC] ``TruncationTransformer`` docstring example (:pr:`6765`) :user:`ceroper`
* [DOC] De-duplicate User Guide and Examples (closes #6767) (:pr:`6770`) :user:`alexander-lakocy`
* [DOC] improved docstring of ``DWTTransformer`` (:pr:`6764`) :user:`Mitchjkjkjk`
* [DOC] various improvements to user journey on documentation page (:pr:`6760`) :user:`fkiraly`
* [DOC] Time series k means max iter parameter docstring (:pr:`6726`) :user:`AlexeyOm`
* [DOC] cross-reference estimator search from tags API reference (:pr:`6816`) :user:`fkiraly`, :user:`yarnabrina`
* [DOC] updated docstring for ``check_is_mtype`` to match skpro ``check_is_mtype`` function (:pr:`6835`) :user:`julian-fong`
* [DOC] example & tutorial notebooks: normalize execution counts, indentation, execute all cells (:pr:`6847`) :user:`fkiraly`
* [DOC] clarify column handling in docstring of ``FourierFeatures`` (:pr:`6834`) :user:`fkiraly`
* [DOC] added fork usage recommendations (:pr:`6827`) :user:`yarnabrina`
* [DOC] change links in documentation to refer to same version (:pr:`6841`) :user:`yarnabrina`
* [DOC] minor improvements to ``check_scoring`` docstring (:pr:`6877`) :user:`fkiraly`
* [DOC] add proper author credits to 1:1 interface classes - aligners, distances, forecasters, parameter estimators (:pr:`6850`) :user:`fkiraly`
* [DOC] fix docstring formatting of ``evaluate`` (:pr:`6864`) :user:`fkiraly`
* [DOC] Add documentation for benchmarking module (:pr:`6792`) :user:`benHeid`
* [DOC] add elections link on landing page (:pr:`6910`) :user:`fkiraly`
* [DOC] Add example notebook for the graphical pipeline (:pr:`5175`) :user:`benHeid`
* [DOC] git workflow guide - chained branches, fixing header fonts (:pr:`6913`) :user:`fkiraly`

Maintenance
~~~~~~~~~~~

* [MNT] Remove ``tbats`` python version constraint (:pr:`6769`) :user:`fr1ll`
* [MNT] Update ``Callable`` import from ``typing`` to ``collections.abc`` (:pr:`6798`) :user:`yarnabrina`
* [MNT] Fix spellings using ``codespell`` and ``typos`` (:pr:`6799`) :user:`yarnabrina`
* [MNT] improved environment package version check (:pr:`6776`) :user:`fkiraly`
* [MNT] downgrade pykan version to ``<0.2.2`` (:pr:`6853`) :user:`geetu040`
* [MNT] add non-unicode characters check to the linter (:pr:`6807`) :user:`fnhirwa`
* [MNT] updates and fixes to type hints (:pr:`6743`) :user:`ZhipengXue97`
* [MNT] Resolve the issue with diacritics failing to be decoded on Windows (:pr:`6862`) :user:`fnhirwa`
* [MNT] sync docstring and code formatting of dependency checker module with ``skbase`` (:pr:`6873`) :user:`fkiraly`
* [MNT] Remove package import alias related internal logic and tags (:pr:`6821`) :user:`fkiraly`
* [MNT] restrict failing Mr-SEQL version (:pr:`6879`) :user:`fkiraly`
* [MNT] release workflow: Upgrade deprecated pypa action parameter (:pr:`6878`) :user:`szepeviktor`
* [MNT] Fix ``pykan`` import and dependency checks (:pr:`6881`) :user:`fkiraly`
* [MNT] temporarily pin ``matplotlib`` below ``3.9.1`` (:pr:`6890`) :user:`yarnabrina`
* [MNT] make ``pyproject.toml`` parsing for differential testing more robust against non-package relevant changes (:pr:`6882`) :user:`fkiraly`
* [MNT] formatter for jupyter notebook json in build tools (:pr:`6849`) :user:`fkiraly`
* [MNT] sync differential testing utilities with ``skpro`` (:pr:`6840`) :user:`fkiraly`
* [MNT] Handle deprecations from ``pandas`` (:pr:`6855`) :user:`fkiraly`
* [MNT] sync docstring and code formatting of dependency checker module with ``skbase`` (:pr:`6873`) :user:`fkiraly`
* [MNT] fix ``.all-contributorsrc`` syntax (:pr:`6918`) :user:`fkiraly`
* [MNT] Resolve the issue with diacritics failing to be decoded on Windows (:pr:`6862`) :user:`fnhirwa`
* [MNT] changelog utility: fix termination condition to retrieve merged PR (:pr:`6920`) :user:`fkiraly`
* [MNT] restore ``holidays`` lower bound to ``0.29`` (:pr:`6921`) :user:`fkiraly`
* [MNT] Updating the GHA dependencies to install OSX dependencies and setting the compiler flags (:pr:`6926`) :user:`fnhirwa`
* [MNT] revert an erroneous instance of ``pandas`` deprecation fix (:pr:`6925`) :user:`fkiraly`
* [MNT] Update the path to script to fix #6926 (:pr:`6933`) :user:`fnhirwa`
* [MNT] [Dependabot](deps): Update ``pytest`` requirement from ``<8.3,>=7.4`` to ``>=7.4,<8.4`` (:pr:`6819`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update ``dask`` requirement from ``<2024.6.3`` to ``<2024.7.2`` (:pr:`6818`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update ``sphinx-gallery`` requirement from ``<0.17.0`` to ``<0.18.0`` (:pr:`6820`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update ``holidays`` requirement from ``<0.53,>=0.52`` to ``>=0.52,<0.54`` (:pr:`6780`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update sphinx requirement from ``!=7.2.0,<8.0.0`` to ``!=7.2.0,<9.0.0`` (:pr:`6865`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update ``holidays`` requirement from ``<0.54,>=0.52`` to ``>=0.52,<0.55`` (:pr:`6898`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update ``dask`` requirement from ``<2024.7.2`` to ``<2024.8.1`` (:pr:`6907`) :user:`dependabot[bot]`

Fixes
~~~~~

BaseObject and base framework
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] fix ``_check_soft_dependencies`` for post and pre versions of patch versions (:pr:`6909`) :user:`fkiraly`

Data types, checks, conversions
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] fix type inconsistency in conversion ``pandas`` to ``xarray`` based ``Series`` (:pr:`6856`) :user:`fkiraly`

Forecasting
^^^^^^^^^^^

* [BUG] Fix ``pykan`` dependency and set lower bound (:pr:`6789`) :user:`benHeid`
* [BUG] correct dependency tag for ``pytorch-forecasting`` forecasters: rename ``pytorch_forecasting`` to correct package name ``pytorch-forecasting`` (:pr:`6830`) :user:`XinyuWuu`

Registry and search
^^^^^^^^^^^^^^^^^^^

* [BUG] fix polymorphic estimators missing in estimator overview, e.g., ``pytorch-forecasting`` forecasters (:pr:`6803`) :user:`fkiraly`

Time series anomalies, changepoints, segmentation
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] Fix bug when predicting segments from clasp change point annotator (:pr:`6756`) :user:`Alex-JG3`

Transformations
^^^^^^^^^^^^^^^

* [BUG] Refactor ``ADICVTransformer`` and fix CV calculation (:pr:`6757`) :user:`sbhobbes`
* [BUG] fix ``BaseTransformer`` broadcasting condition in ``inverse_transform`` for decomposers (:pr:`6824`) :user:`fkiraly`
* [BUG] fix ``MSTL`` inverse transform and use in forecasting pipeline (:pr:`6825`) :user:`fkiraly`
* [BUG] fix handling of ``numpy`` integers in refactored ``Catch22`` transformation (:pr:`6934`) :user:`fkiraly`

Visualization
^^^^^^^^^^^^^

* [BUG] In ``plot_series``, trim unused levels when verifying dataframe formatting (:pr:`6754`) :user:`SultanOrazbayev`

Contributors
~~~~~~~~~~~~

:user:`Abhay-Lejith`,
:user:`Alex-JG3`,
:user:`alexander-lakocy`,
:user:`AlexeyOm`,
:user:`bastisar`,
:user:`benHeid`,
:user:`ceroper`,
:user:`DinoBektesevic`,
:user:`fkiraly`,
:user:`fnhirwa`,
:user:`fr1ll`,
:user:`gareth-brown-86`,
:user:`geetu040`,
:user:`hliebert`,
:user:`julian-fong`,
:user:`mateuszkasprowicz`,
:user:`MBristle`,
:user:`melinny`,
:user:`Mitchjkjkjk`,
:user:`mk406`,
:user:`SaiRevanth25`,
:user:`sbhobbes`,
:user:`shlok191`,
:user:`SultanOrazbayev`,
:user:`szepeviktor`,
:user:`XinyuWuu`,
:user:`yarnabrina`,
:user:`ZhipengXue97`


Version 0.31.0 - 2024-07-11
---------------------------

Maintenance release:

* scheduled deprecations and change actions
* ``numpy 2`` compatibility
* code style and pre-commit updates, using ``ruff`` for linting

For last non-maintenance content updates, see 0.30.2.

Dependency changes
~~~~~~~~~~~~~~~~~~

* ``numpy`` (core dependency) bounds have been updated to ``<2.1,>=1.21``
* ``skpro`` (soft dependency) bounds have been updated to ``>=2,<2.5.0``

Deprecations and removals
~~~~~~~~~~~~~~~~~~~~~~~~~

Time series anomalies, changepoints, segmentation
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* The ``fmt`` argument in time series annotators is now deprecated.
  Users should use the ``predict`` and ``transform`` methods instead,
  ``predict`` instead of ``fmt="sparse"``, and ``transform`` instead of
  ``fmt="dense"``.

Time series classification
^^^^^^^^^^^^^^^^^^^^^^^^^^

* The ``convert_y_to_keras`` method in deep learning classifiers has been removed.
  Users who have been using this method should
  instead use ``OneHotEncoder`` from ``sklearn`` directly, as ``convert_y_to_keras``
  is a simple wrapper around ``OneHotEncoder`` with default settings.

Contents
~~~~~~~~

* [MNT] raise ``numpy`` bound to ``numpy < 2.1``, ``numpy 2`` compatibility (:pr:`6624`) :user:`fkiraly`
* [MNT] [Dependabot](deps): Update skpro requirement from ``<2.4.0,>=2`` to ``>=2,<2.5.0`` (:pr:`6663`) :user:`dependabot[bot]`
* [MNT] bound ``prophet`` based forecasters to ``numpy<2`` due to incompatibility of ``prophet`` (:pr:`6721`) :user:`fkiraly`
* [MNT] further ``numpy 2`` compatibility fixes in estimators (:pr:`6729`) :user:`fkiraly`
* [MNT] handle ``numpy 2`` incompatible soft deps (:pr:`6728`) :user:`fkiraly`
* [MNT] Upgrade code style beyond ``python 3.8`` (:pr:`6330`) :user:`yarnabrina`
* [MNT] Update pre commit hooks post dropping ``python 3.8`` support (:pr:`6331`) :user:`yarnabrina`
* [MNT] suppress aggressive ``freq`` related warnings from ``pandas 2.2`` (:pr:`6733`) :user:`fkiraly`
* [MNT] 0.31.0 deprecations and change actions (:pr:`6716`) :user:`fkiraly`
* [MNT] switch to ``ruff`` as linting tool (:pr:`6676`) :user:`fnhirwa`
* [ENH] refactor and bugfixes for environment checker utilities (:pr:`6719`) :user:`fkiraly`

Contributors
~~~~~~~~~~~~

:user:`fkiraly`,
:user:`fnhirwa`,
:user:`yarnabrina`


Version 0.30.2 - 2024-07-04
---------------------------

Highlights
~~~~~~~~~~

* new `estimator overview table and estimator search page <https://www.sktime.net/en/stable/estimator_overview.html>`_ (:pr:`6147`) :user:`duydl`
* ``HFTransformersForecaster`` (hugging face transformers connector) now has a user friendly interface for applying PEFT methods (:pr:`6457`) :user:`geetu040`
* ``ForecastingOptunaSearchCV`` for hyper-parameter tuning of forecasters via ``optuna`` (:pr:`6630`) :user:`mk406`, :user:`gareth-brown-86`
* ``prophetverse`` package forecasters are now indexed by ``sktime`` (:pr:`6614`) :user:`felipeangelimvieira`
* ``pytorch-forecasting`` adapter, experimental global forecasting API (:pr:`6228`) :user:`XinyuWuu`
* ``skforecast`` adapter for reduction strategies (:pr:`6531`) :user:`Abhay-Lejith`, :user:`yarnabrina`
* EnbPI based forecaster with components from ``aws-fortuna`` (:pr:`6449`) :user:`benHeid`
* DTW distances and aligners from ``dtaidistance`` (:pr:`6578`) :user:`fkiraly`
* ``parametrize_with_checks`` utility for granular API compliance test setup in 2nd/3rd party libraries (:pr:`6588`) :user:`fkiraly`

Dependency changes
~~~~~~~~~~~~~~~~~~

* ``holidays`` (transformations soft dependency) bounds have been updated to ``>=0.29,<0.53``
* ``dask`` (data container and parallelization back-end) bounds have been updated to ``<2024.5.3``
* ``optuna`` is now a soft dependency, via the ``ForecastingOptunaSearchCV`` estimator, in the ``all_extras`` soft dependency set,
  with bounds ``<3.7``
* ``pytorch-forecasting`` is now a soft dependency, in the ``dl`` (deep learning) soft dependency set
* ``skforecast`` is now a soft dependency, in the ``all_extras`` soft dependency set and the ``forecasting`` soft dependency set,
  with bounds ``<0.13,>=0.12.1``
* ``dtaidistance`` is now a soft dependency, in the ``all_extras`` soft dependency set and the ``alignment`` soft dependency set,
  with bounds ``<2.4``

Core interface changes
~~~~~~~~~~~~~~~~~~~~~~

Forecasting
^^^^^^^^^^^

The base forecaster interface now has a dedicated interface point for
global forecasting or fine-tuning: in forecasters supporting global forecast,
an ``y`` argument may be passed in ``predict``, indicating new time series instances
for a global forecast, or a context for foundation models.
Forecasters capable of global forecasting or fine-tuning (this is the same interface
point) are tagged with the tag ``capability:global_forecasting``, value ``True``.

The global forecasting and fine-tuning interfaces are currently experimental,
and may undergo changes.

Users are invited to give feedback, and test the feature with the new
``pytorch-forecasting`` adapter.

Test framework
^^^^^^^^^^^^^^

* 2nd and 3rd party extension packages can now use the ``parametrize_with_checks``
  utility to set up granular API compliance tests. For detailed usage notes,
  consult the extender guide: :ref:`developer_guide_add_estimators`.
* various quality-of-life improvements have been made to facilitate
  indexing an estimator in the estimator overview and estimator search for
  developers of API compatible 2nd and 3rd party packages,
  without adding it directly to the main ``sktime`` repository.
  For detailed usage notes, consult the extender guide:
  :ref:`developer_guide_add_estimators`, or inspect the ``Prophetverse`` forecaster
  as a worked example.

Enhancements
~~~~~~~~~~~~

BaseObject and base framework
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] prevent imports caused by ``_check_soft_dependencies``, speed up dependency check and test collection time (:pr:`6355`) :user:`fkiraly`, :user:`yarnabrina`

Benchmarking, Metrics, Splitters
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] Parallelization option for ``ForecastingBenchmark`` (:pr:`6568`) :user:`benHeid`

Data types, checks, conversions
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] Added GluonTS datasets as ``sktime`` mtypes (:pr:`6530`) :user:`shlok191`

Distances, kernels
^^^^^^^^^^^^^^^^^^

* [ENH] DTW distances from ``dtaidistance`` (:pr:`6578`) :user:`fkiraly`

Forecasting
^^^^^^^^^^^

* [ENH] ``pytorch-forecasting`` adapter with Global Forecasting API (:pr:`6228`) :user:`XinyuWuu`
* [ENH] fitted parameter forwarding utility, forward ``statsforecast`` estimators' fitted parameters (:pr:`6349`) :user:`fkiraly`
* [ENH] EnbPI based forecaster with components from ``aws-fortuna`` (:pr:`6449`) :user:`benHeid`
* [ENH] ``skforecast`` ForecasterAutoreg adapter  (:pr:`6531`) :user:`Abhay-Lejith`, :user:`yarnabrina`
* [ENH] Extend ``HFTransformersForecaster`` for PEFT methods (:pr:`6457`) :user:`geetu040`
* [ENH] in ``BaseForecaster``, move check for ``capability:insample`` to ``_check_fh`` boilerplate (:pr:`6593`) :user:`XinyuWuu`
* [ENH] indexing ``prophetverse`` forecaster (:pr:`6614`) :user:`fkiraly`
* [ENH] ``ForecastingOptunaSearchCV`` for hyper-parameter tuning of forecasters via ``optuna`` (:pr:`6630`) :user:`mk406`, :user:`gareth-brown-86`

Registry and search
^^^^^^^^^^^^^^^^^^^

* [ENH] enhanced estimator overview table - tag display and search (:pr:`6147`) :user:`duydl`, :user:`fkiraly`

Time series alignment
^^^^^^^^^^^^^^^^^^^^^

* [ENH] DTW aligners from ``dtaidistance`` (:pr:`6578`) :user:`fkiraly`

Time series classification
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] resolve duplication in KNeighborsClassifier and KNeighborsRegressor (:pr:`6504`) :user:`Z-Fran`
* [ENH] added two test params sets to ``FCNNetwork`` (:pr:`6562`) :user:`TheoWeih`
* [ENH] further refactor of knn classifier and regressor (:pr:`6615`) :user:`fkiraly`
* [ENH] update ``tests._config`` to skip various sporadically failing tests for Proximity Forest and Proximity Tree until fixed (:pr:`6638`) :user:`julian-fong`

Time series regression
^^^^^^^^^^^^^^^^^^^^^^

* [ENH] Time Series Regression grid search (:pr:`6118`) :user:`ksharma6`
* [ENH] test parameters for ``RocketRegressor`` (:pr:`6149`) :user:`iaryangoyal`
* [ENH] resolve duplication in KNeighborsClassifier and KNeighborsRegressor (:pr:`6504`) :user:`Z-Fran`
* [ENH] further refactor of knn classifier and regressor (:pr:`6615`) :user:`fkiraly`

Transformations
^^^^^^^^^^^^^^^

* [ENH] refactor ``WindowSummarizer`` tests (:pr:`6564`) :user:`fkiraly`

Test framework
^^^^^^^^^^^^^^

* [ENH] differential testing for base functionality in various modules (:pr:`6534`) :user:`fkiraly`
* [ENH] further differential testing for the ``transformations`` module (:pr:`6533`) :user:`fkiraly`
* [ENH] differential testing in ``dist_kernels`` and ``clustering`` modules (:pr:`6543`) :user:`fkiraly`
* [ENH] simplify and add differential testing to ``forecasting.compose.tests`` module (:pr:`6563`) :user:`fkiraly`
* [ENH] simplify and add differential testing to ``sktime.pipeline`` module (:pr:`6565`) :user:`fkiraly`
* [ENH] differential testing in ``benchmarking`` module (:pr:`6566`) :user:`fkiraly`
* [ENH] move doctests to main test suite to ensure conditional execution (:pr:`6536`) :user:`fkiraly`
* [ENH] minor improvements to test efficiency (:pr:`6586`) :user:`fkiraly`
* [ENH] ``parametrize_with_checks`` utility for granular API compliance test setup in 2nd/3rd party libraries (:pr:`6588`) :user:`fkiraly`
* [ENH] differential testing to ``utils`` module (:pr:`6620`) :user:`fkiraly`
* [ENH] differential testing and minor improvements to ``forecasting.base`` tests (:pr:`6619`) :user:`fkiraly`
* [ENH] differential testing for ``performance_metrics`` module (:pr:`6616`) :user:`fkiraly`
* [ENH] fixes and improvements to ``pytest`` ``doctest`` integration (:pr:`6621`) :user:`fkiraly`

Documentation
~~~~~~~~~~~~~

* [DOC] fix broken links on webpage docs (:pr:`6339`) :user:`duydl`
* [DOC] document more tags (:pr:`6496`) :user:`fkiraly`
* [DOC] fix minor typos in tags API reference (:pr:`6631`) :user:`fkiraly`
* [DOC] update dependencies reference (:pr:`6655`) :user:`emmanuel-ferdman`
* [DOC] fix minor typo in developer comment in ``BaseTransformer`` (:pr:`6689`) :user:`Spinachboul`
* [DOC] rst roadmap documentation page stale since 2021 - replace by correct links to recent roadmaps (:pr:`6556`) :user:`fkiraly`
* [DOC] clarify docs on ARIMA estimators, add author credits for upstream (:pr:`6705`) :user:`fkiraly`
* [DOC] credit :user:`doberbauer`` for ``pykalman`` python 3.11 compatibility fix (:pr:`6662`) :user:`doberbauer`

Maintenance
~~~~~~~~~~~

* [MNT] [Dependabot](deps): Update holidays requirement from ``<0.51,>=0.29`` to ``>=0.29,<0.52`` (:pr:`6634`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update holidays requirement from ``<0.52,>=0.29`` to ``>=0.52,<0.53`` (:pr:`6702`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update dask requirement from ``<2024.6.1`` to ``<2024.6.2`` (:pr:`6643`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update numba requirement from ``<0.60,>=0.53`` to ``>=0.53,<0.61`` (:pr:`6590`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update dask requirement from ``<2024.6.2`` to ``<2024.6.3`` (:pr:`6647`) :user:`dependabot[bot]`
* [MNT] remove coverage reporting and ``pytest-cov`` from PR CI and ``setup.cfg`` (:pr:`6363`) :user:`fkiraly`
* [MNT] ``numpy 2`` compatibility fixes - estimators (:pr:`6626`) :user:`fkiraly`
* [MNT] ``scipy`` ``1.14.0`` compatibility for ``deep_equals`` plugin for ``csr_matrix`` (:pr:`6664`) :user:`fkiraly`
* [MNT] deprecate unused ``_check_soft_dependencies`` argument ``suppress_import_stdout`` (:pr:`6691`) :user:`fkiraly`

Fixes
~~~~~

Benchmarking, Metrics, Splitters
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] fix ``AUCalibration`` probabilistic metric for ``multivariate`` case (:pr:`6617`) :user:`fkiraly`

Data loaders
^^^^^^^^^^^^

* [BUG] fix bug 4076: ``PerformanceWarning`` in ``load_from_tsfile_to_dataframe`` (:pr:`6632`) :user:`ericjb`

Data types, checks, conversions
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] patch over ``pandas 2.2.X`` issue in ``freq`` timestamp/period round trip conversion for period start timestamps such as ``"MonthBegin"`` (:pr:`6574`) :user:`fkiraly`

Forecasting
^^^^^^^^^^^

* [BUG] fix passing of ``y`` in ``ForecastingPipeline`` (:pr:`6706`) :user:`fkiraly`

Time series classification
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] Fix bug in fitted parameter override in ``pyts`` and ``tslearn`` adapters (:pr:`6707`) :user:`fkiraly`

Time series clustering
^^^^^^^^^^^^^^^^^^^^^^

* [BUG] Fix bug in fitted parameter override in ``pyts`` and ``tslearn`` adapters (:pr:`6707`) :user:`fkiraly`

Time series regression
^^^^^^^^^^^^^^^^^^^^^^

* [BUG] in ``TimeSeriesForestRegressor``, fix failure: ``self.criterion`` does not exist (:pr:`6573`) :user:`ksharma6`

Test framework
^^^^^^^^^^^^^^

* [BUG] partially revert ``pytest.skip`` change from #6233 due to side effects in downstream test suites (:pr:`6508`) :user:`fkiraly`
* [BUG] fix test failures introduced by differential testing refactor (:pr:`6585`) :user:`fkiraly`

Transformations
^^^^^^^^^^^^^^^

* [BUG] fix ``HolidayFeatures`` crashes if dataframe doesn't contain specified date  (:pr:`6550`) :user:`fnhirwa`
* [BUG] in ``Differencer``, make explicit clone to avoid ``SettingWithCopyWarning`` (:pr:`6567`) :user:`benHeid`
* [BUG] minirocket: fix zero division errors #5174 (:pr:`6612`) :user:`benshaw2`
* [BUG] ensure correct setting of ``requires_X`` and ``requires_y`` tag for ``FeatureUnion`` (:pr:`6695`) :user:`fkiraly`
* [BUG] ensure correct setting of ``requires_X`` and ``requires_y`` tag for ``TransformerPipeline`` (:pr:`6692`) :user:`fkiraly`
* [BUG] partial fix for dropped column names in ``PaddingTransformer`` (:pr:`6693`) :user:`fkiraly`

Contributors
~~~~~~~~~~~~

:user:`Abhay-Lejith`,
:user:`benHeid`,
:user:`benshaw2`,
:user:`doberbauer`,
:user:`emmanuel-ferdman`,
:user:`ericjb`,
:user:`felipeangelimvieira`,
:user:`fkiraly`,
:user:`fnhirwa`,
:user:`gareth-brown-86`,
:user:`geetu040`,
:user:`iaryangoyal`,
:user:`julian-fong`,
:user:`ksharma6`,
:user:`mk406`,
:user:`shlok191`,
:user:`Spinachboul`,
:user:`TheoWeih`,
:user:`XinyuWuu`,
:user:`yarnabrina`,
:user:`Z-Fran`


Version 0.30.1 - 2024-06-04
---------------------------

Minimal maintenance update with actions consolidating onboard packages.

For last major feature update, see 0.29.1.

Contents
~~~~~~~~

* [MNT] reorganization of onboard libs - ``pykalman``, ``vmdpy`` (:pr:`6535`) :user:`fkiraly`
* [MNT] differential testing for ``split`` module (:pr:`6532`) :user:`fkiraly`


Version 0.30.0 - 2024-06-03
---------------------------

Major upgrade to the time series anomaly, changepoints, segmentation API (:user:`Alex-JG3`).
Users should review the section in the release notes.

Kindly also note the python 3.8 End-of-life warning below.

Also includes scheduled deprecations and change actions.

For last major feature update, see 0.29.1.

Dependency changes
~~~~~~~~~~~~~~~~~~

* ``joblib`` is now an explicit core dependency, with bounds ``<1.5,>=1.2.0``.
  Previously, ``joblib`` was an indirect core dependency, via ``scikit-learn``.
  Due to direct imports, this was changed to an explicit dependency.

* ``scikit-learn`` (core dependency) bounds have been updated to ``>=0.24,<1.6.0``

* ``scikit-base`` (core dependency) bounds have been updated to ``>=0.6.1,<0.9.0``

* ``skpro`` (soft dependency) bounds have been updated to ``>=2,<2.4.0``

* ``kotsu`` is not longer a soft dependency required by the forecasting benchmarking
  framework. The ``kotsu`` package is no longer maintained,
  and its necessary imports have beend moved
  to ``sktime`` as private utilities until refactor. See :pr:`6514`.

* ``pykalman`` (transformations soft dependency) has been forked into ``sktime``,
  as ``sktime.libs.pykalman``, as the original package is no longer maintained,
  see ``sktime`` issue 5414 or ``pykalman`` issue 109.

  * The package fork will be maintained in ``sktime``.
  * Direct users of ``pykalman`` can replace imports ``from pykalman import x``
    with equivalent imports ``from sktime.libs.pykalman import x``.
  * Indirect users via the transformer ``KalmanFilterTransformerPK`` will not be
    impacted as APIs do not change, except that they no longer require
    the original ``pykalman`` package in their python environment.

Core interface changes
~~~~~~~~~~~~~~~~~~~~~~

The time series annotation, anomalies, changepoints, segmentation API has been
fully reworked to be in line with ``scikit-base`` patterns, ``sktime`` tags,
and to provide a more consistent and flexible interface.

* the API provides ``predict`` methods for annotation labels, e.g., segments,
  outlier points, and a ``transform`` method for indicator series, for instance
  1/0 indicator whether an anomaly is present at the time stamp.
* the ``fmt`` argument used in some estimators is now deprecated,
  in favour of using ``predict`` or ``transform``.
* The type of annotation, e.g., change points or segmentation, is
  encoded by the new tag ``task`` used in time series annotators,
  with values ``anomaly_detection``, ``segmentation``, ``changepoint_detection``.
* Low-level methods allow polymorphic use of annotators, e.g., a changepoint detector
  to be used for segmentation, via ``predict_points`` or ``predict_segments``.
  The ``predict`` method defaults to the type of annotation defined by ``task``.

A full tutorial with examples will be created over the next release cycles,
and further enhancements are planned.

Deprecations and removals
~~~~~~~~~~~~~~~~~~~~~~~~~

Python 3.8 End-of-life
^^^^^^^^^^^^^^^^^^^^^^

``sktime`` now requires Python version ``>=3.9``.
No errors will be raised on Python 3.8, but test coverage and support for
Python 3.8 has been dropped.

Kindly note for context: python 3.8 will reach end of life
in October 2024, and multiple ``sktime`` core dependencies,
including ``scikit-learn``, have already dropped support for 3.8.

Forecasting
^^^^^^^^^^^

``cINNForecaster`` has been renamed to ``CINNForecaster``.
The estimator is no longer available under its old name,
after the deprecation period.
Users should replace any imports of ``cINNForecaster``
with imports of ``CINNForecaster``.

Enhancements
~~~~~~~~~~~~

* [ENH] Rework of base series annotator API (:pr:`6265`) :user:`Alex-JG3`
* [ENH] upgrade ``is_module_changed`` test utility for paths (:pr:`6518`) :user:`fkiraly`

Documentation
~~~~~~~~~~~~~

* [DOC] updated ``all_estimators`` docstring for ``re.Pattern`` support (:pr:`6478`) :user:`fkiraly`

Maintenance
~~~~~~~~~~~

* [MNT] [Dependabot](deps): Update skpro requirement from ``<2.3.0,>=2`` to ``>=2,<2.4.0`` (:pr:`6443`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update scikit-learn requirement from ``<1.5.0,>=0.24`` to ``>=0.24,<1.6.0`` (:pr:`6462`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update scikit-base requirement from ``<0.8.0,>=0.6.1`` to ``>=0.6.1,<0.9.0`` (:pr:`6488`) :user:`dependabot[bot]`
* [MNT] drop test coverage on python 3.8 in CI (:pr:`6329`) :user:`yarnabrina`
* [MNT] final change cycle (0.30.0) for renaming ``cINNForecaster`` to ``CINNForecaster`` (:pr:`6367`) :user:`geetu040`
* [MNT] added ``joblib`` as core dependency (:pr:`6384`) :user:`yarnabrina`
* [MNT] 0.30.0 deprecations and change actions (:pr:`6468`) :user:`fkiraly`
* [MNT] modified CRLF line endings to LF line endings (:pr:`6512`) :user:`yarnabrina`
* [MNT] Move dependency checkers to separate module in ``utils`` (:pr:`6354`) :user:`fkiraly`
* [MNT] resolution to ``pykalman`` issue - ``sktime`` local pykalman fork (:pr:`6188`) :user:`fkiraly`
* [MNT] add systematic differential test switch to low-level tests (:pr:`6511`) :user:`fkiraly`
* [MNT] isolate ``utils`` module init and ``sktime`` init from external imports (:pr:`6516`) :user:`fkiraly`
* [MNT] preparing refactor of benchmark framework: folding minimal ``kotsu`` library into ``sktime`` (:pr:`6514`) :user:`fkiraly`
* [MNT] run tests in ``distances`` module only if it has changed (:pr:`6517`) :user:`fkiraly`
* [MNT] refactor ``pykalman`` tests to ``pytest`` and conditional execution (:pr:`6519`) :user:`fkiraly`
* [MNT] conditional execution of tests in ``datatypes`` module (:pr:`6520`) :user:`fkiraly`

Contributors
~~~~~~~~~~~~

:user:`Alex-JG3`,
:user:`dependabot[bot]`,
:user:`fkiraly`,
:user:`geetu040`,
:user:`yarnabrina`


Version 0.29.1 - 2024-05-30
---------------------------

Highlights
~~~~~~~~~~

* ``TransformSelectForecaster`` to apply different forecasters depending on series type (e.g., intermittent, lumpy) (:pr:`6453`) :user:`shlok191`
* Kolmogorov-Arnold Network (KAN) forecaster (:pr:`6386`) :user:`benHeid`
* New probabilistic forecast metrics: interval width (sharpness), area under the
  calibration curve (:pr:`6437`, :pr:`6460`) :user:`fkiraly`
* Data loader for fpp3 (Forecasting, Princniples and Practice) datasets via ``rdata`` package, in ``sktime`` data formats (:pr:`6477`) :user:`ericjb`
* Bollinger Bands transformation (:pr:`6473`) :user:`ishanpai`
* ADI/CV2 (Syntetos/Boylan) feature extractor (:pr:`6336`) :user:`shlok191`
* ``ExpandingCutoffSplitter`` - splitter by moving cutoff (:pr:`6360`) :user:`ninedigits`

Dependency changes
~~~~~~~~~~~~~~~~~~

* ``holidays`` (transformations soft dependency) bounds have been updated to ``>=0.29,<0.50``
* ``pycatch22`` (transformations soft dependency) bounds have been updated to ``<0.4.6``
* ``dtw-python`` (distances and alignment soft dependency) bounds have been updated to ``>=1.3,<1.6``
* ``dask`` (data container and parallelization back-end) bounds have been updated to ``<2024.5.2``
* ``transformers`` (forecasting soft dependency) bounds have been updated to ``<4.41.0``

Core interface changes
~~~~~~~~~~~~~~~~~~~~~~

Benchmarking, Metrics, Splitters
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* all metrics for point forecasts now support weighting, via the ``sample_weight`` parameter.
  If passed, the metric will be weighted by the sample weights.
  For hierarchical data, the weights are applied to the series level,
  in this case all series need to have same length.
  Probabilistic metrics do not support weighting yet, this will be added in a future release.

Time series alignment
^^^^^^^^^^^^^^^^^^^^^

* all time series aligners now possess the ``capability:unequal_length`` tag,
  which is ``True`` if the aligner can handle time series of unequal length,
  and ``False`` otherwise. An informative error message, based on the tag,
  is now raised if an aligner not supporting unequal length time series is used on such data.

Deprecations and removals
~~~~~~~~~~~~~~~~~~~~~~~~~

Time series classification
^^^^^^^^^^^^^^^^^^^^^^^^^^

* The ``convert_y_to_keras`` method in deep learning classifiers has been deprecated and
  will be removed in 0.31.0. Users who have been using this method should
  instead use ``OneHotEncoder`` from ``sklearn`` directly, as ``convert_y_to_keras``
  is a simple wrapper around ``OneHotEncoder`` with default settings.

Enhancements
~~~~~~~~~~~~

BaseObject and base framework
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

Benchmarking, Metrics, Splitters
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] ``ExpandingCutoffSplitter`` - splitter by moving cutoff (:pr:`6360`) :user:`ninedigits`
* [ENH] Interval width (sharpness) metric (:pr:`6437`) :user:`fkiraly`
* [ENH] unsigned area under the calibration curve metric for distribution forecasts (:pr:`6460`) :user:`fkiraly`
* [ENH] forecasting metrics: ensure uniform support and testing for ``sample_weight`` parameter (:pr:`6495`) :user:`fkiraly`

Data loaders
^^^^^^^^^^^^

* [ENH] data loader for fpp3 datasets from CRAN via ``rdata`` package, to ``sktime`` data formats (:pr:`6477`) :user:`ericjb`

Data types, checks, conversions
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] Polars conversion utilities (:pr:`6455`) :user:`pranavvp16`

Forecasting
^^^^^^^^^^^

* [ENH] Kolmogorov-Arnold Network (KAN) forecaster (:pr:`6386`) :user:`benHeid`
* [ENH] Compositor to apply forecasters depending on series type (e.g., intermittent) (:pr:`6453`) :user:`shlok191`
* [ENH] compatibility of ``ForecastingHorizon`` with ``pandas`` ``freq`` ``2Y`` on ``pandas 2.2.0`` and above (:pr:`6500`) :user:`fkiraly`
* [ENH] add test case for ``ForecastingHorizon``  ``pandas 2.2.X`` compatibility, failure case #6499 (:pr:`6503`) :user:`fkiraly`
* [ENH] remove ``Prophet`` from ``test_differencer_cutoff`` (:pr:`6492`) :user:`fkiraly`
* [ENH] address deprecation and raise error in ``test_differencer_cutoff`` (:pr:`6493`) :user:`fkiraly`

Time series alignment
^^^^^^^^^^^^^^^^^^^^^

* [ENH] time series aligners capability check at input, tag for unequal length capability (:pr:`6486`) :user:`fkiraly`

Time series classification
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] Make deep classifier's ``convert_y_to_keras`` private (:pr:`6373`) :user:`cedricdonie`
* [ENH] classification test scenario with three classes and ``pd-multiindex`` mtype (:pr:`6374`) :user:`fkiraly`
* [ENH] test classifiers on str dtype ``y``, ensure ``predict`` returns same type and labels (:pr:`6428`) :user:`fkiraly`

Transformations
^^^^^^^^^^^^^^^

* [ENH] Test Parameters for `FinancialHolidaysTransformer` (:pr:`6334`) :user:`sharma-kshitij-ks`
* [ENH] ADI/CV feature extractor (:pr:`6336`) :user:`shlok191`
* [ENH] Bollinger Bands (:pr:`6473`) :user:`ishanpai`

Test framework
^^^^^^^^^^^^^^

* [ENH] enable ``check_estimator`` and ``QuickTester.run_tests`` to work with skip marked ``pytest`` tests (:pr:`6233`) :user:`YelenaYY`
* [ENH] make ``get_packages_with_changed_specs`` safe to mutation of return (:pr:`6451`) :user:`fkiraly`

Visualization
^^^^^^^^^^^^^

* [ENH] ``plot_series`` improved to use ``matplotlib`` conventions;
  ``plot_interval`` can now plot multiple overlaid intervals (:pr:`6416`, :pr:`6501`) :user:`ericjb`


Documentation
~~~~~~~~~~~~~

* [DOC] remove redundant/duplicative classification tutorial notebooks (:pr:`6401`) :user:`fkiraly`
* [DOC] update meetup time to new 1pm slot (:pr:`6402`) :user:`fkiraly`
* [DOC] explanation of ``get_test_params`` in test framework example (:pr:`6434`) :user:`fkiraly`
* [DOC] fix download badges in README (:pr:`6479`) :user:`fkiraly`
* [DOC] improved formatting of transformation docstrings (:pr:`6489`) :user:`fkiraly`
* [DOC] document more tags: transformations (:pr:`6351`) :user:`fkiraly`
* [DOC] Improve docstrings for metrics (:pr:`6419`) :user:`fkiraly`
* [DOC] fixed wrong sentence in the documentation (:pr:`6375`) :user:`helloplayer1`
* [DOC] Correct docstring for conversion functions of ``dask_to_pd`` (:pr:`6439`) :user:`pranavvp16`
* [DOC] Fix hugging face transformers documentation (:pr:`6450``) :user:`benheid`
* [DOC] ``plot_calibration`` docstring - formal explanation of the plot (:pr:`6414`) :user:`fkiraly`
* [DOC] high-level explanation of deprecation policy principles (:pr:`6464`) :user:`fkiraly`

Maintenance
~~~~~~~~~~~

* [MNT] [Dependabot](deps): Update holidays requirement from ``<0.49,>=0.29`` to ``>=0.29,<0.50`` (:pr:`6456`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update pycatch22 requirement from ``<0.4.4`` to <0.4.6`` (:pr:`6442`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update sphinx-design requirement from ``<0.6.0`` to ``<0.7.0`` (:pr:`6471`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update dask requirement from ``<2024.5.1`` to ``<2024.5.2`` (:pr:`6444`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update dtw-python requirement from ``<1.5,>=1.3`` to ``>=1.3,<1.6`` (:pr:`6474`) :user:`dependabot[bot]`
* [MNT] include unit tests in ``sktime/tests`` in per module tests (:pr:`6353`) :user:`yarnabrina`
* [MNT] maintenance changes for ``AutoTBATS`` (:pr:`6400`) :user:`yarnabrina`
* [MNT] bound ``transformers<4.41.0`` (:pr:`6447`) :user:`fkiraly`
* [MNT] ``sklearn 1.5.0`` compatibility patch (:pr:`6464`) :user:`fkiraly`
* [MNT] skip doctest for ``all_estimators`` (:pr:`6476`) :user:`fkiraly`
* [MNT] address various deprecation and computation warnings (:pr:`6482`) :user:`fkiraly`
* [MNT] address further deprecation warnings from ``pandas`` (:pr:`6494`) :user:`fkiraly`
* [MNT] fix the docs local build failure due to corrupt notebook (:pr:`6426`) :user:`fnhirwa`

Fixes
~~~~~

Forecasting
^^^^^^^^^^^

* [BUG] fix ``ForecastX`` when ``forecaster_X_exogeneous="complement"`` (:pr:`6433`) :user:`fnhirwa`
* [BUG] Modified VAR code to allow ``predict_quantiles`` of 0.5 (fixes #4742) (:pr:`6441`) :user:`meraldoantonio`

Neural networks
^^^^^^^^^^^^^^^

* [BUG] Remove duplicated ``BaseDeepNetworkPyTorch`` in ``networks.base`` (:pr:`6398`) :user:`luca-miniati`

Time series classification
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] Resolve ``LSTMFCNClassifier`` changing ``callback`` parameter (:pr:`6239`) :user:`ArthrowAbstract`
* [BUG] fix ``_get_train_probs`` in some classifiers to accept any input data type (:pr:`6377`) :user:`fkiraly`
* [BUG] fix ``BaggingClassifier`` for column subsampling case (:pr:`6429`) :user:`fkiraly`
* [BUG] fix ``ProximityForest``, tree, stump, and ``IndividualBOSS`` returning ``y`` of different type in ``predict`` (:pr:`6432`) :user:`fkiraly`
* [BUG] fix classifier default ``_predict`` returning integer labels always, even if ``fit`` ``y`` was not integer (:pr:`6430`) :user:`fkiraly`
* [BUG] in ``CNNClassifier``, ensure ``filter_sizes`` and ``padding`` is passed on (:pr:`6452`) :user:`fkiraly`
* [BUG] fix ``BaseClassifier.fit_predict`` and ``fit_predict_proba`` for ``pd-multiindex`` mtype (:pr:`6491`) :user:`fkiraly`

Time series regression
^^^^^^^^^^^^^^^^^^^^^^

* [BUG] Resolve ``LSTMFCNRegressor`` changing ``callback`` parameter (:pr:`6239`) :user:`ArthrowAbstract`
* [BUG] in ``CNNRegressor``, ensure ``filter_sizes`` and ``padding`` is passed on (:pr:`6452`) :user:`fkiraly`

Transformations
^^^^^^^^^^^^^^^

* [BUG] fix to make ``LabelEncoder`` compatible with ``sktime`` pipelines (:pr:`6458`) :user:`Abhay-Lejith`

Test framework
^^^^^^^^^^^^^^

* [BUG] allow metric classes to be called with ``multilevel`` arg if series is not hierarchical (:pr:`6418`) :user:`fkiraly`
* [BUG] fix ``test_run_test_for_class`` logic check if ``ONLY_CHANGED_MODULES`` flag is ``False`` and all estimator dependencies are present (:pr:`6383`) :user:`fkiraly`
* [BUG] fix ``test_run_test_for_class`` test logic (:pr:`6448`) :user:`fkiraly`

Visualization
^^^^^^^^^^^^^

* [BUG] fix ``xticks`` fore date-like data in ``plot_series`` (:pr:`6416`, :pr:`6501`) :user:`ericjb`

Contributors
~~~~~~~~~~~~

:user:`Abhay-Lejith`,
:user:`ArthrowAbstract`,
:user:`benHeid`,
:user:`cedricdonie`,
:user:`ericjb`,
:user:`fkiraly`,
:user:`fnhirwa`,
:user:`helloplayer1`,
:user:`ishanpai`,
:user:`luca-miniati`,
:user:`meraldoantonio`,
:user:`ninedigits`,
:user:`pranavvp16`,
:user:`sharma-kshitij-ks`,
:user:`shlok191`,
:user:`yarnabrina`,
:user:`YelenaYY`


Version 0.29.0 - 2024-04-28
---------------------------

Kindly note the python 3.8 End-of-life warning below.

Maintenance release:

* scheduled deprecations and change actions
* optimization of test collection speed

For last non-maintenance content updates, see 0.28.1.

Dependency changes
~~~~~~~~~~~~~~~~~~

* ``sktime`` now requires ``scikit-base>=0.6.1`` (core dependency), this has changed
  from previously no lower bound.

Deprecations and removals
~~~~~~~~~~~~~~~~~~~~~~~~~

Python 3.8 End-of-life
^^^^^^^^^^^^^^^^^^^^^^

From ``sktime`` 0.30.0, sktime will require Python version >=3.9.
No errors will be raised, but test coverage and support for
Python 3.8 will be dropped from 0.30.0 onwards.

Kindly note for context: python 3.8 will reach end of life
in October 2024, and multiple ``sktime`` core dependencies,
including ``scikit-learn``, have already dropped support for 3.8.

Forecasting
^^^^^^^^^^^

``cINNForecaster`` has been renamed to ``CINNForecaster``.
The estimator is available under its past name at its
current location until 0.30.0, when the old name will be removed.
To prepare for the name change,
replace any imports of ``cINNForecaster`` with imports of ``CINNForecaster``.

Transformations
^^^^^^^^^^^^^^^

* The ``n_jobs`` parameter in the ``Catch22`` transformer has been removed.
  Users should pass parallelization backend parameters via ``set_config`` instead.
  To specify ``n_jobs``, use any of the backends supporting it in the
  ``backend:parallel`` configuration, such as ``"loky"`` or ``"multithreading"``.
  The ``n_jobs`` parameter should be passed via the
  ``backend:parallel:params`` configuration.
  To retain previous behaviour, with a specific setting of ``n_jobs=x``,
  use ``set_config(**{"backend:parallel": "loky", "backend:parallel:params": {"n_jobs": x}})``.

Contents
~~~~~~~~

* [MNT] change cycle (0.29.0) for renaming ``cINNForecaster`` to ``CINNForecaster`` (:pr:`6238`) :user:`geetu040`
* [MNT] ``python 3.8`` End-of-life and ``sktime`` support drop warning (:pr:`6348`) :user:`fkiraly`
* [MNT] speed up test collection - cache differential testing switch utilities (:pr:`6357`) :user:`fkiraly`, :user:`yarnabrina`
* [MNT] temporary skip of estimators involved in timeouts #6344 (:pr:`6361`) :user:`fkiraly`
* [MNT] 0.29.0 deprecations and change actions (:pr:`6350`) :user:`fkiraly`

Contributors
~~~~~~~~~~~~

:user:`fkiraly`,
:user:`geetu040`,
:user:`yarnabrina`


Version 0.28.1 - 2024-04-25
---------------------------

Highlights
~~~~~~~~~~

* Experimental Hugging Face interface for pre-trained forecasters and foundation models (:pr:`5796`) :user:`benHeid`
* estimator tags are now `systematically documented in the API reference <https://www.sktime.net/en/latest/api_reference/tags.html>`_ (:pr:`6289`) :user:`fkiraly`
* new classifiers, transformers from ``pyts`` interfaced: BOSSVS, learning shapelets, shapelet transform (:pr:`6296`) :user:`johannfaouzi` (author), :user:`fkiraly` (interface)
* new classifiers from ``tslearn`` interfaced: time series SVC, SVR, learning shapelets (:pr:`6273`) :user:`rtavenar` (author), :user:`fkiraly` (interface)
* ``ForecastX`` can now use use future-unknown exogenous variables if passed in ``predict`` (:pr:`6199`) :user:`yarnabrina`
* bagging/bootstrap forecaster can now be applied to multivariate, exogeneous, hierarchical data and produces fully probabilistic forecasts (:pr:`6052`) :user:`fkiraly`
* ``neuralforecast`` models now have settings to auto-detect date-time ``freq``, and pass ``optimizer`` (:pr:`6235`, :pr:`6237`) :user:`pranavvp16`, :user:`geetu040`

Dependency changes
~~~~~~~~~~~~~~~~~~

* ``dask`` (data container and parallelization back-end) bounds have been updated to ``<2024.4.2``
* ``arch`` (transformation and parameter estimation soft dependency) bounds have been updated to ``>=5.6,<7.1.0``
* ``holidays`` (transformations soft dependency) bounds have been updated to ``>=0.29,<0.48``
* ``mne`` (transformations soft dependency) bounds have been updated to ``>=1.5,<1.8``

Core interface changes
~~~~~~~~~~~~~~~~~~~~~~

All objects and estimators now can, in addition to the existing PEP 440 package dependency specifier tags,
specify PEP 508 compatible environment markers for their dependencies,
via the ``env_marker`` tag. Values should be PEP 508 compliant strings, e.g., ``platform_system!="Windows"``.

This allows for more fine-grained control over the dependencies of estimators, where needed,
e.g., for estimators that require specific operating systems.

Enhancements
~~~~~~~~~~~~

BaseObject and base framework
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] PEP 508 environment markers for estimators (:pr:`6144`) :user:`fkiraly`
* [ENH] enhancements to tag system, systematic API docs for tags (:pr:`6289`) :user:`fkiraly`

Benchmarking, Metrics, Splitters
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] instance splitter to apply ``sklearn`` splitter to panel data (:pr:`6055`) :user:`fkiraly`
* [ENH] efficient ``_evaluate_by_index`` for MSE and RMSE (``MeanSquaredError``) (:pr:`6248`) :user:`fkiraly`
* [ENH] implement efficient ``_evaluate_by_index`` for ``MedianAbsoluteError`` class (:pr:`6251`) :user:`mobley-trent`

Forecasting
^^^^^^^^^^^

* [ENH] Hugging Face interface for pre-trained forecasters (:pr:`5796`) :user:`benHeid`
* [ENH] bagging/bootstrap forecaster extended to multivariate, exogeneous, hierarchical data (:pr:`6052`) :user:`fkiraly`
* [ENH] Minor ``neuralforecast`` related changes (:pr:`6312`) :user:`yarnabrina`
* [ENH] Option to use future-unknown exogenous variables in ``ForecastX`` if passed in ``predict`` (:pr:`6199`) :user:`yarnabrina`
* [ENH] Add ``optimizer`` param for ``neuralforecast`` models (:pr:`6235`) :user:`pranavvp16`
* [ENH] Update behavior of ``freq="auto"`` in ``neuralforecast`` facing estimators (:pr:`6237`) :user:`geetu040`
* [ENH] ``TBATS`` test parameters to cover doc example (:pr:`6292`) :user:`fkiraly`

Neural networks
^^^^^^^^^^^^^^^

* [ENH] added test parameters to ``CNNNetwork`` and ``ResnetNetwork`` (:pr:`6209`) :user:`julian-fong`
* [ENH] added test parameters for the LSTM FCNN network (:pr:`6281`) :user:`shlok191`

Probability distributions and simulators
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] extend ``Empirical`` distribution to hierarchical data (:pr:`6066`) :user:`fkiraly`
* [ENH] mixture distribution, from ``skpro`` (:pr:`6179`) :user:`vandit98`

Time series classification
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] added test parameters for ``MatrixProfileClassifier`` (:pr:`6193`) :user:`MMTrooper`
* [ENH] interfaces to further ``tslearn`` estimators (:pr:`6273`) :user:`fkiraly`
* [ENH] interfaces to further ``pyts`` classifiers (:pr:`6296`) :user:`fkiraly`

Time series clustering
^^^^^^^^^^^^^^^^^^^^^^

* [ENH] clusterer test scenario with unequal length time series; fix clusterer tags (:pr:`6277`) :user:`fkiraly`

Time series regression
^^^^^^^^^^^^^^^^^^^^^^

* [ENH] k-nearest neighbors regressor: support for non-brute algorithms and non-precomputed mode to improve memory efficiency (:pr:`6217`) :user:`Z-Fran`

Transformations
^^^^^^^^^^^^^^^

* [ENH] make ``TabularToSeriesAdaptor`` compatible with ``sklearn`` transformers that accept only ``y``, e.g., ``LabelEncoder`` (:pr:`5982`) :user:`fkiraly`

Test framework
^^^^^^^^^^^^^^

* [ENH] make ``get_examples`` side effect safe via ``deepcopy`` (:pr:`6259`) :user:`fkiraly`
* [ENH] refactor test scenario creation to be lazy rather than on module load (:pr:`6278`) :user:`fkiraly`

Documentation
~~~~~~~~~~~~~

* [DOC] update installation instructions on ``conda`` soft dependencies (:pr:`6229`) :user:`fkiraly`
* [DOC] add missing import statements to the ``InvertAugmenter`` docstring example (:pr:`6236`) :user:`Anteemony`
* [DOC] Adding Usage Example in docstring (:pr:`6264`) :user:`MihirsinhChauhan`
* [DOC] improve docstring formatting in probabilistic metrics (:pr:`6256`) :user:`fkiraly`
* [DOC] ``authors`` tag - extension template instructions to credit 3rd party interfaced authors (:pr:`5953`) :user:`fkiraly`
* [DOC] Refactor examples directory and link to docs/source/examples (:pr:`6210`) :user:`duydl`
* [DOC] author credits to ``tslearn`` authors (:pr:`6269`) :user:`fkiraly`
* [DOC] author credits to ``pyts`` authors (:pr:`6270`) :user:`fkiraly`
* [DOC] Update README.md - time of Friday meetups (:pr:`6293`) :user:`fkiraly`
* [DOC] systematic API docs for tags (:pr:`6289`) :user:`fkiraly`
* [DOC] in extension templates, clarify handling of soft dependencies (:pr:`6325`) :user:`fkiraly`
* [DOC] author credits to ``pycatch22`` authors, fix missing documentation page (:pr:`6300`) :user:`fkiraly`
* [DOC] added usage examples to multiple estimator docstrings (:pr:`6187`) :user:`MihirsinhChauhan`
* [DOC] Miscellaneous aesthetic improvements to docs UI (:pr:`6211`) :user:`duydl`
* [DOC] Remove redundant code in tutorial section 2.2.4 (:pr:`6267`) :user:`iamSathishR`
* [DOC] Added an example to ``WhiteNoiseAugmenter``  (:pr:`6200`) :user:`SamruddhiNavale`

Maintenance
~~~~~~~~~~~

* [MNT] Basic fix and enhancement of doc local build process (:pr:`6128`) :user:`duydl`
* [MNT] temporary skip for failure #6260 (:pr:`6262`) :user:`fkiraly`
* [MNT] Update dask requirement from ``<2024.2.2`` to ``<2024.4.2``, add new required ``dataframe`` extra to ``pyproject.toml``. (:pr:`6282`) :user:`yarnabrina`
* [MNT] fix isolation of ``mlflow`` soft dependencies (:pr:`6285`) :user:`fkiraly`
* [MNT] add :user:`slavik57` as a maintenance contributor for fixing ``conda-forge`` ``sktime-all-extras 0.28.0`` release (:pr:`6308`) :user:`tm-slavik57`
* [MNT] set GHA macos runner consistently to ``macos-13`` (:pr:`6328`) :user:`fkiraly`
* [MNT] [Dependabot](deps-dev): Update ``holidays`` requirement from ``<0.46,>=0.29`` to ``>=0.29,<0.47`` (:pr:`6250`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update ``holidays`` requirement from ``<0.47,>=0.29`` to ``>=0.29,<0.48`` (:pr:`6302`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update ``arch`` requirement from ``<6.4.0,>=5.6`` to ``>=5.6,<7.1.0`` (:pr:`6307`, :pr:`6309`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update ``pytest-xdist`` requirement from ``<3.6,>=3.3`` to ``>=3.3,<3.7`` (:pr:`6316`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Update ``mne`` requirement from ``<1.7,>=1.5`` to ``>=1.5,<1.8`` (:pr:`6317`) :user:`dependabot[bot]`
* [MNT] Update ``dask`` requirement from ``<2024.2.2`` to ``<2024.4.2``, add new required ``dataframe`` extra to ``pyproject.toml``. (:pr:`6282`) :user:`yarnabrina`

Fixes
~~~~~

Data loaders
^^^^^^^^^^^^

* [BUG] Fix ``tsf`` data error log and make it more precise (:pr:`6258`) :user:`pranavvp16`

Forecasting
^^^^^^^^^^^

* [BUG] Fix ``NaiveForecaster`` with ``sp>1`` (:pr:`5923`) :user:`benHeid`
* [BUG] fix ``FallbackForecaster`` failing with ``ForecastByLevel`` when ``nan_predict_policy='raise'`` (:pr:`6231`) :user:`ninedigits`
* [BUG] Add regression test for bug 3177 (:pr:`6246`) :user:`benHeid`
* [BUG] fix failing test in ``neuralforecast`` auto freq, amid ``pandas`` ``freq`` deprecations (:pr:`6321`) :user:`geetu040`

Probability distributions and simulators
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] fix ``var`` of ``Laplace`` distribution (:pr:`6324`) :user:`fkiraly`
* [BUG] fix ``Empirical`` index to be ``pd.MultiIndex`` for hierarchical data index (:pr:`6341`) :user:`fkiraly`

Time series clustering
^^^^^^^^^^^^^^^^^^^^^^

* [BUG] fix dependent tags of ``TimeSeriesDBSCAN`` (:pr:`6322`) :user:`fkiraly`

Time series regression
^^^^^^^^^^^^^^^^^^^^^^

* [BUG] in ``CNNRegressor``, fix ``self.model not found`` error when ``verbose=True`` (:pr:`6232`) :user:`morestart`

Transformations
^^^^^^^^^^^^^^^

* [BUG] ``Imputer`` bugfix #6224 (:pr:`6253`) :user:`Ram0nB`
* [BUG] Fix backfill of custom function in ``window_feature`` (:pr:`6294`) :user:`toandaominh1997`
* [BUG] fixed indexing of return in ``TSBootstrapAdapter`` (:pr:`6326`) :user:`astrogilda`
* [BUG] Fix ``STLTransformer.inverse_transform`` for univariate case (:pr:`6338`) :user:`fkiraly`

Contributors
~~~~~~~~~~~~

:user:`Anteemony`,
:user:`astrogilda`,
:user:`benHeid`,
:user:`duydl`,
:user:`fkiraly`,
:user:`geetu040`,
:user:`iamSathishR`,
:user:`julian-fong`,
:user:`MihirsinhChauhan`,
:user:`MMTrooper`,
:user:`mobley-trent`,
:user:`morestart`,
:user:`ninedigits`,
:user:`pranavvp16`,
:user:`Ram0nB`,
:user:`SamruddhiNavale`,
:user:`shlok191`,
:user:`slavik57`,
:user:`tm-slavik57`,
:user:`toandaominh1997`,
:user:`vandit98`,
:user:`yarnabrina`,
:user:`Z-Fran`


Version 0.28.0 - 2024-03-27
---------------------------

Maintenance release:

* scheduled deprecations and change actions
* support for ``pandas 2.2.X``

For last non-maintenance content updates, see 0.27.1.

Dependency changes
~~~~~~~~~~~~~~~~~~

* ``sktime`` now supports ``pandas`` ``2.2.X``, bounds have been updated to ``<2.3.0,>=1.1``.
* ``temporian`` (transformations soft dependency) bounds have been updated to ``>=0.7.0,<0.9.0``.
* ``pykalman-bardo`` dependencies have been replaced by the original fork ``pykalman``.
  ``pykalman-bardo`` has been merged back into ``pykalman``,
  which is no longer abandoned.
  This is a soft dependency, and the switch does not affect users installing
  ``sktime`` using one of its dependency sets.


Deprecations and removals
~~~~~~~~~~~~~~~~~~~~~~~~~

Forecasting
^^^^^^^^^^^

* in ``ProphetPiecewiseLinearTrendForecaster``, the seasonality parameters
  ``yearly_seasonality``, ``weekly_seasonality`` and ``daily_seasonality``
  now have default values of ``False``.
  To retain previous behaviour, set these parameters explicitly to ``"auto"``.

Transformations
^^^^^^^^^^^^^^^

* The ``n_jobs`` parameter in the ``Catch22`` transformer is deprecated
  and will be removed in 0.29.0.
  Users should pass parallelization backend parameters via ``set_config`` instead.
  To specify ``n_jobs``, use any of the backends supporting it in the
  ``backend:parallel`` configuration, such as ``"loky"`` or ``"multithreading"``.
  The ``n_jobs`` parameter should be passed via the
  ``backend:parallel:params`` configuration.
  To retain previous behaviour, with a specific setting of ``n_jobs=x``,
  use ``set_config(**{"backend:parallel": "loky", "backend:parallel:params": {"n_jobs": x}})``.
* The ``n_jobs`` parameter in the ``Catch22Wrapper`` transformer has been removed.
  Users should pass parallelization backend parameters via ``set_config`` instead.
  To specify ``n_jobs``, use any of the backends supporting it in the
  ``backend:parallel`` configuration, such as ``"loky"`` or ``"multithreading"``.
  The ``n_jobs`` parameter should be passed via the
  ``backend:parallel:params`` configuration.
  To retain previous behaviour, with a specific setting of ``n_jobs=x``,
  use ``set_config(**{"backend:parallel": "loky", "backend:parallel:params": {"n_jobs": x}})``.
* ``panel.dictionary_based.PAA`` has been renamed to ``PAAlegacy`` in 0.27.0,
  and ``sktime.transformations.series.PAA2`` has been renamed to ``PAA``.
  ``PAA`` is now the primary PAA implementation in ``sktime``.
  After completion of the deprecation cycle, the estimators are no longer available
  under their previous names.
  To migrate dependent code to use the new names, do one of the following:
  1. replace use of ``PAA`` from ``sktime.transformations.panel.dictionary_based``
  by use of ``PAA2`` from ``sktime.transformations.series.paa``, switching
  parameter names appropriately, or
  2. replace use of ``PAA`` from ``sktime.transformations.panel.dictionary_based``
  by use of ``PAAlegacy`` from ``sktime.transformations.panel.dictionary_based``,
  without change of parameter values.
* ``panel.dictionary_based.SAX`` has been renamed to ``SAXlegacy`` in 0.27.0,
  while ``sktime.transformations.series.SAX2`` has been renamed to ``SAX``.
  ``SAX`` is now the primary SAX implementation in ``sktime``,
  while the former ``SAX`` will continue to be available as ``SAXlegacy``.
  After completion of the deprecation cycle, the estimators are no longer available
  under their previous names.
  To migrate dependent code to use the new names, do one of the following:
  1. replace use of ``SAX`` from ``sktime.transformations.panel.dictionary_based``
  by use of ``SAX2`` from ``sktime.transformations.series.paa``, switching
  parameter names appropriately, or
  2. replace use of ``SAX`` from ``sktime.transformations.panel.dictionary_based``
  by use of ``SAXlegacy`` from ``sktime.transformations.panel.dictionary_based``,
  without change of parameter values.

Contents
~~~~~~~~

* [MNT] 0.28.0 deprecations and change actions (:pr:`6198`) :user:`fkiraly`
* [MNT] raise ``pandas`` bound to ``pandas<2.3.0`` (:pr:`5841`) :user:`fkiraly`
* [MNT] update ``temporian`` bound to ``<0.9.0,!=0.8.0`` (:pr:`6222`) :user:`fkiraly`
* [MNT] revert switch from ``pykalman`` to ``pykalman-bardo`` (:pr:`6114`) :user:`fkiraly`
* [MNT] [Dependabot](deps-dev): Update ``pytest-cov`` requirement from ``<4.2,>=4.1`` to ``>=4.1,<5.1`` (:pr:`6215`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Bump ``tj-actions/changed-files`` from 43 to 44 (:pr:`6226`) :user:`dependabot[bot]`
* [ENH] stricter condition for ``get_test_params`` not failing in repo soft dependency isolation tests (:pr:`6223`) :user:`fkiraly`


Version 0.27.1 - 2024-03-25
---------------------------

Highlights
~~~~~~~~~~

* Phase 1 integration with ``temporian`` - ``TemporianTransformer`` transformer (:pr:`5980`) :user:`ianspektor`, :user:`achoum`, :user:`javiber`
* Phase 1 integration with ``tsbootstrap`` - ``TSBootstrapAdapter`` transformer (:pr:`5887`) :user:`benHeid`, :user:`astrogilda`, :user:`fkiraly`
* Shapelet transform from ``pyts`` available as ``sktime`` transformer (:pr:`6082`) :user:`Abhay-Lejith`
* ``Catch22`` transformer now supports short aliases and parallelization backend selection (:pr:`6002`) :user:`julnow`
* forecasting tuners can now return performances of all parameters, via ``return_n_best_forecasters=-1`` (:pr:`6031`) :user:`HassnHamada`
* ``NeuralForecastRNN`` can now auto-detect ``freq`` (:pr:`6039`) :user:`geetu040`
* time series splitters are now first-class objects, with suite tests and ``check_estimator`` support (:pr:`6051`) :user:`fkiraly`

Dependency changes
~~~~~~~~~~~~~~~~~~

* ``temporian`` is now a soft dependency for ``sktime`` (transformations)
* ``holidays`` (transformations soft dependency) bounds have been updated to ``>=0.29,<0.46``
* ``dtw-python`` bounds have been updated to ``>=1.3,<1.5`

Core interface changes
~~~~~~~~~~~~~~~~~~~~~~

* time series splitters are now full first-class citizens. Interface conformance
  can now be checked with ``check_estimator``.


Deprecations and removals
~~~~~~~~~~~~~~~~~~~~~~~~~

Forecasting
^^^^^^^^^^^

``cINNForecaster`` will be renamed to CINNForecaster in sktime 0.29.0.
The estimator is available under the future name at its
current location, and will be available under its deprecated name
until 0.30.0. To prepare for the name change,
replace any imports of ``cINNForecaster`` with imports of ``CINNForecaster``.


Enhancements
~~~~~~~~~~~~

Benchmarking, Metrics, Splitters
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] ``check_estimator`` integration for splitters (:pr:`6051`) :user:`fkiraly`

Data loaders
^^^^^^^^^^^^

* [ENH] automatic inference of file ending in data loaders for single file types (:pr:`6045`) :user:`SaiRevanth25`

Data types, checks, conversions
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] use ``Index.unique`` instead of ``set`` in conversion from ``pd-multiindex`` to ``df-list`` mtype by :user:`fkiraly` (:pr:`6007`)

Distances, kernels
^^^^^^^^^^^^^^^^^^

* [ENH] Second test parameter set for shapeDTW (:pr:`6093`) :user:`XinyuWuu`
* [ENH] add ``colalign`` functionality to ``ScipyDist`` class as specified in the docstrings (:pr:`6110`) :user:`fnhirwa`

Forecasting
^^^^^^^^^^^

* [ENH] forecasting tuners, ``return_n_best_forecasters=-1`` to return performances of all forecasters (:pr:`6031`) :user:`HassnHamada`
* [ENH] ``NeuralForecastRNN`` ``freq`` auto-detect feature (:pr:`6039`) :user:`geetu040`
* [ENH] ``neuralforecast`` based LSTM model by :user:`pranavvp16` (:pr:`6047`)
* [ENH] fix ``ForecastingHorizon.freq`` handling for ``pandas 2.2.X`` by :user:`fkiraly` (:pr:`6057`)

Neural network templates
^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] added test params to ``RNNNetwork`` (:pr:`6155`) :user:`julian-fong`

Time series classification
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] remove private methods from parameters of ``ProximityForest``, ``ProximityTree``, and ``ProximityStump`` by :user:`fnhirwa` (:pr:`6046`)

Time series clustering
^^^^^^^^^^^^^^^^^^^^^^

* [ENH] add new test parameter sets for ``TimeSeriesKMeansTslearn`` (:pr:`6195`) :user:`shankariraja`

Time series regression
^^^^^^^^^^^^^^^^^^^^^^

* [ENH] Migrate DL regressors from ``sktime-dl``: CNTC, InceptionTime, MACNN (:pr:`6038`) :user:`nilesh05apr`
* [ENH] ``MultiplexRegressor`` - autoML multiplexer for time series regressors (:pr:`6075`) :user:`ksharma6`

Transformations
^^^^^^^^^^^^^^^

* [ENH] ``tsbootstrap`` transformer adapter (:pr:`5887`) :user:`benHeid`
* [ENH] ``TemporianTransformer`` - interface to ``temporian`` (:pr:`5980`) :user:`ianspektor`, :user:`achoum`
* [ENH] Refactored and improved ``Catch22`` transformer - support for column names, short aliases, refactor to ``pd.Series``, ``sktime`` native parallelization (:pr:`6002`) :user:`julnow`
* [ENH] Examples for ``YtoX`` transformer (:pr:`6028`, :pr:`6059`) :user:`fkiraly`, :user:`geetu040`
* [ENH] Shapelet transform interfacing ``pyts`` (:pr:`6082`) :user:`Abhay-Lejith`
* [ENH] Add a ``test_mstl`` module checking if ``transform`` returns desired components by :user:`kcentric` (:pr:`6084`)
* [ENH] add test cases for ``HampelFilter`` by :user:`fkiraly` (:pr:`6087`)
* [ENH] Second test parameter set for Kalman Filter (:pr:`6095`) :user:`XinyuWuu`
* [ENH] Add ``MSTL`` import statement in ``detrend`` by :user:`geetu040` (:pr:`6116`)

Test framework
^^^^^^^^^^^^^^

* [ENH] test suite for splitters (:pr:`6051`) :user:`fkiraly`


Documentation
~~~~~~~~~~~~~

* [DOC] Fix invalid use of single-grave in docstrings (:pr:`6023`) :user:`geetu040`
* [DOC] Fix typos in changelog by :user:`yarnabrina` (:pr:`6034`)
* [DOC] corrected Discord channel mention in developer guide (:pr:`6163`) :user:`shankariraja`
* [DOC] add credit to :user:`rikstarmans in ``FallbackForecaster`` (:pr:`6069`) :user:`fkiraly`
* [DOC] Added an example to MLPRegressor #4264  (:pr:`6135`) :user:`vandit98`
* [DOC] in ``BaseSeriesAnnotator``, document the ``int_label`` option (:pr:`6143`) :user:`Alex-JG3`
* [DOC] fix typo in ``_registry.py`` (:pr:`6160`) :user:`pranavvp16`
* [DOC] minor clarifications in mtype descriptions (:pr:`6078`) :user:`fkiraly`
* [DOC] ExponentialSmoothing default method change from L-BFGS-B to SLSQP (:pr:`6186`) :user:`manuel-munoz-aguirre`
* [DOC] fix missing exports in time series regression API ref (:pr:`6191`) :user:`fkiraly`
* [DOC] add more examples to CoC from python software foundation CoC (:pr:`6185`) :user:`fkiraly`
* [DOC] correct deprecation versions in ``BaseDeepClassifier`` docstring (:pr:`6197`) :user:`fkiraly`
* [DOC] update maintainer tag information in docs and PR template (:pr:`6072`) :user:`fkiraly`
* [DOC] Add hall-of-fame widget to README (Added the Hall-of-fame section) #3716  (:pr:`6203`) :user:`KaustubhUp025`
* [DOC] Added docstring example to ``DummyClassifier`` (:pr:`6146`) :user:`YashKhare20`
* [DOC] Added docstring for lstmfcn and MLP classifiers (:pr:`6136`) :user:`vandit98`
* [DOC] Fix syntax error in "getting started" example code block for Time Series Regression (:pr:`6022`) :user:`sahusiddharth`
* [DOC] Added blank lines to properly render ``FourierFeatures`` docstring, ``sp_list`` (:pr:`5984`) :user:`tiloye`
* [DOC] add missing author credits of :user:`ivarzap` (:pr:`6050`) :user:`fkiraly`
* [DOC] fix various typos (:pr:`6043`) :user:`fkiraly`
* [DOC] clarification regarding immutability of ``self``-params in extension templates (:pr:`6053`) :user:`fkiraly`
* [DOC] Fix invalid use of single-grave in docstrings (:pr:`6023`) :user:`geetu040`
* [DOC] Added docstring example to ``CNNRegressor`` (:pr:`6102`) :user:`meraldoantonio`
* [DOC] corrected Discord channel mention in developer guide (:pr:`6163`) :user:`shankariraja`
* [DOC] add credit to :user:`rikstarmans` in ``FallbackForecaster`` (:pr:`6069`) :user:`fkiraly`
* [DOC] Added an example to ``MLPRegressor`` (:pr:`6135`) :user:`vandit98`
* [DOC] fix typo in ``_registry.py`` (:pr:`6160`) :user:`pranavvp16`
* [DOC] minor clarifications in mtype descriptions by :user:`fkiraly` (:pr:`6078`)
* [DOC] ``ExponentialSmoothing`` - fix docstring after default method change from ``L-BFGS-B`` to SLSQP`` (:pr:`6186`) :user:`manuel-munoz-aguirre`
* [DOC] fix missing imports in time series regression API ref (:pr:`6191`) :user:`fkiraly`
* [DOC] add more examples to CoC from python software foundation CoC (:pr:`6185`) :user:`fkiraly`
* [DOC] correct deprecation versions in ``BaseDeepClassifier`` docstring (:pr:`6197`) :user:`fkiraly`
* [DOC] update maintainer tag information in docs and PR template (:pr:`6072`) :user:`fkiraly`
* [DOC] Add hall-of-fame widget and section to README (:pr:`6203`) :user:`KaustubhUp025`


Maintenance
~~~~~~~~~~~

* [MNT] [Dependabot](deps-dev): Update ``holidays`` requirement from ``<0.45,>=0.29`` to ``>=0.29,<0.46`` (:pr:`6164`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps-dev): Update ``dtw-python`` requirement from ``<1.4,>=1.3`` to ``>=1.3,<1.5`` (:pr:`6165`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Bump ``tj-actions/changed-files`` from 42 to 43 (:pr:`6125`) :user:`dependabot[bot]`
* [MNT] temporary skip sporadically failing tests for ``ShapeletTransformPyts`` (:pr:`6172`) :user:`fkiraly`
* [MNT] create build tool to check invalid backticks (:pr:`6088`) :user:`geetu040`
* [MNT] decouple ``catch22`` module from ``numba`` utilities (:pr:`6101`) :user:`fkiraly`
* [MNT] bound ``temporian<0.8.0`` (:pr:`6184`) :user:`fkiraly`
* [MNT] Ensure Update Contributors does not run on main (:pr:`6189`) :user:`Greyisheep`, :user:`duydl`
* [MNT] initialize change cycle (0.28.0) for renaming ``cINNForecaster`` to ``CINNForecaster`` (:pr:`6121`) :user:`geetu040`
* [MNT] Fix failing tests due to ``tensorflow`` update (:pr:`6098`) :user:`benHeid`
* [MNT] silence sporadic failure in ``test_evaluate_error_score`` (:pr:`6058`) :user:`fkiraly`
* [MNT] update ``statsforecast`` version in ``forecasting`` extra  (:pr:`6064`) :user:`yarnabrina`
* [MNT] Docker files updated by (:pr:`6076`) :user:`deysanjeeb`
* [MNT] deprecation action timing for ``Catch22`` changes  (:pr:`6123`) :user:`fkiraly`
* [MNT] run ``update-contributors`` workflow only on PR by (:pr:`6133`) :user:`fkiraly`
* [MNT] temporary skip sporadically failing tests for ``ShapeletTransformPyts`` (:pr:`6172`) :user:`fkiraly`
* [MNT] enable concurrency settings in 'Install and Test' GHA workflow (:pr:`6074`) :user:`MEMEO-PRO`
* [MNT] temporary skip for some sporadic failures on ``main`` (:pr:`6208`) :user:`fkiraly`


Fixes
~~~~~

Distances, kernels
^^^^^^^^^^^^^^^^^^

* [BUG] Fix various issues in shapeDTW (:pr:`6093`) :user:`XinyuWuu`
* [BUG] resolve redundant or problematic statements in ``numba`` bounding matrix routines (:pr:`6183`) :user:`albertoazzari`

Estimator registry
^^^^^^^^^^^^^^^^^^

* [BUG] remove unnecessary line in ``all_estimators`` (:pr:`6103`) :user:`fkiraly`

Forecasting
^^^^^^^^^^^

* [BUG] Fixed ``SARIMAX`` failure when ``X`` is passed to predict but not ``fit``  (:pr:`6005`) :user:`Abhay-Lejith`
* [BUG] fix ``BaseForecaster.predict_var`` default if ``predict_proba`` is implemented (:pr:`6067`) :user:`fkiraly`
* [BUG] In ``ForecastingHorizon``, ignore ``ValueError`` on ``pd.infer_freq`` when index has fewer than 3 values (:pr:`6097`) :user:`tpvasconcelos`

Time series classification
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] fix ``super`` calls in deep learning classifiers and regressors (:pr:`6139`) :user:`fkiraly`
* [BUG] Resolved wrong arg name ``lr`` in ``SimpleRNNClassifier`` and regressor, fix minor ``batch_size`` param issue in ``ResNetClassifier`` (:pr:`6154`) :user:`vandit98`

Time series regression
^^^^^^^^^^^^^^^^^^^^^^

* [BUG] fix ``BaseRegressor.score`` method failing with ``sklearn.metrics r2_score got an unexpected keyword argument 'normalize`` (:pr:`6019`) :user:`Cyril-Meyer`
* [BUG] fix ``super`` calls in deep learning classifiers and regressors (:pr:`6139`) :user:`fkiraly`
* [BUG] fix network construction in ``InceptionTimeRegressor`` (:pr:`6140`) :user:`fkiraly`

Transformations
^^^^^^^^^^^^^^^

* [BUG] fix ``FeatureUnion`` for primitive outputs (:pr:`6079`) :user:`fkiraly`, :user:`fspinna`
* [BUG] Fix unexpected NaN values in ``Summarizer`` (:pr:`6081`) :user:`ShreeshaM07`
* [BUG] Update ``_shapelet_transform_numba.py`` to improve numerical stability (:pr:`6141`) :user:`stevcabello`

Test framework
^^^^^^^^^^^^^^

* [BUG] fix ``deep_equals`` when comparing ``ForecastingHorizon`` of different lengths by :user:`MBristle` (:pr:`5954`)

Webpage
^^^^^^^

* [BUG] fix search function for estimator overview not working (:pr:`6105`) :user:`duydl`

Contributors
~~~~~~~~~~~~

:user:`Abhay-Lejith`,
:user:`achoum`,
:user:`albertoazzari`,
:user:`Alex-JG3`,
:user:`astrogilda`,
:user:`benHeid`,
:user:`Cyril-Meyer`,
:user:`deysanjeeb`,
:user:`duydl`,
:user:`fkiraly`,
:user:`fnhirwa`,
:user:`fspinna`,
:user:`geetu040`,
:user:`Greyisheep`,
:user:`HassnHamada`,
:user:`ianspektor`,
:user:`javiber`,
:user:`julian-fong`,
:user:`julnow`,
:user:`KaustubhUp025`,
:user:`kcentric`,
:user:`ksharma6`,
:user:`manuel-munoz-aguirre`,
:user:`MBristle`,
:user:`MEMEO-PRO`,
:user:`meraldoantonio`,
:user:`nilesh05apr`,
:user:`pranavvp16`,
:user:`SaiRevanth25`,
:user:`sahusiddharth`,
:user:`shankariraja`,
:user:`stevcabello`,
:user:`tiloye`,
:user:`tpvasconcelos`,
:user:`vandit98`,
:user:`XinyuWuu`,
:user:`YashKhare20`


Version 0.27.0 - 2024-02-28
---------------------------

Maintenance release:

* scheduled deprecations and change actions
* support for soft dependency ``numba 0.59`` and ``numba`` under ``python 3.12``
* minor documentation updates, website updates for GSoC 2024

For last non-maintenance content updates, see 0.26.1.

Dependency changes
~~~~~~~~~~~~~~~~~~

* ``numba`` bounds have been updated to ``<0.60``.

Deprecations and removals
~~~~~~~~~~~~~~~~~~~~~~~~~

Forecasting tuners
^^^^^^^^^^^^^^^^^^

* in forecasting tuners ``ForecastingGridSearchCV``, ``ForecastingRandomizedSearchCV``,
  ``ForecastingSkoptSearchCV``, the ``joblib`` backend specific parameters ``n_jobs``,
  ``pre_dispatch`` have been removed.
  Users should pass backend parameters via the ``backend_params`` parameter instead.
  Direct replacements are ``backend='joblib'``,
  and ``n_jobs`` and ``pre_dispatch`` passed via ``backend_params``.

Transformations
^^^^^^^^^^^^^^^

* in ``SplitterSummarizer``, the ``remember_data`` argument has been removed.
  Users should use the ``fit_on`` and ``transform_on`` arguments instead.
  Logic identical argument replacements are:
  ``remember_data=True`` with ``fit_on='all_train'`` and
  ``transform_on='all_train'``; and ``remember_data=False`` with
  ``"fit_on='transform_train'`` and ``transform_on='transform_train'``.
* ``panel.dictionary_based.PAA`` has been renamed to ``PAAlegacy`` in 0.27.0,
  and ``sktime.transformations.series.PAA2`` has been renamed to ``PAA``.
  ``PAA`` is now the primary PAA implementation in ``sktime``,
  while the former ``PAA`` will continue to be available as ``PAAlegacy``.
  Both estimators are also available under their former name
  until 0.28.0.
  To prepare for the name change, do one of the following:
  1. replace use of ``PAA`` from ``sktime.transformations.panel.dictionary_based``
  by use of ``PAA2`` from ``sktime.transformations.series.paa``, switching
  parameter names appropriately, or
  2. replace use of ``PAA`` from ``sktime.transformations.panel.dictionary_based``
  by use of ``PAAlegacy`` from ``sktime.transformations.panel.dictionary_based``,
  without change of parameter values.
* ``panel.dictionary_based.SAX`` has been renamed to ``SAXlegacy`` in 0.27.0,
  while ``sktime.transformations.series.SAX2`` has been renamed to ``SAX``.
  ``SAX`` is now the primary SAX implementation in ``sktime``,
  while the former ``SAX`` will continue to be available as ``SAXlegacy``.
  Both estimators are also available under their former name
  until 0.28.0.
  To prepare for the name change, do one of the following:
  1. replace use of ``SAX`` from ``sktime.transformations.panel.dictionary_based``
  by use of ``SAX2`` from ``sktime.transformations.series.paa``, switching
  parameter names appropriately, or
  2. replace use of ``SAX`` from ``sktime.transformations.panel.dictionary_based``
  by use of ``SAXlegacy`` from ``sktime.transformations.panel.dictionary_based``,
  without change of parameter values.


Contents
~~~~~~~~

Documentation
~~~~~~~~~~~~~

* [DOC] improved formatting of ``HierarchyEnsembleForecaster`` docstring (:pr:`6008`) :user:`fkiraly`
* [DOC] add missing ``PluginParamsTransformer`` to API reference (:pr:`6010`) :user:`fkiraly`
* [DOC] update contact links in code of conduct (:pr:`6011`) :user:`fkiraly`
* [DOC] 2024 summer programme links on ``sktime.net`` landing page (:pr:`6013`) :user:`fkiraly`

Maintenance
~~~~~~~~~~~

* [MNT] 0.27.0 deprecations and change actions (:pr:`5974`) :user:`fkiraly`
* [MNT] [Dependabot](deps-dev): Update ``numba`` requirement from ``<0.59`` to ``<0.60`` (:pr:`5877`) :user:`dependabot[bot]`


Version 0.26.1 - 2024-02-26
---------------------------

Highlights
~~~~~~~~~~

* Conditional Invertible Neural Network forecaster - from 2022 BigDEAL challenge (:pr:`5339`) :user:`benHeid`
* ``neuralforecast`` adapter and rnn forecaster (:pr:`5962`) :user:`yarnabrina`
* ``FallbackForecaster`` now supports probabilistic forecasters and setting of nan handling policy (:pr:`5847`, :pr:`5924`) :user:`ninedigits`
* ``statsforecast`` ``AutoTBATS`` interface (:pr:`5908`) :user:`yarnabrina`
* k-nearest neighbor classifiers from ``pyts`` and ``tslearn`` (:pr:`5939`, :pr:`5952`) :user:`fkiraly`
* ``pyts`` ``ROCKET`` transformation (:pr:`5851`) :user:`fkiraly`
* deep learning regressors from ``sktime-dl`` migrated: FCN, LSTMFCN, MLP (:pr:`6001`) :user:`nilesh05apr`

Dependency changes
~~~~~~~~~~~~~~~~~~

* ``dask`` (data container and parallelization back-end) bounds have been updated to ``<2024.2.2``
* ``holidays`` (transformations soft dependency) bounds have been updated to ``>=0.29,<0.44``
* ``pyts`` is now a soft dependency for classification and transformations

Core interface changes
~~~~~~~~~~~~~~~~~~~~~~

Transformations
^^^^^^^^^^^^^^^

All transformation dunders now automatically coerce ``sklearn`` transformers to
``sktime`` transformers, wrapping in ``TabularToSeriesAdaptor`` is no longer necessary
when using ``sklearn`` transformers in ``sktime`` pipelines specified by dunders.

Deprecations and removals
~~~~~~~~~~~~~~~~~~~~~~~~~

Transformations
^^^^^^^^^^^^^^^

The ``n_jobs`` parameter of ``Catch22Wrapper`` has been deprecated
and will be removed in ``sktime`` 0.28.0.
Users should pass parallelization backend parameters via ``set_config`` instead.

Enhancements
~~~~~~~~~~~~

Benchmarking, Metrics, Splitters
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] efficient ``_evaluate_by_index`` for ``MeanAbsolutePercentageError`` (:pr:`5842`) :user:`fkiraly`

Data loaders
^^^^^^^^^^^^

* [ENH] add encoding parameter in data loaders (:pr:`6000`) :user:`Cyril-Meyer`

Data types, checks, conversions
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] ``polars`` based ``Table`` mtype, feature name metadata (:pr:`5757`) :user:`fkiraly`

Forecasting
^^^^^^^^^^^

* [ENH] Conditional Invertible Neural Network forecaster (:pr:`5339`) :user:`benHeid`
* [ENH] Expose seasonality parameters of ``ProphetPiecewiseLinearTrendForecaster`` (:pr:`5834`) :user:`sbuse`
* [ENH] centralize logic for safe clone of delegator tags - forecasting (:pr:`5845`) :user:`fkiraly`
* [ENH] ``FallbackForecaster`` - support for probabilistic forecasters (:pr:`5847`) :user:`ninedigits`
* [ENH] interface to ``ARIMA`` from ``statsmodels`` library (:pr:`5857`) :user:`arnaujc91`
* [ENH] Improved specificity of some error messages in forecasters and transformations (:pr:`5882`) :user:`fkiraly`
* [ENH] ``statsforecast`` ``AutoTBATS`` direct interface estimator (:pr:`5908`) :user:`yarnabrina`
* [ENH] Several updates in direct ``statsforecast`` interface estimators (:pr:`5920`) :user:`yarnabrina`
* [ENH] Add nan policy handler for ``FallbackForecaster`` (:pr:`5924`) :user:`ninedigits`
* [ENH] ``ForecastX`` option to use future-known variables as exogenous variables in forecasting future-unknown exogenous variables (:pr:`5926`) :user:`fkiraly`
* [ENH] ``neuralforecast`` adapter and rnn forecaster (:pr:`5962`) :user:`yarnabrina`
* [ENH] rearchitect ``ForecastingSkoptSearchCV`` on abstract parallelization backend (:pr:`5973`) :user:`fkiraly`
* [ENH] in ``ForecastingPipeline``, allow ``None`` ``X`` to be passed to transformers (:pr:`5977`) :user:`albahhar`, :user:`fkiraly`

Time series annotation
^^^^^^^^^^^^^^^^^^^^^^

* [ENH] second set of test parameters for ``GMMHMM`` (:pr:`5931`) :user:`sanjayk0508`

Time series classification
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] k-nearest neighbors classifier: support for non-brute algorithms and non-precomputed mode to improve memory efficiency (:pr:`5937`) :user:`fkiraly`
* [ENH] adapter to ``pyts`` ``KNeighborsClassifier`` (:pr:`5939`) :user:`fkiraly`
* [ENH] adapter to ``tslearn`` ``KNeighborsTimeSeriesClassifier`` (:pr:`5952`) :user:`fkiraly`
* [ENH] Feature importance capability tag for classifiers (:pr:`5969`) :user:`sanjayk0508`

Time series regression
^^^^^^^^^^^^^^^^^^^^^^

* [ENH] Migrate DL regressors from ``sktime-dl``: FCN, LSTMFCN, MLP (:pr:`6001`) :user:`nilesh05apr`

Transformations
^^^^^^^^^^^^^^^

* [ENH] ``pyts`` adapter and interface to ``pyts`` ``ROCKET`` (:pr:`5851`) :user:`fkiraly`
* [ENH] in transformer dunders, uniformize coercion of ``sklearn`` transformers (:pr:`5869`) :user:`fkiraly`
* [ENH] Improved specificity of some error messages in forecasters and transformations (:pr:`5882`) :user:`fkiraly`
* [ENH] second set of test parameters for ``TSInterpolator`` (:pr:`5910`) :user:`sanjayk0508`
* [ENH] improved output type checking error messages in ``BaseTransformer.transform`` (:pr:`5921`) :user:`fkiraly`
* [ENH] refactor ``Catch22Wrapper`` transformer to use ``pd.Series`` type internally (:pr:`5983`) :user:`fkiraly`

Test framework
^^^^^^^^^^^^^^

* [ENH] testing estimators whose package dependencies are changed in ``pyproject.toml`` (:pr:`5727`) :user:`fkiraly`


Fixes
~~~~~

Forecasting
^^^^^^^^^^^

* [BUG] Remove duplicative setting of ``_fh`` and ``_y`` in _fit of ``_pytorch.py`` (:pr:`5889`) :user:`benHeid`
* [BUG] ``BaseForecaster`` - move ``check_fh`` to inner loop if vectorized (:pr:`5900`) :user:`ciaran-g`
* [BUG] fix sporadic failure of ``ConformalIntervals`` if ``sample_frac`` is too low (:pr:`59/2`) :user:`fkiraly`

Pipelines
^^^^^^^^^

* [BUG] In ``Pipeline``, empty dummy step's buffer only if new data arrive (:pr:`5837`) :user:`benHeid`

Probability distributions and simulators
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] fix missing loc/scale in ``TDistribution`` methods (:pr:`5942`) :user:`ivarzap`

Time series classification
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] corrected default loss function to ``CNNClassifier`` (:pr:`5852`) :user:`Vasudeva-bit`
* [BUG] fix ``BaseClassifier.fit_predict`` for multioutput ``y`` and non-none ``cv`` (:pr:`5928`) :user:`fkiraly`
* [BUG] fix input check error message in ``BaseTransformer`` (:pr:`5947`) :user:`fkiraly`

Transformations
^^^^^^^^^^^^^^^

* [BUG] fix input check error message in `BaseTransformer` (:pr:`5947`) :user:`fkiraly`
* [BUG] Fixed transform method of MSTL transformer (:pr:`5996`) :user:`Abhay-Lejith`


Maintenance
~~~~~~~~~~~

* [MNT] improvements to modular CI framework - part 2, merge frameworks (:pr:`5785`) :user:`fkiraly`
* [MNT] ``pandas 2.2.X`` compatibility fixes (:pr:`5840`) :user:`fkiraly`
* [MNT] fix moto breaking change by using different mocking methods depending on version (:pr:`5858`) :user:`yarnabrina`
* [MNT] address some ``pandas`` deprecations (:pr:`5883`) :user:`fkiraly`
* [MNT] addressed ``FutureWarning`` for RMSE by using newer ``root_mean_absolute_error`` function (:pr:`5884`) :user:`yarnabrina`
* [MNT] Skip ``mlflow`` tests when soft-dependencies are absent (:pr:`5888`) :user:`achieveordie`
* [MNT] fix failing CRON "test all" workflow (:pr:`5925`) :user:`fkiraly`
* [MNT] update versions of several actions (:pr:`5929`) :user:`yarnabrina`
* [MNT] Add codecov token to coverage uploads (:pr:`5930`) :user:`yarnabrina`
* [MNT] CI on main fix: add checkout step to detect steps in CI (:pr:`5945`) :user:`fkiraly`
* [MNT] address some upcoming deprecations (:pr:`5971`) :user:`fkiraly`
* [MNT] avoid running unit tests in CI for documentation/template/etc changes (:pr:`5976`) :user:`yarnabrina`
* [MNT] [Dependabot](deps-dev): Update dask requirement from ``<2024.1.1`` to ``<2024.1.2`` (:pr:`5861`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps-dev): Update dask requirement from ``<2024.1.2`` to ``<2024.2.1`` (:pr:`5958`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps-dev): Update holidays requirement from ``<0.43,>=0.29`` to ``>=0.29,<0.44`` (:pr:`5965`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps-dev): Update dask requirement from ``<2024.2.1`` to ``<2024.2.2`` (:pr:`5991`) :user:`dependabot[bot]`


Documentation
~~~~~~~~~~~~~

* [DOC] recipes for simple parameter change and deprecation management (:pr:`5875`) :user:`fkiraly`
* [DOC] improved deprecation recipes (:pr:`5890`) :user:`fkiraly`
* [DOC] fixing broken link to ``DropNA`` in API reference (:pr:`5899`) :user:`sbuse`
* [DOC] remove obsolete request for contribution (python 3.10 compatibility) in install docs (:pr:`5901`) :user:`fkiraly`
* [DOC] use tags for estimator overview (:pr:`5906`) :user:`fkiraly`
* [DOC] add "maintainers" column to estimator overview (:pr:`5911`) :user:`fkiraly`
* [DOC] fix ``ARDL`` API reference (:pr:`5912`) :user:`fkiraly`
* [DOC] add GitHub ID hyperlinks in estimator table (:pr:`5916`) :user:`fkiraly`
* [DOC] fix odd formatting in deprecation timeline example (:pr:`5957`) :user:`fkiraly`
* [DOC] improved glossary and forecasting docstrings (:pr:`5968`) :user:`fkiraly`
* [DOC] remove type annotations in extension templates (:pr:`5970`) :user:`fkiraly`
* [DOC] Typo in documentation, fixed monotonous to monotonic  (:pr:`5946`) :user:`eduardojp26`
* [DOC] fixed typo in docstring (:pr:`5949`) :user:`yarnabrina`
* [DOC] fixed typo in docstring (:pr:`5950`) :user:`yarnabrina`
* [DOC] format docstrings in ``feature_selection.py`` correctly (:pr:`5994`) :user:`oleeviyababu`


Contributors
~~~~~~~~~~~~

:user:`Abhay-Lejith`,
:user:`achieveordie`,
:user:`albahhar`,
:user:`arnaujc91`,
:user:`benHeid`,
:user:`ciaran-g`,
:user:`Cyril-Meyer`,
:user:`eduardojp26`,
:user:`fkiraly`,
:user:`ivarzap`,
:user:`ninedigits`,
:user:`oleeviyababu`,
:user:`sanjayk0508`,
:user:`sbuse`,
:user:`Vasudeva-bit`,
:user:`yarnabrina`


Version 0.26.0 - 2024-01-27
---------------------------

Maintenance release:

* support for ``scikit-learn 1.4.X``
* scheduled deprecations
* minor bugfix

For last non-maintenance content updates, see 0.25.1.

Dependency changes
~~~~~~~~~~~~~~~~~~

* ``scikit-learn`` bounds have been updated to ``>=0.24.0,<1.5.0``.

Deprecations and removals
~~~~~~~~~~~~~~~~~~~~~~~~~

Benchmarking, Metrics, Splitters
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* in forecasting ``evaluate``, ``kwargs`` have been removed.
  Users should pass backend parameters via the ``backend_params``
  parameter instead.

Data types, checks, conversions
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* in ``check_is_mtype``, the default of ``msg_return_dict`` has now changed to ``"dict"``

Forecasting tuners
^^^^^^^^^^^^^^^^^^

* in forecasting tuners ``ForecastingGridSearchCV``, ``ForecastingRandomizedSearchCV``,
  ``ForecastingSkoptSearchCV``, use of ``joblib`` backend specific parameters ``n_jobs``,
  ``pre_dispatch`` has been deprecated, and will be removed in ``sktime`` 0.27.0.
  Users should pass backend parameters via the ``backend_params`` parameter instead.

Time series classification
^^^^^^^^^^^^^^^^^^^^^^^^^^

* In ``SimpleRNNClassifier``, the ``num_epochs`` parameter has been
  renamed to ``n_epochs``. The original parameter of name ``num_epochs`` has now
  been removed.

Time series regression
^^^^^^^^^^^^^^^^^^^^^^

* In ``SimpleRNNRegressor``, the ``num_epochs`` parameter has been
  renamed to ``n_epochs``. The original parameter of name ``num_epochs`` has now
  been removed.

Contents
~~~~~~~~

* [MNT] 0.26.0 deprecations and change actions (:pr:`5817`) :user:`fkiraly`
* [MNT] [Dependabot](deps-dev): Update ``scikit-learn`` requirement from
  ``<1.4.0,>=0.24`` to ``>=0.24,<1.5.0`` (:pr:`5776`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Bump styfle/cancel-workflow-action from ``0.12.0``
  to ``0.12.1`` (:pr:`5839`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Bump dorny/paths-filter
  from ``2`` to ``3`` (:pr:`5838`) :user:`dependabot[bot]`
* [BUG] fix tag handling in ``IgnoreX`` (:pr:`5843`) :user:`tpvasconcelos`, :user:`fkiraly`


Version 0.25.1 - 2024-01-24
---------------------------

Highlights
~~~~~~~~~~

* in ``make_reduction``, direct reduction forecaster now supports probabilistic tabular regressors from ``skpro`` (:pr:`5536`) :user:`fkiraly`
* new, efficient, parallelizable PAA and SAX transformer implementations, available as ``PAA2``, ``SAX2`` (:pr:`5742`) :user:`steenrotsman`
* ``FallbackForecaster``, fallback chain of multiple forecaster for exception handling (:pr:`5779`) :user:`ninedigits`
* time series classification: ``sktime`` native grid search, multiplexer for autoML (:pr:`4596`, :pr:`5678`) :user:`achieveordie`, :user:`fkiraly`
* ``IgnoreX`` - forecasting compositor to ignore exogenous data, for use in tuning (:pr:`5769`) :user:`hliebert`, :user:`fkiraly`
* classifier migrated from ``sktime-dl``: CNTC classifier (:pr:`3978`) :user:`aurumnpegasus`
* authors and maintainers of algorithms are now tracked via tags ``"authors"`` and ``"maintainers"``, see below

Dependency changes
~~~~~~~~~~~~~~~~~~

* ``arch`` (forecasting and parameter estimation soft dependency) bounds have been updated to ``>=5.6,<6.4.0`` (:pr:`5771`) :user:`dependabot[bot]`
* ``mne`` (transformations soft dependency) bounds have been updated to  ``>=1.5,<1.7`` (:pr:`5585`) :user:`dependabot[bot]`
* ``dask`` (data container and parallelization back-end) bounds have been updated to ``<2024.1.1`` (:pr:`5748`) :user:`dependabot[bot]`

Core interface changes
~~~~~~~~~~~~~~~~~~~~~~

BaseObject and base framework
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* estimators and objects now record author and maintainer information in the new
  tags ``"authors"`` and ``"maintainers"``. This is required only for estimators
  in ``sktime`` proper and compatible third party packages. It is also used to generate
  mini-package headers used in lookup functionality of the ``sktime`` webpage.
* author and maintainer information in the ``sktime`` package is no longer recorded in
  ``CODEOWNERS``, but in the new tags ``"authors"`` and ``"maintainers"``.
  Authors and maintainer do not need to action this change, as it has been carried out
  by the ``sktime`` maintainers. However, authors and maintainers are encouraged to
  check the information in the tags, and to flag any accidental omissions or errors.

Benchmarking, Metrics, Splitters
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* forecasting point prediction metrics now also support parallelization via
  ``set_config``, for broadcasting on hierarchical or multivariate data

Forecasting
^^^^^^^^^^^

* forecasters can now be prevented from storing a reference to all seen data
  as ``self._y`` and ``self._X`` by setting the config ``"remember_data"`` to
  ``False`` via ``set_config``. This is useful for serialization of forecasters.
  Currently, the setting is only supported for a combination of data and forecasters
  where instance or variable broadcasting is not triggered,
  but the feature will be extended to all situations in the future.

Parameter estimation and hypothesis testing
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* Parameter plugin or estimation based parameter tuning estimators can now be quickly constructed
  with the ``*`` dunder, which will construct a ``PluginParamsForecaster`` or ``PluginParamsTransformer``
  with all fitted parameters (``get_fitted_params``) of the left element plugged in into the right element
  (``set_params``), where parameter names match.
  For instance, ``SeasonalityACF() * Deseasonalizer()`` will construct
  a ``Deseasonalizer`` whose ``sp`` (seasonality period) parameter is tuned
  by ``SeasonalityACF``,  estimating ``sp`` via the ACF significance criterion on the series.
* The ``*`` dunder binds to the left, for instance
  ``Differencer() * SeasonalityACF() * Deseasonalizer()`` will construct
  a ``Deseasonalizer`` whose ``sp`` (seasonality period) parameter is tuned
  by ``SeasonalityACF``, estimating ``sp`` via the ACF significance criterion
  on first differenced data (for stationarity).
  Here first differencing is not applied to the ``Deseasonalizer``,
  but only to the input of ``SeasonalityACF``, as the first ``*`` constructs
  a parameter estimator, and the second ``*`` plugs in the parameter estimator into
  the ``Deseasonalizer``.

Transformations
^^^^^^^^^^^^^^^

* transformations, i.e., ``BaseTransformer`` descendant instances,
  can now also return ``None`` in ``_transform``, this is interpreted as empty data.

Deprecations and removals
~~~~~~~~~~~~~~~~~~~~~~~~~

Transformations
^^^^^^^^^^^^^^^

* ``panel.dictionary_based.PAA`` will be renamed to ``PAAlegacy`` in ``sktime`` 0.27.0,
  while ``sktime.transformations.series.PAA2`` will be renamed to ``PAA``.
  ``PAA2`` will become the primary PAA implementation in ``sktime``,
  while the current ``PAA`` will continue to be available as ``PAAlegacy``.
  Both estimators are also available under their future name at their
  current location, and will be available under their deprecated name
  until 0.28.0.
  To prepare for the name change, do one of the following:
  1. replace use of ``PAA`` from ``sktime.transformations.panel.dictionary_based``
  by use of ``PAA2`` from ``sktime.transformations.series.paa``, switching
  parameter names appropriately, or
  2. replace use of ``PAA`` from ``sktime.transformations.panel.dictionary_based``
  by use of ``PAAlegacy`` from ``sktime.transformations.panel.dictionary_based``,
  without change of parameter values.
* ``panel.dictionary_based.SAX`` will be renamed to ``SAXlegacy`` in ``sktime`` 0.27.0,
  while ``sktime.transformations.series.SAX2`` will be renamed to ``SAX``.
  ``SAX2`` will become the primary SAX implementation in ``sktime``,
  while the current ``SAX`` will continue to be available as ``SAXlegacy``.
  Both estimators are also available under their future name at their
  current location, and will be available under their deprecated name
  until 0.28.0.
  To prepare for the name change, do one of the following:
  1. replace use of ``SAX`` from ``sktime.transformations.panel.dictionary_based``
  by use of ``SAX2`` from ``sktime.transformations.series.paa``, switching
  parameter names appropriately, or
  2. replace use of ``SAX`` from ``sktime.transformations.panel.dictionary_based``
  by use of ``SAXlegacy`` from ``sktime.transformations.panel.dictionary_based``,
  without change of parameter values.

Enhancements
~~~~~~~~~~~~

BaseObject and base framework
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] update ``deep_equals`` to accommodate plugins, e.g., for ``polars`` (:pr:`5504`) :user:`fkiraly`
* [ENH] Replace ``isinstance`` by ``object_type`` tag based checks (:pr:`5657`) :user:`benheid`
* [ENH] author and maintainer tags (:pr:`5754`) :user:`fkiraly`
* [ENH] enable ``all_tags`` to retrieve estimator and object tags (:pr:`5798`) :user:`fkiraly`
* [ENH] remove maintainer information from ``CODEOWNERS`` in favour of estimator tags (:pr:`5808`) :user:`fkiraly`
* [ENH] author and maintainer tags for alignment and distances modules (:pr:`5801`) :user:`fkiraly`
* [ENH] author and maintainer tags for forecasting module (:pr:`5802`) :user:`fkiraly`
* [ENH] author and maintainer tags for distributions and parameter fitting module (:pr:`5803`) :user:`fkiraly`
* [ENH] author and maintainer tags for classification, clustering and regression modules (:pr:`5807`) :user:`fkiraly`
* [ENH] author and maintainer tags for transformer module (:pr:`5800`) :user:`fkiraly`

Benchmarking, Metrics, Splitters
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] Repeat splitter composition (:pr:`5737`) :user:`fkiraly`
* [ENH] parallelization support and config for forecasting performance metrics (:pr:`5813`) :user:`fkiraly`

Data types, checks, conversions
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] in ``VectorizedDF``, partially decouple internal data store from methods (:pr:`5681`) :user:`fkiraly`

Forecasting
^^^^^^^^^^^

* [ENH] ``Imputer``: conditional parameter handling logic (:pr:`3916`) :user:`aiwalter`, :user:`fkiraly``
* [ENH] support for probabilistic regressors (``skpro``) in ``make_reduction``, direct reduction (:pr:`5536`) :user:`fkiraly`
* [ENH] private utility for ``BaseForecaster`` get columns, for all ``predict``-like functions (:pr:`5590`) :user:`fkiraly`
* [ENH] adding second test parameters for ``TBATS`` (:pr:`5689`) :user:`NguyenChienFelix33`
* [ENH] config to turn off data memory in forecasters (:pr:`5676`) :user:`fkiraly`, :user:`corradomio`
* [ENH] Simplify conditional statements in direct reducer (:pr:`5725`) :user:`fkiraly`
* [ENH] forecasting compositor to ignore exogenous data (:pr:`5769`) :user:`hliebert`, :user:`fkiraly`
* [ENH] add ``disp`` parameter to ``SARIMAX`` to control output verbosity (:pr:`5770`) :user:`tvdboom`
* [ENH] expose parameters supported by ``fit`` method of ``SARIMAX`` in ``statsmodels`` (:pr:`5787`) :user:`yarnabrina`
* [ENH] ``FallbackForecaster``, fallback upon fail with multiple forecaster chain (:pr:`5779`) :user:`ninedigits`

Parameter estimation and hypothesis testing
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] Simplify ``BaseEstimator._get_fitted_params()`` and ``BaseParamFitter`` inheritance of that method (:pr:`5633`) :user:`tpvasconcelos`
* [ENH] parameter plugin for estimator into transformers, right concat dunder (:pr:`5764`) :user:`fkiraly`

Probability distributions and simulators
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] bring distributions module on par with ``skpro`` distributions (:pr:`5708`) :user:`fkiraly`, :user:`alex-jg3`

Time series classification
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] migrating CNTC network and classifier for classification from ``sktime-dl`` (:pr:`3978`) :user:`aurumnpegasus`, :user:`fkiraly`
* [ENH] grid search for time series classification (:pr:`4596`) :user:`achieveordie`, :user:`fkiraly`
* [ENH] reduce private coupling of ``IndividualBOSS`` classifier and ``BaseClassifier`` (:pr:`5654`) :user:`fkiraly`
* [ENH] multiplexer classifier (:pr:`5678`) :user:`fkiraly`
* [ENH] refactor structure of time series forest classifier related files (:pr:`5751`) :user:`fkiraly`

Transformations
^^^^^^^^^^^^^^^

* [ENH] better explanation about fit/transform instance linking in instance-wise transformers in error messages, and pointer to common solution (:pr:`5652`) :user:`fkiraly`
* [ENH] New ``PAA`` and ``SAX`` transformer implementations (:pr:`5742`) :user:`steenrotsman`
* [ENH] feature upgrade for ``SplitterSummarizer`` - granular control of inner ``fit``/``transform`` input (:pr:`5750`) :user:`fkiraly`
* [ENH] allow ``BaseTransformer._transform`` to return ``None`` (:pr:`5772`) :user:`fkiraly`, :user:`hliebert`

Test framework
^^^^^^^^^^^^^^

* [ENH] refactor tests with parallelization backend fixtures to programmatic backend fixture lookup (:pr:`5714`) :user:`fkiraly`
* [ENH] further refactor parallelization backend test fixtures to use central location (:pr:`5734`) :user:`fkiraly`


Fixes
~~~~~

BaseObject and base framework
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] fix scitype inference utility for all cases (:pr:`5672`) :user:`fkiraly`
* [BUG] fixes for minor typos in error message related to custom ``joblib`` backend selection (:pr:`5724`) :user:`fkiraly`
* [BUG] handles ``AttributeError`` in ``show_versions`` when dependency lacks ``__version__`` (:pr:`5793`) :user:`yarnabrina`
* [BUG] fix type error in parallelization backend test fixture refactor (:pr:`5760`) :user:`fkiraly`

Benchmarking, Metrics, Splitters
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] Fix dynamic ``make_forecasting_scorer`` for newer ``sklearn`` metrics (:pr:`5717`) :user:`fkiraly`
* [BUG] fix ``test_evaluate_error_score`` to skip test of expected warning raised if the ``joblib`` backend is ``"loky"`` or ``"multiprocessing"`` (:pr:`5780`) :user:`fkiraly`

Data loaders
^^^^^^^^^^^^

* [BUG] fix ``extract_path`` arg in ``sktime.datasets.load_UCR_UEA_dataset`` (:pr:`5744`) :user:`steenrotsman`

Data types, checks, conversions
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] fix ``deep_equals`` for ``np.array`` with ``dtype="object"`` (:pr:`5697`) :user:`fkiraly`

Forecasting
^^^^^^^^^^^

* [BUG] fix ``ForecastingHorizon.get_expected_pred_idx`` ``sort_time`` (:pr:`5726`) :user:`fkiraly`
* [BUG] in ``BaggingForecaster``, fix ``random_state`` handling (:pr:`5730`) :user:`fkiraly`

Pipelines
^^^^^^^^^

* [BUG] Enable ``pipeline.fit`` without X (:pr:`5656`) :user:`benheid`

Time series classification
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] fix ``predict`` output conversion failure in ``BaseClassifier``, ``BaseRegressor``, if ``y_inner_mtype`` tag is a list (:pr:`5680`) :user:`fkiraly`
* [BUG] fix ``test_multioutput`` for genuinely multioutput classifiers (:pr:`5700`) :user:`fkiraly`

Time series regression
^^^^^^^^^^^^^^^^^^^^^^

* [BUG] fix ``predict`` output conversion failure in ``BaseClassifier``, ``BaseRegressor``, if ``y_inner_mtype`` tag is a list (:pr:`5680`) :user:`fkiraly`

Transformations
^^^^^^^^^^^^^^^

* [BUG] skip sporadic test errors in ``ExponentialSmoothing`` (:pr:`5516`) :user:`achieveordie`
* [BUG] fix sporadic permutation of internal feature columns in ``TSFreshClassifier.predict`` (:pr:`5673`) :user:`fkiraly`
* [BUG] fix backend strings in transformer ``test_base`` (:pr:`5695`) :user:`fkiraly`
* [BUG] Ensure ``MultiRocketMultivariate`` uses ``random_state`` (:pr:`5710`) :user:`chrico-bu-uab`

Test framework
^^^^^^^^^^^^^^

* [BUG] Fixing dockerized tests (:pr:`5426`) :user:`kurayami07734`


Maintenance
~~~~~~~~~~~

* [MNT] [Dependabot](deps-dev): Update sphinx-issues requirement from ``<4.0.0`` to ``<5.0.0`` (:pr:`5792`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Bump tj-actions/changed-files from 41 to 42 (:pr:`5777`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps-dev): Update arch requirement from ``<6.3.0,>=5.6`` to ``>=5.6,<6.4.0`` (:pr:`5771`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps-dev): Update mne requirement from ``<1.6,>=1.5`` to ``>=1.5,<1.7`` (:pr:`5585`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps-dev): Update dask requirement from ``<2023.12.2`` to ``<2024.1.1`` (:pr:`5748`) :user:`dependabot[bot]`
* [MNT] improvements to modular CI framework - clearer naming, ``pyproject`` handling (:pr:`5713`) :user:`fkiraly`
* [MNT] temporary deactivation of new CI (:pr:`5795`) :user:`fkiraly`
* [MNT] fix faulty deprecation logic for ``n_jobs``, ``pre_dispatch`` in forecasting tuners, bump deprecation to 0.27.0 (:pr:`5784`) :user:`fkiraly`
* [MNT] update python version in binder dockerfile to 3.11 (:pr:`5762`) :user:`fkiraly`
* [MNT] address various deprecations from ``pandas`` (:pr:`5733`) :user:`fkiraly`, :user:`yarnabrina`
* [MNT] ``scikit-learn 1.4.0`` compatibility patches (:pr:`5782`, :pr:`5811`) :user:`fkiraly`
* [MNT] Code quality updates (:pr:`5786`) :user:`yarnabrina`
* [MNT] change cycle for making ``SAX2`` and ``PAA2`` primary implementation renamed to ``SAX``, ``PAA`` (:pr:`5799`) :user:`fkiraly`
* [MNT] remove maintainer information from ``CODEOWNERS`` in favour of estimator tags (:pr:`5808`) :user:`fkiraly`
* [MNT] addressing more ``pandas`` deprecations (:pr:`5816`) :user:`fkiraly`
* [MNT] address ``pd.DataFrame.groupby(axis=1)`` deprecation in ``EnsembleForecaster`` (:pr:`5707`) :user:`ninedigits`
* [MNT] add missing ``__author__`` field for ``MultiRocket`` and ``MultiRocketMultivariate`` (:pr:`5698`) :user:`fkiraly`
* [MNT] addressing ``DataFrame.groupby(axis=1)`` deprecation in metric classes (:pr:`5709`) :user:`fkiraly`
* [MNT] added upper bound ``pycatch22<0.4.5`` in ``transformations`` dependency set to avoid installation error on windows (:pr:`5670`) :user:`yarnabrina`
* [MNT] refactoring new CI to fix some bugs and other minor enhancements (:pr:`5638`) :user:`yarnabrina`
* [MNT] Update ``tslearn`` dependency version in pyproject.toml (:pr:`5686`) :user:`DManowitz`
* [MNT] fix several spelling mistakes (:pr:`5639`) :user:`yarnabrina`

Documentation
~~~~~~~~~~~~~

* [DOC] comment in ``CONTRIBUTORS.md`` that source file is ``all-contributorsrc`` (:pr:`5687`) :user:`fkiraly`
* [DOC] improved docstring for ``TrendForecaster`` and ``PolynomialTrendForecaster`` (:pr:`5747`) :user:`fkiraly`
* [DOC] updated algorithm inclusion guide (:pr:`5753`) :user:`fkiraly`
* [DOC] improved docstring for ``TimeSeriesForestClassifier`` (:pr:`5741`) :user:`fkiraly`
* [DOC] fix ``scitype`` string of transformers in API ref (:pr:`5759`) :user:`fkiraly`
* [DOC] improved formatting of tag section in extension templates (:pr:`5812`) :user:`fkiraly`
* [DOC] ``Imputer``: docstring clarity improvement, conditional parameter handling logic (:pr:`3916`) :user:`aiwalter`, :user:`fkiraly``
* [DOC] extension template for time series splitters (:pr:`5769`) :user:`fkiraly`
* [DOC] update soft dependency handling guide for tests with tag based dependency checking (:pr:`5756`) :user:`fkiraly`
* [DOC] fix all import failures in API docs and related missing exports (:pr:`5752`) :user:`fkiraly`
* [DOC] improve clarity in describing ``strategy="refit"`` in forecasting tuners' docstrings (:pr:`5711`) :user:`fkiraly`
* [DOC] correct type statement in forecasting tuner regarding ``forecaster`` (:pr:`5699`) :user:`fkiraly`
* [DOC] various minor API reference improvements (:pr:`5721`) :user:`fkiraly`
* [DOC] add ``ReducerTransform`` and ``DirectReductionForecaster`` to API reference (:pr:`5690`) :user:`fkiraly`
* [DOC] remove outdated ``sktime-dl`` reference in ``README.md`` (:pr:`5685`) :user:`fkiraly`

Contributors
~~~~~~~~~~~~

:user:`achieveordie`,
:user:`aiwalter`,
:user:`alex-jg3`,
:user:`aurumnpegasus`,
:user:`benheid`,
:user:`chrico-bu-uab`,
:user:`corradomio`,
:user:`DManowitz`,
:user:`fkiraly`,
:user:`hliebert`,
:user:`NguyenChienFelix33`,
:user:`ninedigits`,
:user:`kurayami07734`,
:user:`steenrotsman`,
:user:`tpvasconcelos`,
:user:`tvdboom`,
:user:`yarnabrina`


Version 0.25.0 - 2023-12-26
---------------------------

Release with base class updates and scheduled deprecations:

* framework support for multioutput classifiers, regressors
  (:pr:`5408`, :pr:`5651`, :pr:`5662`) :user:`Vasudeva-bit`, :user:`fkiraly`
* framework support for panel-to-series transformers (:pr:`5351`) :user:`benHeid`
* scheduled deprecations

For last larger feature update, see 0.24.2.

Core interface changes
~~~~~~~~~~~~~~~~~~~~~~

Time series classification and regression
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* the base class framework now supports multioutput classifiers or regressors.
  All classifiers and regressors are now able to make multioutput predictions,
  including all third party classifiers and regressors.
  A multioutput ``y`` can now be passed, in the form of a 2D ``np.ndarray`` or
  ``pd.DataFrame``, with one column per output.
  The ``predict`` method will then return a predicted output of the same type.
  To retain downwards compatibility, ``predict`` will always return a 1D ``np.ndarray``
  for univariate outputs, this is currently not subject to deprecation.

* Genuinely multioutput classifiers and regressors are labelled with the new
  tag ``capability:multioutput`` being ``True``.
  All other classifiers and regressors broadcast by column of ``y``,
  and a parallelization backend can be selected via ``set_config``,
  by setting the ``backend:parallel`` and ``backend:parallel:params`` configuration
  flags, see the ``set_config`` docstring for details.
  Broadcasting extends automatically to all existing third party classifiers
  and regressors via base class inheritance once ``sktime`` is updated,
  the estimator classes themselves do not need to be updated.

* classifiers and regressors now have a tag ``y_inner_mtype``, this allows extenders
  to specify an internal ``mtype``, of ``Table`` scitype.
  The mtype specified i the tag is the guaranteed
  mtype of ``y`` seen in the private ``_fit`` method.
  The default is the same as previously
  implicit, the ``numpy1D`` mtype.
  Therefore, third party classifiers and regressors do not need to be updated,
  and should be fully upwards compatible.

Transformations
^^^^^^^^^^^^^^^

* the base class framework now supports transformations that aggregate ``Panel`` data
  to ``Series`` data, i.e., panel-to-series transformers, e.g., averaging.
  Such transformers are identified by the tags
  ``scitype:transform-input`` being ``"Panel"``,
  and ``scitype:transform-output`` being ``"Series"``.
  An example is ``Merger``.

Deprecations and removals
~~~~~~~~~~~~~~~~~~~~~~~~~

Benchmarking, Metrics, Splitters
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* time series splitters, i.e., descendants of ``BaseSplitter``, have moved from
  ``sktime.forecasting.model_selection`` to ``sktime.split``.
  They are no longer available in the old location
  ``sktime.forecasting.model_selection``, since 0.25.0.
  Forecasting tuners are still present in ``sktime.forecasting.model_selection``,
  and their locationn is not subject to deprecation.

* in forecasting ``evaluate``, the order of columns in the return data frame
  has changed. Users should consult the docstring of ``evaluate`` for details.

* in forecasting ``evaluate``, the ``compute`` argument was removed,
  after deprecation in 0.24.0.
  Its purpose was to distinguish lazy or eager evaluation in
  the ``dask`` parallelization backend.
  To switch between lazy and eager evaluation, users should instead
  select ``dask`` or ``dask_lazy`` via the ``backend`` parameter.

* in forecasting ``evaluate``, ``kwargs`` are deprecated, removal has been
  moved to 0.26.0. Users should pass backend parameters via the ``backend_params``
  parameter instead.


Contents
~~~~~~~~

* [ENH] Multioutput capability for all time series classifiers and regressors, broadcasting and tag (:pr:`5408`) :user:`Vasudeva-bit`
* [ENH] Support for panel-to-series transformers, merger transformation (:pr:`5351`) :user:`benHeid`
* [ENH] allow object ``dtype``-s in ``pandas`` based ``Table`` mtype-s (:pr:`5651`) :user:`fkiraly`
* [ENH] intermediate base class for panel tasks - classification, regression (:pr:`5662`) :user:`fkiraly`
* [MNT] CI element to test blogpost notebooks (:pr:`5663`) :user:`fkiraly`, :user:`yarnabrina`
* [MNT] 0.25.0 deprecations and change actions (:pr:`5613`) :user:`fkiraly`

Contributors
~~~~~~~~~~~~

:user:`benHeid`,
:user:`fkiraly`,
:user:`Vasudeva-bit`,
:user:`yarnabrina`

Version 0.24.2 - 2023-12-24
---------------------------

Highlights
~~~~~~~~~~

* ``FunctionParamFitter`` for custom parameter switching, e.g., applying forecaster or transformer
  conditional on instance properties (:pr:`5630`) :user:`tpvasconcelos`
* ``calibration_plot`` for probabilistic forecasts (:pr:`5632`) :user:`benHeid`
* ``prophet`` based piecewise linear trend forecaster (:pr:`5592`) :user:`sbuse`
* new transformer: dilation mapping (:pr:`5557`) :user:`fspinna`
* custom ``joblib`` backends are now supported in parallelization via ``set_config`` (:pr:`5537`) :user:`fkiraly`

Dependency changes
~~~~~~~~~~~~~~~~~~

* ``dask`` (data container and parallelization back-end) bounds have been updated to ``<2023.12.2``.
* ``holidays`` (transformations soft dependency) bounds have been updated to ``>=0.29,<0.40``.

Core interface changes
~~~~~~~~~~~~~~~~~~~~~~

Forecasting
^^^^^^^^^^^

* ``fit_predict`` now allows specification of ``X_pred`` argument for ``predict``.
  If passed, ``X_pred`` is used as ``X`` in ``predict``, instead of ``X``.
  This is useful for forecasters that expect ``X`` to be subset to the
  forecasting horizon.
* custom ``joblib`` backends for hierarchical and multivariate forecast broadcasting
  are now supported. To use a custom ``joblib`` backend, use ``set_config`` to
  set the ``backend:parallel`` configuration flag to ``"joblib"``,
  and set the ``backend`` parameter in the ``dict`` set via ``backend:parallel:params``
  to the name of the custom ``joblib`` backend. Further backend parameters
  can be passed in the same ``dict``. See docstring of ``set_config`` for details.

Time series classification
^^^^^^^^^^^^^^^^^^^^^^^^^^

* In ``SimpleRNNClassifier``, the ``num_epochs`` parameter is deprecated and has been
  renamed to ``n_epochs``. ``num_epochs`` can be used until ``sktime`` 0.25.last,
  but will be removed in ``sktime`` 0.26.0. A deprecation warning is raised if
  ``num_epochs`` is used.

Time series regression
^^^^^^^^^^^^^^^^^^^^^^

* In ``SimpleRNNRegressor``, the ``num_epochs`` parameter is deprecated and has been
  renamed to ``n_epochs``. ``num_epochs`` can be used until ``sktime`` 0.25.last,
  but will be removed in ``sktime`` 0.26.0. A deprecation warning is raised if
  ``num_epochs`` is used.

Transformations
^^^^^^^^^^^^^^^

* custom ``joblib`` backends for hierarchical and multivariate transformer broadcasting
  are now supported. To use a custom ``joblib`` backend, use ``set_config`` to
  set the ``backend:parallel`` configuration flag to ``"joblib"``,
  and set the ``backend`` parameter in the ``dict`` set via ``backend:parallel:params``
  to the name of the custom ``joblib`` backend. Further backend parameters
  can be passed in the same ``dict``. See docstring of ``set_config`` for details.

Enhancements
~~~~~~~~~~~~

BaseObject and base framework
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] improved error messages for input checks in base classes (:pr:`5510`) :user:`fkiraly`
* [ENH] support for custom ``joblib`` backends in parallelization (:pr:`5537`) :user:`fkiraly`
* [ENH] consistent use of ``np.ndarray`` for mtype tags (:pr:`5648`) :user:`fkiraly`
* [ENH] set output format parameter in ``sktime`` internal ``check_is_mtype`` calls to silence deprecation warnings (:pr:`5563`) :user:`benHeid`

Benchmarking, Metrics, Splitters
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] cutoff and forecasting horizon ``loc`` based splitter (:pr:`5575`) :user:`fkiraly`
* [ENH] enable tag related registry tests for ``splitter`` estimator type (:pr:`5576`) :user:`fkiraly`

Data types, checks, conversions
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] ``sklearn`` facing coercion utility for ``pd.DataFrame``, to ``str`` columns (:pr:`5550`) :user:`fkiraly`
* [ENH] ``deep_equals`` - clearer return on diffs from ``dtypes`` and ``index``, relaxation of ``MultiIndex`` equality check (:pr:`5560`) :user:`fkiraly`
* [ENH] Uniformization of ``pandas`` index types in mtypes (:pr:`5561`) :user:`fkiraly`
* [ENH] ``n_features`` and ``feature_names`` metadata field for time series mtypes (:pr:`5596`) :user:`fkiraly`

Forecasting
^^^^^^^^^^^

* [ENH] expected forecast prediction index utility in ``ForecastingHorizon`` (:pr:`5501`) :user:`fkiraly`
* [ENH] refactor index generation in reducers to use ``ForecastingHorizon`` method (:pr:`5539`) :user:`fkiraly`
* [ENH] fix index name check for reduction forecasters (:pr:`5543`) :user:`fkiraly`
* [ENH] forecaster ``fit_predict`` with ``X_pred`` argument for ``predict`` (:pr:`5562`) :user:`fkiraly`
* [ENH] refactor ``DirectReductionForecaster``to use ``sklearn`` input coercion utility (:pr:`5581`) :user:`fkiraly`
* [ENH] export and test ``DirectReductionForecaster`` (:pr:`5582`) :user:`fkiraly`
* [ENH] ``prophet`` based piecewise linear trend forecaster (:pr:`5592`) :user:`sbuse`
* [ENH] Add ``fit_kwargs`` to ``Prophet`` (:pr:`5597`) :user:`tpvasconcelos`
* [ENH] ``Croston`` test parameters - integer smoothing parameter (:pr:`5608`) :user:`NguyenChienFelix33`
* [ENH] ``prophet`` adapter - safer handling of ``fit_kwargs`` (:pr:`5622`) :user:`fkiraly`

Parameter estimation and hypothesis testing
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] Add new ``FunctionParamFitter`` parameter estimator (:pr:`5630`) :user:`tpvasconcelos`

Time series annotation
^^^^^^^^^^^^^^^^^^^^^^
* [ENH] Change ``GGS`` to inherit from ``BaseSeriesAnnotator`` (:pr:`5315`) :user:`Alex-JG3`

Time series classification
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] enable testing ``MrSQM`` for persistence in ``nsfa>0`` case after upstream bugfix (:pr:`5171`) :user:`fkiraly`
* [ENH] ``num_epochs`` renamed to ``n_epochs`` in ``SimpleRNNClassifier`` and ``SimpleRNNRegressor`` (:pr:`5607`) :user:`aeyazadil`

Time series clustering
^^^^^^^^^^^^^^^^^^^^^^

* [ENH] enable tag related registry tests for ``clusterer`` estimator type (:pr:`5576`) :user:`fkiraly`

Transformations
^^^^^^^^^^^^^^^

* [ENH] dilation mapping transformer (:pr:`5557`) :user:`fspinna`
* [ENH] second test parameter set for ``TSFreshRelevantFeatureExtractor`` (:pr:`5623`) :user:`fkiraly`

Visualization
^^^^^^^^^^^^^

* [ENH] Add ``calibration_plot`` for probabilistic forecasts (:pr:`5632`) :user:`benHeid`

Test framework
^^^^^^^^^^^^^^

* [ENH] reactivate and fix ``test_multiprocessing_idempotent`` (:pr:`5573`) :user:`fkiraly`
* [ENH] test class register, refactor ``check_estimator`` test gathering to central location (:pr:`5574`) :user:`fkiraly`
* [ENH] conditional testing of objects - test if covering test class has changed (:pr:`5579`) :user:`fkiraly`


Fixes
~~~~~

BaseObject and base framework
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] fix ``scitype`` ``coerce_to_list`` parameter, add test coverage (:pr:`5578`) :user:`fkiraly`

Data types, checks, conversions
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] Fix typos in mtype tags ``np.ndarray``, from erroneous ``nd.array`` (:pr:`5645`) :user:`yarnabrina`

Forecasting
^^^^^^^^^^^

* [BUG] in ``ARCH``, fix ``str`` coercion of ``pd.Series`` name (:pr:`5407`) :user:`Vasudeva-bit`
* [BUG] in reduced regressor, copy or truncate ``X`` if it does not fit the forecasting horizon (:pr:`5542`) :user:`benHeid`
* [BUG] pass correct level argument from ``StatsForecastBackAdapter`` to ``statsforecast`` (:pr:`5587`) :user:`sd2k`
* [BUG] fix ``HierarchyEnsembleForecaster`` returned unexpected predictions if data had only one hierarchy level and forecasters specified by node (:pr:`5615`) :user:`VyomkeshVyas`
* [BUG] fix loss of time zone attribute in ``ForecastingHorizon.to_absolute`` (:pr:`5628`) :user:`fkiraly`
* [BUG] change index match to integer in ``_StatsModelsAdapter`` predict (:pr:`5642`) :user:`ciaran-g`

Transformations
^^^^^^^^^^^^^^^

* [BUG] ``TsFreshFeatureExtractor`` - correct wrong forwarded parameter name ``profiling`` (:pr:`5600`) :user:`sssilvar`
* [BUG] Correct inference of ``TransformerPipeline`` output type tag (:pr:`5625`) :user:`fkiraly`

Visualization
^^^^^^^^^^^^^

* [BUG] Fix multiple figures created by ``plot_windows`` (:pr:`5636`) :user:`benHeid`


Maintenance
~~~~~~~~~~~

* [MNT] CI Modifications (:pr:`5498`) :user:`yarnabrina`
* [MNT] rename variables in base (:pr:`5502`) :user:`yarnabrina`
* [MNT] addressing various ``pandas`` related deprecations (:pr:`5583`) :user:`fkiraly`
* [MNT] Update pre commit hooks (:pr:`5646`) :user:`yarnabrina`
* [MNT] [Dependabot](deps-dev): Update ``pytest-xdist`` requirement from ``<3.4,>=3.3`` to ``>=3.3,<3.5`` (:pr:`5551`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps-dev): Update ``dask`` requirement from ``<2023.7.1`` to ``<2023.11.1`` (:pr:`5552`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps-dev): Update ``dask`` requirement from ``<2023.11.1`` to ``<2023.12.2`` (:pr:`5629`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps-dev): Update ``holidays`` requirement from ``<0.36,>=0.29`` to ``>=0.29,<0.37`` (:pr:`5538`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps-dev): Update ``holidays`` requirement from ``<0.37,>=0.29`` to ``>=0.29,<0.38`` (:pr:`5565`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps-dev): Update ``holidays`` requirement from ``<0.38,>=0.29`` to ``>=0.29,<0.40`` (:pr:`5637`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps-dev): Update ``sphinx-gallery`` requirement from ``<0.15.0`` to ``<0.16.0`` (:pr:`5566`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps-dev): Update ``pytest-xdist`` requirement from ``<3.5,>=3.3`` to ``>=3.3,<3.6`` (:pr:`5567`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps-dev): Update ``pycatch22`` requirement from ``<0.4.4`` to ``<0.4.5`` (:pr:`5542`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Bump actions/download-artifact from 3 to 4 (:pr:`5627`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Bump actions/setup-python from 4 to 5 (:pr:`5605`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Bump actions/upload-artifact from 3 to 4 (:pr:`5626`) :user:`dependabot[bot]`

Documentation
~~~~~~~~~~~~~

* [DOC] splitter full API reference page (:pr:`5577`) :user:`fkiraly`
* [DOC] Correct ReST syntax in "RocketClassifier" (:pr:`5564`) :user:`rahulporuri`
* [DOC] Added notebook accompanying Joanna Lenczuk's blog post for testing (:pr:`5604`) :user:`onyekaugochukwu`, :user:`joanlenczuk`
* [DOC] Remove extra parameter in docstring with incorrect definition (:pr:`5617`) :user:`wayneadams`
* [DOC] fix and complete ``YfromX`` docstring (:pr:`5593`) :user:`fkiraly`
* [DOC] fix typo in ``AA_datatypes_and_datasets.ipynb`` panel data loading example (:pr:`5594`) :user:`fkiraly`
* [DOC] forecasting ``evaluate`` utility - improved algorithm description in docstring #5603  (:pr:`5603`) :user:`adamkells`
* [DOC] add explanation about fit/transform instance linking behaviour of rocket transformers (:pr:`5621`) :user:`fkiraly`
* [DOC] Adjust ``FunctionTransformer``'s docstring (:pr:`5634`) :user:`tpvasconcelos`
* [DOC] fixed typo in ``pytest.mark.skipif`` (:pr:`5640`) :user:`yarnabrina`

Contributors
~~~~~~~~~~~~

:user:`adamkells`,
:user:`aeyazadil`,
:user:`Alex-JG3`,
:user:`benHeid`,
:user:`ciaran-g`,
:user:`fkiraly`,
:user:`fspinna`,
:user:`joanlenczuk`,
:user:`NguyenChienFelix33`,
:user:`onyekaugochukwu`,
:user:`rahulporuri`,
:user:`sbuse`,
:user:`sd2k`,
:user:`sssilvar`,
:user:`tpvasconcelos`,
:user:`Vasudeva-bit`,
:user:`VyomkeshVyas`,
:user:`wayneadams`,
:user:`yarnabrina`

Version 0.24.1 - 2023-11-05
---------------------------

Highlights
~~~~~~~~~~

* ``torch`` adapter, LTSF forecasters - linear, D-linear, N-linear (:pr:`4891`, :pr:`5514`) :user:`luca-miniati`
* more period options in ``FourierFeatures``: ``pandas`` period alias and from offset column (:pr:`5513`) :user:`Ram0nB`
* ``iisignature`` backend option for ``SignatureTransformer`` (:pr:`5398`) :user:`sz85512678`
* ``TimeSeriesForestClassifier`` feature importance and optimized interval generation (:pr:`5338`) :user:`YHallouard`
* all stationarity tests from ``arch`` package available as estimators (:pr:`5439`) :user:`Vasudeva-bit`
* Hyperbolic sine transformation and its inverse, ``ScaledAsinhTransformer``, for soft input or output clipping (:pr:`5389`) :user:`ali-parizad`
* estimator serialization: user choice of ``serialization_format`` in ``save`` method and ``mlfow`` plugin,
  support for ``cloudpickle`` (:pr:`5486`, :pr:`5526`) :user:`achieveordie`

Dependency changes
~~~~~~~~~~~~~~~~~~

* ``holidays`` (transformations soft dependency) bounds have been updated to ``>=0.29,<0.36``.
* ``torch`` is now a managed soft dependency for neural networks (``dl`` test set)

Core interface changes
~~~~~~~~~~~~~~~~~~~~~~

* if using ``scikit-base>=0.6.1``: ``set_params`` now recognizes unique ``__``-separated
  suffixes as aliases for full parameter string, e.g., ``set_params(foo="bar")``
  instead of ``set_params(estimator__detrender__forecaster__supercalifragilistic__foo="bar")``.
  This extends to use of parameter names in tuners, e.g., ``ForecastingGridSearchCV`` grids,
  and estimators internally using ``set_params``. The behaviour of ``get_params`` is unchanged.
* ``sktime`` now supports ``cloudpickle`` for estimator serialization, with ``pickle``
  being the standard serialization backend.
  To select the serialization backend, use the ``serialization_format`` parameter
  of estimators' ``save`` method.
  ``cloudpickle`` is already a soft dependency, therefore no dependency change is required.

Enhancements
~~~~~~~~~~~~

BaseObject and base framework
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] test that ``set_params`` recognizes unique suffixes as aliases for full parameter string (:pr:`2931`) :user:`fkiraly`
* [ENH] estimator serialization: user choice of ``serialization_format``, support for ``cloudpickle`` (:pr:`5486`) :user:`achieveordie`

Benchmarking, Metrics, Splitters
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] in ``ExpandingGreedySplitter``, allow ``float`` ``step_size`` (:pr:`5329`) :user:`fkiraly`
* [ENH] Sensible default for ``BaseSplitter.get_n_splits`` (:pr:`5412`) :user:`fkiraly`

Data sets and data loaders
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] Add tecator dataset for time series regression as ``sktime`` onboard dataset (:pr:`5428`) :user:`JonathanBechtel`

Forecasting
^^^^^^^^^^^

* [ENH] ``LTSFLinearForecaster``, ``LTSFLinearNetwork``, ``BaseDeepNetworkPyTorch`` (:pr:`4891`) :user:`luca-miniati`
* [ENH] ``LTSFDLinearForecaster``, ``LTSFNLinearForecaster`` (:pr:`5514`) :user:`luca-miniati`
* [ENH] parallel backend selection for forecasting tuners (:pr:`5430`) :user:`fkiraly`
* [ENH] in ``NaiveForecaster``, add valid variance prediction for in-sample forecasts (:pr:`5499`) :user:`fkiraly`

MLOps & Deployment
^^^^^^^^^^^^^^^^^^

* [ENH] in ``mlflow`` plugin, improve informativity of ``ModuleNotFoundError`` messages (:pr:`5487`) :user:`achieveordie`
* [ENH] Add support for DL estimator persistence in ``mlflow`` plugin (:pr:`5526`) :user:`achieveordie`

Neural networks
^^^^^^^^^^^^^^^

* [ENH] ``pytorch`` adapter for neural networks (:pr:`4891`) :user:`luca-miniati`
* [ENH] add placeholder test suite for neural networks (:pr:`5511`) :user:`fkiraly`

Parameter estimation and hypothesis testing
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] Interface to stationarity tests from ``arch`` package (:pr:`5439`) :user:`Vasudeva-bit`

Time series annotation
^^^^^^^^^^^^^^^^^^^^^^

* [ENH] Add unit tests for change point and segmentation plotting functions (:pr:`5509`) :user:`adamkells`

Time series classification
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] ``TimeSeriesForestClassifier`` feature importance and optimized interval generation (:pr:`5338`) :user:`YHallouard`

Transformations
^^^^^^^^^^^^^^^

* [ENH] Add Hyperbolic Sine transformation and its inverse (ScaledAsinhTransformer) (:pr:`5389`) :user:`ali-parizad`
* [ENH] ``iisignature`` backend option for ``SignatureTransformer`` (:pr:`5398`) :user:`sz85512678`
* [ENH] general inverse transform for ``MSTL`` transformer (:pr:`5457`) :user:`fkiraly`
* [ENH] more period options in ``FourierFeatures``: ``pandas`` period alias and from offset column (:pr:`5513`) :user:`Ram0nB`

Maintenance
~~~~~~~~~~~

* [MNT] Auto format pyproject (:pr:`5425`) :user:`yarnabrina`
* [MNT] bound ``pycatch22<0.4.4`` due to breaking change in patch version (:pr:`5434`) :user:`fkiraly`
* [MNT] removed two recently added hooks (:pr:`5453`) :user:`yarnabrina`
* [MNT] xfail remote data loaders to silence sporadic failures (:pr:`5461`) :user:`fkiraly`
* [MNT] new CI workflow to test extras (:pr:`5375`) :user:`yarnabrina`
* [MNT] Split CI jobs per components with specific soft-dependencies (:pr:`5304`) :user:`yarnabrina`
* [MNT] Programmatically fix (all) typos (:pr:`5424`) :user:`kianmeng`
* [MNT] fix typos in ``base`` module (:pr:`5313`) :user:`yarnabrina`
* [MNT] fix typos in ``forecasting`` module (:pr:`5314`) :user:`yarnabrina`
* [MNT] added missing checkout steps (:pr:`5471`) :user:`yarnabrina`
* [MNT] adds code quality checks without outdated/deprecated Github actions (:pr:`5427`) :user:`yarnabrina`
* [MNT] revert PR #4681 (:pr:`5508`) :user:`yarnabrina`
* [MNT] address ``pandas`` constructor deprecation message from ``ExpandingGreedySplitter`` (:pr:`5500`) :user:`fkiraly`
* [MNT] address deprecation of ``pd.DataFrame.fillna`` with ``method`` arg (:pr:`5497`) :user:`fkiraly`
* [MNT] Dataset downloader testing workflow (:pr:`5437`) :user:`yarnabrina`
* [MNT] shorter names for CI workflow elements (:pr:`5470`) :user:`fkiraly`
* [MNT] skip ``load_solar`` in doctests (:pr:`5528`) :user:`fkiraly`
* [MNT] revert PR #4681 (:pr:`5508`) :user:`yarnabrina`
* [MNT] exclude downloads in "no soft dependencies" CI element (:pr:`5529`) :user:`fkiraly`

* [MNT] [Dependabot](deps): Bump actions/setup-node from 3 to 4 (:pr:`5483`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps-dev): Update pytest-timeout requirement from <2.2,>=2.1 to >=2.1,<2.3 (:pr:`5482`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Bump tj-actions/changed-files from 39 to 40 (:pr:`5492`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps-dev): Update holidays requirement from <0.35,>=0.29 to >=0.29,<0.36 (:pr:`5443`) :user:`dependabot[bot]`

Documentation
~~~~~~~~~~~~~

* [DOC] fixing docstring example for ``FhPlexForecaster`` (:pr:`4931`) :user:`fkiraly`
* [DOC] Programmatically fix (all) typos (:pr:`5424`) :user:`kianmeng`
* [DOC] comments for readability of ``pyproject.toml`` (:pr:`5472`) :user:`fkiraly`
* [DOC] streamlining API reference, fixing minor issues (:pr:`5466`) :user:`fkiraly`
* [DOC] Fix more typos (:pr:`5478`) :user:`szepeviktor`
* [DOC] update docstring of ``STLTransformer`` to correct statements on inverse and pipelines (:pr:`5455`) :user:`fkiraly`
* [DOC] improved docstrings for ``statsforecast`` estimators (:pr:`5409`) :user:`fkiraly`
* [DOC] add missing API reference entries for five deep learning classifiers (:pr:`5522`) :user:`fkiraly`
* [DOC] fixed docstrings for stationarity tests (:pr:`5531`) :user:`fkiraly`

Fixes
~~~~~

BaseObject and base framework
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] fix error message in ``_check_python_version`` (:pr:`5473`) :user:`fkiraly`

Benchmarking, Metrics, Splitters
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] fix bug in deprecation logic of ``kwargs`` in ``evaluate`` that always set
  backend to ``dask_lazy`` if deprecated ``kwargs`` are passed (:pr:`5469`) :user:`fkiraly`

Forecasting
^^^^^^^^^^^

* [BUG] Fix ``pandas`` ``FutureWarning`` for silent upcasting (:pr:`5395`) :user:`tpvasconcelos`
* [BUG] fix predict function of ``make_reduction`` (recursive, global) to work with tz aware data (:pr:`5464`) :user:`ciaran-g`
* [BUG] in ``TransformedTargetForecaster``, ensure correct setting of ``ignores-exogenous-X`` tag if forecaster ignores ``X``, but at least one transformer uses ``y=X``, e.g., feature selector (:pr:`5521`) :user:`fkiraly`

Parameter estimation and hypothesis testing
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] fixed incorrect signs for some stationarity tests (:pr:`5531`) :user:`fkiraly`

Time series annotation
^^^^^^^^^^^^^^^^^^^^^^

* [BUG] CLASP logic: remove indexes from exclusion zone that are out of range (:pr:`5459`) :user:`Alex-JG3`
* [BUG] in ``ClaSPSegmentation``, deal with ``k`` when it is too large for ``np.argpartition`` (:pr:`5490`) :user:`Alex-JG3`

Time series classification
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] fix missing epochs parameter in ``MCDCNNClassifier._fit`` (#4996) (:pr:`5422`) :user:`pseudomo`
* [BUG] add missing exports five deep learning classifiers (:pr:`5522`) :user:`fkiraly`

Transformations
^^^^^^^^^^^^^^^

* [BUG] fix test excepts for ``SignatureTransformer`` (:pr:`5474`) :user:`fkiraly`

Visualization
^^^^^^^^^^^^^

* [BUG] fix ``plot_series`` prediction interval plotting for 3 or less points in forecasting horizon (:pr:`5494`) :user:`fkiraly`

Contributors
~~~~~~~~~~~~

:user:`achieveordie`,
:user:`adamkells`,
:user:`Alex-JG3`,
:user:`ali-parizad`,
:user:`ciaran-g`,
:user:`fkiraly`,
:user:`JonathanBechtel`,
:user:`kianmeng`,
:user:`luca-miniati`,
:user:`pseudomo`,
:user:`Ram0nB`,
:user:`sz85512678`,
:user:`szepeviktor`,
:user:`tpvasconcelos`,
:user:`Vasudeva-bit`,
:user:`yarnabrina`,
:user:`YHallouard`


Version 0.24.0 - 2023-10-13
---------------------------

Maintenance release:

* support for python 3.12
* scheduled deprecations
* soft dependency updates

For last non-maintenance content updates, see 0.23.1.

Dependency changes
~~~~~~~~~~~~~~~~~~

* ``pykalman`` dependencies have been replaced by the fork ``pykalman-bardo``.
  ``pykalman`` is abandoned, and ``pykalman-bardo`` is a maintained fork.
  This is a soft dependency, and the switch does not affect users installing
  ``sktime`` using one of its dependency sets.
  Mid-term, we expect ``pykalman-bardo`` to be merged back into ``pykalman``,
  after which the dependency will be switched back to ``pykalman``.
* ``holidays`` (transformations soft dependency) bounds have been updated to ``>=0.29,<0.35``.
* ``numba`` (classification, regression, and transformations soft dependency) bounds have been updated to ``>=0.53,<0.59``.
* ``skpro`` (forecasting soft dependency) bounds have been updated to ``>=2.0.0,<2.2.0``.

Deprecations and removals
~~~~~~~~~~~~~~~~~~~~~~~~~

* in forecasting tuners ``ForecastingGridSearchCV``, ``ForecastingRandomizedSearchCV``,
  ``ForecastingSkoptSearchCV``, the default of parameter ``tune_by_variable``
  has been switched from ``True`` to ``False``.

Contents
~~~~~~~~

* [MNT] Update ``numba`` requirement from ``<0.58,>=0.53`` to ``>=0.53,<0.59`` (:pr:`5299`, :pr:`5319`) :user:`dependabot[bot]`, :user:`fkiraly`
* [MNT] [Dependabot](deps-dev): Update ``skpro`` requirement from ``<2.1.0,>=2.0.0`` to ``>=2.0.0,<2.2.0`` (:pr:`5396`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps-dev): Update ``holidays`` requirement from ``<0.34,>=0.29`` to ``>=0.29,<0.35`` (:pr:`5342`) :user:`dependabot[bot]`
* [MNT] Migrate from ``pykalman`` to ``pykalman-bardo`` (:pr:`5277`) :user:`mbalatsko`
* [MNT] 0.24.0 deprecations and change actions (:pr:`5404`) :user:`fkiraly`
* 🚀 python 3.12 🚀  (:pr:`5345`) :user:`fkiraly`

Contributors
~~~~~~~~~~~~

:user:`fkiraly`,
:user:`mbalatsko`


Version 0.23.1 - 2023-10-12
---------------------------

Highlights
~~~~~~~~~~

* all hierarchical/multivariate forecaster and transformer broadcasting can now use parallelization backends ``joblib``, ``dask`` via ``set_config`` (:pr:`5267`, :pr:`5268`, :pr:`5301`, :pr:`5311`, :pr:`5405`) :user:`fkiraly`
* ``PeakTimeFeatures`` transformer to generate indicator features for one or multiple peak hours, days, etc (:pr:`5191`) :user:`ali-parizad`
* ARCH forecaster interfacing ``arch`` package (:pr:`5326`) :user:`Vasudeva-bit`
* forecasting reducer ``YfromX`` now makes probabilistic forecasts when using ``skpro`` probabilistic tabular regressors (:pr:`5271`) :user:`fkiraly`
* forecasting compositors ``ForecastX`` now allows fitting ``forecaster_y`` on forecasted ``X`` (:pr:`5334`) :user:`benHeid`
* lucky dynamic time warping distance and aligner, for use in time series classifiers, regressors, clusterers (:pr:`5341`) :user:`fkiraly`
* splitters have now moved to their own module, ``sktime.split`` (:pr:`5017`) :user:`BensHamza`

Dependency changes
~~~~~~~~~~~~~~~~~~

* ``attrs`` is no longer a soft dependency (time series annotation) of ``sktime``
* ``arch`` is now a soft dependency (forecasting) of ``sktime``
* ``skpro`` is now a soft dependency (forecasting) of ``sktime``

Core interface changes
~~~~~~~~~~~~~~~~~~~~~~

BaseObject and base framework
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* the ``sktime`` framework now inspects estimator type primarily via the tag ``object_type``.
  This is not a breaking change as inheriting from respective base classes automatically sets the tag as well,
  via the tag inheritance system. The type inspection utility ``scitype`` is also unaffected.
  For extenders, the change enables polymorphic and dynamically typed estimators.
* warnings from ``sktime`` can now be silenced on a per-estimator basis via
  the ``warnings`` config that can be set via ``set_config`` (see docstring).

Forecasting
^^^^^^^^^^^

* hierarchical and multivariate forecasts can now use parallelization and distributed backends,
  including ``joblib`` and ``dask``, if the forecast is obtained via broadcasting.
  To enable parallelization, set the ``backend:parallel`` and/or the ``backend:parallel:params``
  configuration flags via ``set_config`` (see docstring) before fitting the forecaster.
  This change instantaneously extends to all existing third party forecasters
  that are interface conformant, via inheritance from the updated base framework.

Time series regression
^^^^^^^^^^^^^^^^^^^^^^

* time series regressors now allow single-column ``pd.DataFrame`` as ``y``.
  Current behaviour is unaffected, this is not a breaking change for existing code.

Transformations
^^^^^^^^^^^^^^^

* hierarchical and multivariate transformers can now use parallelization and distributed backends,
  including ``joblib`` and ``dask``, if the transformation is obtained via broadcasting.
  To enable parallelization, set the ``backend:parallel`` and/or the ``backend:parallel:params``
  configuration flags via ``set_config`` (see docstring) before fitting the transformer.
  This change instantaneously extends to all existing third party transformers
  that are interface conformant, via inheritance from the updated base framework.

Deprecations and removals
~~~~~~~~~~~~~~~~~~~~~~~~~

Benchmarking, Metrics, Splitters
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* time series splitters, i.e., descendants of ``BaseSplitter``, have moved from
  ``sktime.forecasting.model_selection`` to ``sktime.split``.
  The old location ``model_selection`` is deprecated and will be removed in 0.25.0.
  Until 0.25.0, it is still available but will raise an informative warning message.

Enhancements
~~~~~~~~~~~~

BaseObject and base framework
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] warnings config (:pr:`4536`) :user:`fkiraly`
* [ENH] add exports of common utilities in ``utils`` module (:pr:`5266`) :user:`fkiraly`
* [ENH] in scitype check, replace base class register logic with type tag inspection (:pr:`5288`) :user:`fkiraly`
* [ENH] parallelization backend calls in utility module - part 1, refactor to utility module (:pr:`5268`) :user:`fkiraly`
* [ENH] parallelization backend calls in utility module - part 2, backend parameter passing (:pr:`5311`) :user:`fkiraly`
* [ENH] parallelization backend calls in utility module - part 3, backend parameter passing in base class broadcasting (:pr:`5405`) :user:`fkiraly`

Benchmarking, Metrics, Splitters
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] consolidating splitters as their own module with systematic tests and extension (:pr:`5017`, :pr:`5331`) :user:`BensHamza`,  :user:`fkiraly`
* [ENH] allow ``evaluate`` to accept any combination of multiple metrics with correct predict method (:pr:`5192`) :user:`hazrulakmal`
* [ENH] add tests for ``temporal_train_test_split`` (:pr:`5332`) :user:`fkiraly`

Data loaders
^^^^^^^^^^^^

* [ENH] dataset loaders module restructure (:pr:`5239`) :user:`hazrulakmal`

Forecasting
^^^^^^^^^^^

* [ENH] Add a ``CurveFitForecaster`` based on ``scipy`` ``optimize_curve`` (:pr:`5240`) :user:`benHeid`
* [ENH] Restructure the ``trend`` forecasters module (:pr:`5242`) :user:`benHeid`
* [ENH] ``YfromX`` - probabilistic forecasts (:pr:`5271`) :user:`fkiraly`
* [ENH] Link ``test_interval_wrappers.py`` to changes in ``evaluate`` for conditional testing (:pr:`5337`) :user:`fkiraly`
* [ENH] ``joblib`` and ``dask`` backends in broadcasting of estimators in multivariate or hierarchical case - part 1, ``VectorizedDF.vectorize_est`` (:pr:`5267`) :user:`fkiraly`
* [ENH] ``joblib`` and ``dask`` backends in broadcasting of estimators in multivariate or hierarchical case - part 2, base class config (:pr:`5301`) :user:`fkiraly`
* [ENH] ARCH model interfacing ``arch`` package (:pr:`5326`) :user:`Vasudeva-bit`
* [ENH] in ``ForecastX``, enable fitting ``forecaster_y`` on forecasted ``X`` (:pr:`5334`) :user:`benHeid`
* [ENH] Skip unnecessary fit in ``ForecastX`` if inner ``forecaster_y`` ignores ``X`` (:pr:`5353`) :user:`yarnabrina`
* [ENH] remove legacy except in ``TestAllEstimators`` for ``predict_proba`` (:pr:`5386`) :user:`fkiraly`

Time series alignment
^^^^^^^^^^^^^^^^^^^^^

* [ENH] lucky dynamic time warping aligner (:pr:`5341`) :user:`fkiraly`
* [ENH] sensible default ``_get_distance_matrix`` for time series aligners (:pr:`5347`) :user:`fkiraly`

Time series distances and kernels
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] delegator for pairwise time series distances and kernels (:pr:`5340`) :user:`fkiraly`
* [ENH] lucky dynamic time warping distance (:pr:`5341`) :user:`fkiraly`
* [ENH] simplified delegator interface to ``dtw-python`` based dynamic time warping distances (:pr:`5348`) :user:`fkiraly`

Time series regression
^^^^^^^^^^^^^^^^^^^^^^

* [ENH] in ``BaseRegressor``, allow ``y`` to be 1D ``pd.DataFrame`` (:pr:`5282`) :user:`mdsaad2305`

Transformations
^^^^^^^^^^^^^^^

* [ENH] ``PeakTimeFeatures`` transformer to generate indicator features for one/multiple peak/hours-day-week-, working hours, etc (:pr:`5191`) :user:`ali-parizad`
* [ENH] ``VmdTransformer``, add decompose-forecast-recompose as a docstring example and test (:pr:`5250`) :user:`fkiraly`* [ENH] improve ``evaluate`` failure error message (:pr:`5269`) :user:`fkiraly`
* [ENH] add proper ``inverse_transform`` to ``STLTransformer`` (:pr:`5300`) :user:`fkiraly`
* [ENH] ``joblib`` and ``dask`` backends in broadcasting of estimators in multivariate or hierarchical case - part 1, ``VectorizedDF.vectorize_est`` (:pr:`5267`) :user:`fkiraly`
* [ENH] ``joblib`` and ``dask`` backends in broadcasting of estimators in multivariate or hierarchical case - part 2, base class config (:pr:`5301`) :user:`fkiraly`
* [ENH] Refactor of ``DateTimeFeatures`` tests to ``pytest`` fixtures (:pr:`5397`) :user:`adamkells`

Testing framework
^^^^^^^^^^^^^^^^^

* [ENH] add error message return to ``deep_equals`` assert in ``test_reconstruct_identical``  (:pr:`4927`) :user:`fkiraly`
* [ENH] incremental testing to also test if any parent class in sktime has changed (:pr:`5379`) :user:`fkiraly`

Maintenance
~~~~~~~~~~~

* [MNT] revert update numba requirement from <0.58,>=0.53 to >=0.53,<0.59" (:pr:`5297`) :user:`fkiraly`
* [MNT] bound ``numba<0.58`` (:pr:`5303`) :user:`fkiraly`
* [MNT] Remove ``attrs`` dependency (:pr:`5296`) :user:`Alex-JG3`
* [MNT] simplified CI - merge windows CI step with test matrix (:pr:`5362`) :user:`fkiraly`
* [MNT] towards 3.12 compatibility - replace ``distutils`` calls with equivalent functionality (:pr:`5376`) :user:`fkiraly`
* [MNT] ``skpro`` as a soft dependency (:pr:`5273`) :user:`fkiraly`
* [MNT] removed ``py37.dockerfile`` and update doc entry for CI (:pr:`5356`) :user:`kurayami07734`
* [MNT] [Dependabot](deps): Bump styfle/cancel-workflow-action from 0.11.0 to 0.12.0 (:pr:`5355`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Bump stefanzweifel/git-auto-commit-action from 4 to 5 (:pr:`5373`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps-dev): Update holidays requirement from <0.33,>=0.29 to >=0.29,<0.34 (:pr:`5276`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps-dev): Update numpy requirement from <1.26,>=1.21.0 to >=1.21.0,<1.27 (:pr:`5275`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps-dev): Update arch requirement from <6.2.0,>=5.6.0 to >=5.6.0,<6.3.0 (:pr:`5392`) :user:`dependabot[bot]`

Documentation
~~~~~~~~~~~~~

* [DOC] prevent line break in ``README.md`` badges table (:pr:`5263`) :user:`fkiraly`
* [DOC] forecasting extension template - add insample capability tags (:pr:`5272`) :user:`fkiraly`
* [DOC] add ``blog`` badge for ``fkiraly``, for ODSC blog post (:pr:`5291`) :user:`fkiraly`
* [DOC] speed improvement of ``partition_based_clustering`` notebook (:pr:`5278`) :user:`alexfilothodoros`
* [DOC] Documented ax argument and the figure in plot_series (:pr:`5325`) :user:`ShreeshaM07`
* [DOC] Improve Readability of Notebook 2 - Classification, Regression & Clustering (:pr:`5312`) :user:`achieveordie`
* [DOC] Added all feature names to docstring for DateTimeFeatures class (:pr:`5283`) :user:`Abhay-Lejith`
* [DOC] ``sktime`` intro notebook (:pr:`3793`) :user:`fkiraly`
* [DOC] Correct code block formatting for pre-commit install command (:pr:`5377`) :user:`alhridoy`
* [DOC] fix broken docstring example of ``AlignerDtwNumba`` (:pr:`5374`) :user:`fkiraly`
* [DOC] fix typo in classification notebook (:pr:`5390`) :user:`pirnerjonas`
* [DOC] Improved PR template for new contributors (:pr:`5381`) :user:`fkiraly`
* [DOC] dynamic docstring for ``set_config`` (:pr:`5306`) :user:`fkiraly`
* [DOC] update docstring of ``temporal_train_test_split`` (:pr:`4170`) :user:`xansh`
* [DOC] Document ``ax`` argument and the figure in ``plot_series`` (:pr:`5325`) :user:`ShreeshaM07`

Fixes
~~~~~

Benchmarking, Metrics, Splitters
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] fix ``temporal_train_test_split`` for hierarchical and panel data in case where ``fh`` is not passed (:pr:`5330`) :user:`fkiraly`
* [BUG] allow ``alpha`` and ``coverage`` to be passed again via metrics to ``evaluate`` (:pr:`5354`) :user:`fkiraly`, :user:`benheid`

Forecasting
^^^^^^^^^^^

* [BUG] fix ``STLForecaster`` tag ``ignores-exogeneous-X`` to be correctly set for composites (:pr:`5365`) :user:`yarnabrina`
* [BUG] ``statsforecast 1.6.0`` compatibility - in ``statsforecast`` adapter, fixing ``RuntimeError: dictionary changed size during iteration`` (:pr:`5317`) :user:`arnaujc91`
* [BUG] ``statsforecast 1.6.0`` compatibility - fix argument differences between ``sktime`` and ``statsforecast`` (:pr:`5393`) :user:`luca-miniati`
* [BUG] Fix ``ARCH._check_predict_proba`` (:pr:`5384`) :user:`Vasudeva-bit`

Time series alignment
^^^^^^^^^^^^^^^^^^^^^

* [BUG] minor fixes to ``NaiveAligner`` (:pr:`5344`) :user:`fkiraly`

Time series distances and kernels
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] Fix ``numba`` errors when calling ``tslearn`` ``lcss`` (:pr:`5368`) :user:`benHeid`, :user:`BensHamza`, :user:`fkiraly`


Transformations
^^^^^^^^^^^^^^^

* [BUG] in ``Imputer``, fix ``y`` not being passed in ``method="forecaster"`` (:pr:`5287`) :user:`fkiraly`
* [BUG] ensure ``Catch22`` parameter setting ``n_jobs = -1`` uses all cores (:pr:`5361`) :user:`julnow`

Visualization
^^^^^^^^^^^^^

* [BUG] Fix inconsistent date/time index in ``plot_windows`` #4919 (:pr:`5321`) :user:`geronimos`

Contributors
~~~~~~~~~~~~

:user:`Abhay-Lejith`,
:user:`achieveordie`,
:user:`adamkells`,
:user:`Alex-JG3`,
:user:`alexfilothodoros`,
:user:`alhridoy`,
:user:`ali-parizad`,
:user:`arnaujc91`,
:user:`benHeid`,
:user:`BensHamza`,
:user:`fkiraly`,
:user:`geronimos`,
:user:`hazrulakmal`,
:user:`julnow`,
:user:`kurayami07734`,
:user:`luca-miniati`,
:user:`mdsaad2305`,
:user:`pirnerjonas`,
:user:`ShreeshaM07`,
:user:`Vasudeva-bit`,
:user:`xansh`,
:user:`yarnabrina`

Version 0.23.0 - 2023-09-17
---------------------------

Maintenance release - scheduled deprecations.

For last non-maintenance content updates, see 0.22.1.

Contents
~~~~~~~~

* end of change period in column naming convention for univariate probabilistic forecasts,
  see below for details for users and developers
* scheduled 0.23.0 deprecation actions

Deprecations and removals
~~~~~~~~~~~~~~~~~~~~~~~~~

Forecasting - change of column naming for univariate probabilistic forecasts
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

Returns of forecasters' ``predict_quantiles`` and ``predict_intervals``
are now consistent between the univariate case and multivariate cases:
the name of the uppermost (0-indexed) column level is always the variable name.

Previously, in the univariate case, it was always ``Coverage`` or ``Quantiles``.

This has been preceded by a change transition period since 0.21.0.
See the 0.21.0 and 0.22.0 changelogs for further details.

Users and extenders who have not yet completed their downstream actions
should remain on 0.22.X until they have completed their actions, and then upgrade
to 0.23.0 or later.


Version 0.22.1 - 2023-09-17
---------------------------

Highlights
~~~~~~~~~~

* Graphical Pipelines for any learning task (polymorphic) - ``Pipeline`` (:pr:`4652`) :user:`benHeid`
* all ``tslearn`` distances and kernels are now available in ``sktime`` (:pr:`5039`) :user:`fkiraly`
* new transformer: ``VmdTransformer`` (variational mode decomposition) - ``vmdpy`` is now maintained in ``sktime`` (:pr:`5129`) :user:`DaneLyttinen`, :user:`vrcarva`
* new transformer: interface to ``statsmodels`` MSTL (:pr:`5125`) :user:`luca-miniati`
* new classifier: ``MrSEQL`` time series classifier (:pr:`5178`) :user:`lnthach`, :user:`heerme`, :user:`fkiraly`
* new ``sktime`` native probability distributions: Cauchy, empirical, Laplace, Student t (:pr:`5050`, :pr:`5094`, :pr:`5161`) :user:`Alex-JG3`, :user:`fkiraly`

Dependency changes
~~~~~~~~~~~~~~~~~~

* ``sktime`` now supports ``pandas`` 2.1.X
* ``sktime`` now supports ``holidays`` 0.32 (soft dependency)
* ``sktime`` now supports ``statsforecast`` 1.6.X (soft dependency)

Core interface changes
~~~~~~~~~~~~~~~~~~~~~~

Transformations
^^^^^^^^^^^^^^^

* Transformations (``BaseTransformer`` descendants) now have two new optional tags:
  ``"capability:inverse_transform:range"`` and ``"capability:inverse_transform:exact"``.
  The tags should be specified in the ``_tags`` class attribute of the transformer,
  in case the transformer implements ``inverse_transform`` and has
  the restrictions described below.

  * ``"capability:inverse_transform:range"`` specifies the domain of invertibility of
    the transform, must be list [lower, upper] of float".
    This is used for documentation and testing purposes.
  * ``"capability:inverse_transform:exact"`` specifies whether ``inverse_transform``
    is expected to be an exact inverse to ``transform``.
    This is used for documentation and testing purposes.

Enhancements
~~~~~~~~~~~~

BaseObject and base framework
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] test for specification conformance of tag register (:pr:`5170`) :user:`fkiraly`

Benchmarking, Metrics, Splitters
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] speed up ``BaseSplitter`` boilerplate (:pr:`5063`) :user:`fkiraly`
* [ENH] Allow unrestricted ID string for ``BaseBenchmarking`` (:pr:`5130`) :user:`hazrulakmal`

Data sets and data loaders
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] set mirrors for time series classification data loaders (:pr:`5260`) :user:`fkiraly`

Forecasting
^^^^^^^^^^^

* [ENH] speed up tests in ``test_fh`` (:pr:`5098`) :user:`fkiraly`
* [ENH] Robustifying ``ForecastingGridSearchCV`` towards free kwarg methods in estimators, e.g., graphical pipeline (:pr:`5210`) :user:`benHeid`
* [ENH] make ``statsforecast`` adapter compatible with optional ``predict`` ``level`` arguments, and different init param sets (:pr:`5112`) :user:`arnaujc91`
* [ENH] fix ``test_set_freq_hier`` for ``pandas 2.1.0`` (:pr:`5185`) :user:`fkiraly`

Pipelines
^^^^^^^^^

* [ENH] Graphical Pipelines for any learning task (polymorphic) (:pr:`4652`) :user:`benHeid`
* [ENH] add warning that graphical pipeline is experimental (:pr:`5235`) :user:`benHeid`
* [ENH] ensure ``ForecastingPipeline`` is compatible with "featurizers" (:pr:`5252`) :user:`fkiraly`

Probability distributions and simulators
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] Student's t-distribution (:pr:`5050`) :user:`Alex-JG3`
* [ENH] empirical distribution (:pr:`5094`) :user:`fkiraly`
* [ENH] Laplace distribution (:pr:`5161`) :user:`fkiraly`
* [ENH] Refactor of ``BaseDistribution`` and descendants - generalised distribution param broadcasting in base class (:pr:`5176`) :user:`Alex-JG3`
* [ENH] fixture names in probability distribution tests (:pr:`5159`) :user:`fkiraly`

Time series classification
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] ``MrSEQL`` time series classifier (:pr:`5178`) :user:`fkiraly`, :user:`lnthach`, :user:`heerme`

Time series distances and kernels
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] ``tslearn`` distances and kernels including adapter (:pr:`5039`) :user:`fkiraly`
* [ENH] conditional execution of ``test_distance`` and ``test_distance_params`` (:pr:`5099`) :user:`fkiraly`
* [ENH] refactor and add conditional execution to ``numba`` based distance tests (:pr:`5141`) :user:`fkiraly`

Transformations
^^^^^^^^^^^^^^^

* [ENH] Interface statsmodels MSTL - transformer (:pr:`5125`) :user:`luca-miniati`
* [ENH] VMD (variational mode decomposition) transformer based on ``vmdpy`` (:pr:`5129`) :user:`DaneLyttinen`
* [ENH] add tag for inexact ``inverse_transform``-s (:pr:`5166`) :user:`fkiraly`

Testing framework
^^^^^^^^^^^^^^^^^

* [ENH] speed up ``test_probabilistic_metrics`` by explicit fixture generation instead of using forecaster fit/predict (:pr:`5115`) :user:`Ram0nB`
* [ENH] test forecastingdata downloads only on a small random subset (:pr:`5146`) :user:`fkiraly`
* [ENH] widen scope of change-conditional test execution (:pr:`5100`, :pr:`5135`, :pr:`5147`) :user:`fkiraly`
* [ENH] differential testing of ``cython`` based estimators (:pr:`5206`) :user:`fkiraly`

Maintenance
~~~~~~~~~~~

* [MNT] upgrade CI runners to latest stable images (:pr:`5031`) :user:`yarnabrina`
* [MNT] bound ``statsforecast<1.6.0`` due to recent failures (:pr:`5149`) :user:`fkiraly`
* [MNT] test forecastingdata downloads only on a small random subset (:pr:`5146`) :user:`fkiraly`
* [MNT] lower dep bound compatibility patch - ``binom_test`` (:pr:`5152`) :user:`fkiraly`
* [MNT] fix dependency isolation of ``DateTimeFeatures`` tests (:pr:`5154`) :user:`fkiraly`
* [MNT] move fixtures in ``test_reduce_global`` to ``pytest`` fixtures (:pr:`5157`) :user:`fkiraly`
* [MNT] move fixtures in ``test_dropna`` to ``pytest`` fixtures (:pr:`5153`) :user:`fkiraly`
* [MNT] Extra dependency specifications per component (:pr:`5136`) :user:`yarnabrina`
* [MNT] add ``numba`` to ``python`` 3.11 tests (:pr:`5179`) :user:`fkiraly`
* [MNT] autoupdate for copyright range in ``sphinx`` docs (:pr:`5212`) :user:`fkiraly`
* [MNT] move ``Pipeline`` exception from ``test_all_estimators`` to test ``_config`` (:pr:`5251`) :user:`fkiraly`
* [MNT] Update versions of pre commit hooks and fix ``E721`` issues pointed out by ``flake8`` (:pr:`5163`) :user:`yarnabrina`
* [MNT] [Dependabot](deps-dev): Update sphinx-gallery requirement from <0.14.0 to <0.15.0 (:pr:`5124`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps-dev): Update pandas requirement from <2.1.0,>=1.1.0 to >=1.1.0,<2.2.0 (:pr:`5183`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps): Bump actions/checkout from 3 to 4 (:pr:`5189`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps-dev): Update holidays requirement from <0.32,>=0.29 to >=0.29,<0.33 (:pr:`5214`) :user:`dependabot[bot]`
* [MNT] [Dependabot](deps-dev): Update statsforecast requirement from <1.6,>=0.5.2 to >=0.5.2,<1.7 (:pr:`5215`) :user:`dependabot[bot]`

Documentation
~~~~~~~~~~~~~

* [DOC] provisions for treasurer role (:pr:`4798`) :user:`marrov`, :user:`kiraly`
* [DOC] Fix ``make_pipeline``, ``make_reduction``, ``window_summarizer`` & ``load_forecasting`` data docstrings  (:pr:`5065`) :user:`hazrulakmal`
* [DOC] minor docstring typo fixes in ``_DelegatedForecaster`` module (:pr:`5168`) :user:`fkiraly`
* [DOC] update forecasting extension template on ``predict_proba`` (:pr:`5138`) :user:`fkiraly`
* [DOC] speed-up tutorial notebooks - deep learning classifiers (:pr:`5169`) :user:`alexfilothodoros`
* [DOC] Fix rendering issues in ``ColumnEnsembleForecaster`` docstring, add ``ColumnEnsembleTransformer`` example (:pr:`5201`) :user:`benHeid`
* [DOC] installation instruction docs for learning task specific dependency sets (:pr:`5204`) :user:`fkiraly`
* [DOC] add allcontributors badges of benHeid (:pr:`5209`) :user:`benHeid`
* [DOC] fix typo in forecaster API reference (:pr:`5211`) :user:`fkiraly`
* [DOC] Fixing typos in ``installation.rst`` (:pr:`5213`) :user:`Akash190104`
* [DOC] Added examples for ``temporal_train_test_split`` docstring (:pr:`5216`) :user:`JonathanBechtel`
* [DOC] update to README badges: license, tutorials, and community further up (:pr:`5227`) :user:`fkiraly`
* [DOC] Simple edits to make ``STLForecaster`` docstring render properly (:pr:`5220`) :user:`hazrulakmal`
* [DOC] fixing ``conftest.py`` docstrings (:pr:`5228`) :user:`fkiraly`
* [DOC] clarify docstrings in ``trend.py`` (:pr:`5231`) :user:`sniafas`

Fixes
~~~~~

Benchmarking, Metrics, Splitters
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] in splitters, correctly infer series frequency for datetime datatype if not given (:pr:`5009`) :user:`hazrulakmal`
* [BUG] fix ``BaseWindowSplitter`` ``get_n_split`` method for hierarchical data (:pr:`5012`) :user:`hazrulakmal`

Forecasting
^^^^^^^^^^^

* [BUG] fix check causing exception in ``ConformalIntervals`` in ``_predict`` (:pr:`5134`) :user:`fkiraly`
* [BUG] ensure forecasting tuners do not vectorize over columns (variables) (:pr:`5145`) :user:`fkiraly`, :user:`SmirnGregHM`
* [BUG] Fix tag to indicate support of exogenous features by ``NaiveForecaster`` (:pr:`5162`) :user:`yarnabrina`
* [BUG] Add missing ``return`` statement for ``y_dict`` in tests for composite forecasters (:pr:`5253`) :user:`BensHamza`
* [BUG] Fix missing ``y_train`` key in ``y_dict`` in tests for composite forecasters (:pr:`5255`) :user:`fkiraly`
* [BUG] Fix ``ForecastKnownValues`` failure on ``pd-multiindex`` (:pr:`5256`) :user:`mattiasatqubes`

Pipelines
^^^^^^^^^

* [BUG] fix missing ``Pipeline`` export in ``sktime.pipeline`` (:pr:`5232`) :user:`fkiraly`

Time series annotation
^^^^^^^^^^^^^^^^^^^^^^

* [BUG] prevent exception in ``PyODAnnotator.get_test_params`` (:pr:`5151`) :user:`fkiraly`

Transformations
^^^^^^^^^^^^^^^

* [BUG] adds missing tag ``skip-inverse-transform`` to ``ColumnSelect`` (:pr:`5208`) :user:`benHeid`

Visualisations
^^^^^^^^^^^^^^

* [BUG] address ``matplotlib`` deprecation of ``label`` attribute (:pr:`5246`) :user:`benHeid`


Contributors
~~~~~~~~~~~~

:user:`Akash190104`,
:user:`Alex-JG3`,
:user:`alexfilothodoros`,
:user:`arnaujc91`,
:user:`benHeid`,
:user:`BensHamza`,
:user:`DaneLyttinen`,
:user:`fkiraly`,
:user:`hazrulakmal`,
:user:`heerme`,
:user:`lnthach`,
:user:`JonathanBechtel`,
:user:`luca-miniati`,
:user:`mattiasatqubes`,
:user:`Ram0nB`,
:user:`SmirnGregHM`,
:user:`sniafas`,
:user:`vrcarva`,
:user:`yarnabrina`

Version 0.22.0 - 2023-08-18
---------------------------

Maintenance release - dependency updates, scheduled deprecations.

For last non-maintenance content updates, see 0.21.1.

Contents
~~~~~~~~

* midpoint of change period in column naming convention for univariate probabilistic forecasts,
  in preparation for 0.23.0 - see below for details for users and developers
* scheduled 0.22.0 deprecation actions

Dependency changes
~~~~~~~~~~~~~~~~~~

* the ``deprecated`` has been removed as a core dependency of ``sktime``.
  No action is required of users
  or developers, as the package was used only for internal deprecation actions.

Deprecations and removals
~~~~~~~~~~~~~~~~~~~~~~~~~

Forecasting - change of column naming for univariate probabilistic forecasts
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

From 0.23.0, returns of forecasters' ``predict_quantiles`` and ``predict_intervals``
in the univariate case will be made consistent with the multivariate case:
the name of the uppermost (0-indexed) column level will always be the variable name.
Previously, in the univariate case, it was always ``Coverage`` or ``Quantiles``.

The transition period is managed by the ``legacy_interface`` argument of the two methods.
See the 0.21.0 changelog for further details.

In 0.22.0, the ``legacy_interface`` argument defaults have been changed to ``False``,
which ensures outputs are of the future, post-change naming convention.

Reminder of recommended action for users:

* Users should aim to upgrade dependent code to ``legacy_interface=False`` behaviour by 0.21.last,
  and to remove ``legacy_interface`` arguments after 0.22.0 and before 0.23.0.
  Users who need more time to upgrade dependent code can set ``legacy_interface=True`` until 0.22.last.

Extenders should use the new ``"pred_int:legacy_interface:testcfg"`` config field to upgrade their third party extensions,
this is as described in the 0.21.0 changelog.

Transformations
^^^^^^^^^^^^^^^

* in ``DateTimeFeatures``, the feature ``hour_of_week`` feature
  has been added to the ``"comprehensive"`` feature set.
  Users who would like to continue using the previous feature set
  should use the argument ``manual_selection`` instead.

List of PR
~~~~~~~~~~

* [MNT] ``failfast=False`` in the release workflow (:pr:`5120`) :user:`fkiraly`
* [MNT] 0.22.0 release action - deprecate ``deprecated`` in 0.21.0, remove in 0.22.0 (:pr:`4822`) :user:`fkiraly`
* [MNT] 0.22.0 deprecations and change actions (:pr:`5106`) :user:`fkiraly`


Version 0.21.1 - 2023-08-16
---------------------------

Highlights
~~~~~~~~~~

* holiday feature transformers (country, financial holidays; 1:1 interface) based on ``holidays`` (:pr:`4893`, :pr:`4909`) :user:`VyomkeshVyas`, :user:`yarnabrina`
* ``DropNA`` transformer to drop rows or columns with nan (:pr:`5049`) :user:`hliebert`
* ``ExpandingGreedySplitter`` for slicing test sets from end (:pr:`4917`) :user:`davidgilbertson`
* ``statsforecast`` interfaces: MSTL forecaster, ARCH family forecasters (:pr:`4865`, :pr:`4938`) :user:`luca-miniati`, :user:`eyjo`
* full rework of time series classification notebook (:pr:`5045`) :user:`fkiraly`
* improved developer experience - speedups for testing :user:`julia-kraus`, :user:`tarpas`, :user:`benheid`, :user:`fkiraly`, :user:`yarnabrina`

Core interface changes
~~~~~~~~~~~~~~~~~~~~~~

Time series alignment
^^^^^^^^^^^^^^^^^^^^^

* Time series aligners now accept all ``Panel`` mtypes as input,
  from only ``df-list`` previously. This is not a breaking change.
* Time series aligners now have a tag ``"alignment_type"``, which can have values
  ``"full"`` and ``"partial"``, to distinguish between a full and partial alignment
  produced by ``get_alignment``. The tag can depend on parameters of the aligner.

Time series distances and kernels
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* Pairwise transformers now have a tag ``"pwtrafo_type"``, which can have values
  ``"kernel"``, ``"distance"``, or ``"other"``, to allow the user to inspect
  whether the transformer is a kernel or distance transformer.
  This does not impact the interface. The tag is mainly for search and retrieval
  by the user. This also allows to check against methodological requirements
  of estimators, e.g., support vector machines requiring a kernel.
  However, as stated, this is not enforced by the base interface.

Enhancements
~~~~~~~~~~~~

BaseObject and base framework
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] Speed-up ``deep_equals`` - lazy evaluation of costly error message string coercions (:pr:`5044`) :user:`benHeid`
* [ENH] sktime str/object aliasing registry mechanism (:pr:`5058`) :user:`fkiraly`

Benchmarking, Metrics, Splitters
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] private ``split_loc`` and tag to control dispatch of ``split_series`` to ``split`` vs ``split_loc`` (:pr:`4903`) :user:`fkiraly`
* [ENH] applying forecasting metrics disregarding index - docstrings and tests (:pr:`4960`) :user:`fkiraly`
* [ENH] metrics classes - add testing parameters (:pr:`5097`) :user:`fkiraly`
* [ENH] tests and fixes for ``numpy`` weights in performance metrics (:pr:`5086`) :user:`fkiraly`
* [ENH] input checks for ``BaseBenchmark``, allow ``add_estimator`` to accept multiple estimators (:pr:`4877`) :user:`hazrulakmal`
* [ENH] tests and fixes for ``numpy`` weights in performance metrics - probabilistic metrics (:pr:`5104`) :user:`fkiraly`

Data sets and data loaders
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] rework data loader module, ability to specify download mirrors (:pr:`4985`) :user:`fkiraly`

Forecasting
^^^^^^^^^^^

* [ENH] improvements to ``_ColumnEstimator`` - refactor to reduce coupling with ``BaseForecaster`` (:pr:`4791`) :user:`fkiraly`
* [ENH] rewrite ``test_probabilistic_metrics`` using proper ``pytest`` fixtures (:pr:`4946`) :user:`julia-kraus`
* [ENH] add expanding greedy splitter (:pr:`4917`) :user:`davidgilbertson`
* [ENH] Interface ``statsforecast`` MSTL, ``statsforecast`` back-adapter (:pr:`4865`) :user:`luca-miniati`
* [ENH] contiguous ``fh`` option for ``FhPlexForecaster`` (:pr:`4926`) :user:`fkiraly`
* [ENH] ensure robustness of ``StatsForecastBackAdapter`` w.r.t. change of ``predict_interval`` return format (:pr:`4991`) :user:`fkiraly`
* [ENH] improve ``SARIMAX`` test parameter coverage (:pr:`4932`) :user:`janpipek`
* [ENH] interface to ``statsforecast`` ARCH family estimators (:pr:`4938`) :user:`eyjo`
* [ENH] add test cases for ``Croston`` and ``ExponentialSmoothing`` (:pr:`4935`) :user:`Gigi1111`
* [ENH] applying forecasting metrics disregarding index - docstrings and tests (:pr:`4960`) :user:`fkiraly`
* [ENH] alias strings for ``scoring`` argument in forecasting tuners (:pr:`5058`) :user:`fkiraly`
* [ENH] allow ``YfromX`` to take missing data (:pr:`5062`) :user:`eenticott-shell`

Parameter estimators
^^^^^^^^^^^^^^^^^^^^

* [ENH] speed up parameter fitter base class boilerplate (:pr:`5057`) :user:`fkiraly`

Probability distributions and simulators
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] add length option to ``_bottom_hier_datagen`` hierarchical data generator, speed up ``ReconcilerForecaster`` doctest (:pr:`4979`) :user:`fkiraly`

Time series alignment
^^^^^^^^^^^^^^^^^^^^^

* [ENH] edit distance alignment algorithms from ``sktime`` native ``numba`` based aligners (:pr:`5075`) :user:`fkiraly`
* [ENH] extend ``BaseAligner.fit`` with input conversion (:pr:`5077`) :user:`fkiraly`
* [ENH] naive multiple aligners for baseline comparisons (:pr:`5076`) :user:`fkiraly`
* [ENH] tag for full/partial alignment, exact tests for full alignment output (:pr:`5080`) :user:`fkiraly`

Time series classification
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] full rework of time series classification notebook (:pr:`5045`) :user:`fkiraly`

Time series clustering
^^^^^^^^^^^^^^^^^^^^^^

* [ENH] Explicit centroid init for ``TimeSeriesLloyds``, ``TimeSeriesKMeans`` and ``TimeSeriesKMedoids`` (:pr:`5001`) :user:`Alex-JG3`
* [ENH] generalized ``tslearn`` adapter and clusterer refactor (:pr:`4992`) :user:`fkiraly`
* [ENH] interface to all ``tslearn`` clusterers (:pr:`5037`) :user:`fkiraly`

Time series distances and kernels
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [ENH] distance/kernel tag, uniformize base module (:pr:`5038`) :user:`fkiraly`

Transformations
^^^^^^^^^^^^^^^

* [ENH] inverse transform for ``CosineTransformer``, tag handling for limited range of invertibility (:pr:`3671`) :user:`fkiraly`
* [ENH] Holiday indicator transformers by country or market based on ``holidays`` package (:pr:`4893`) :user:`yarnabrina`
* [ENH] ``HolidayFeatures`` transformer (:pr:`4909`) :user:`VyomkeshVyas`
* [ENH] enable use of ``TabularToSeriesAdaptor`` with feature selectors, and passing of ``y`` (:pr:`4978`) :user:`fkiraly`
* [ENH] speed up ``BaseTransformer`` checks and conversion boilerplate (:pr:`5036`) :user:`fkiraly`
* [ENH] ``DropNA`` transformer to drop rows or columns with nan (:pr:`5049`) :user:`hliebert`
* [ENH] speed up ``Lag`` transformer (:pr:`5035`) :user:`fkiraly`
* [ENH] option to remember data in ``SplitterSummarizer`` (:pr:`5070`) :user:`fkiraly`

Testing framework
^^^^^^^^^^^^^^^^^

* [ENH] speed-up test collection by improvements to ``_testing.scenarios`` (:pr:`4901`) :user:`tarpas`
* [ENH] test for more than one parameter sets per estimator (:pr:`2862`) :user:`fkiraly`
* [ENH] remove ``sklearn`` dependency in ``test_get_params`` (:pr:`5011`) :user:`fkiraly`
* [ENH] testing only estimators from modules that have changed compared to ``main`` (:pr:`5019`) :user:`fkiraly`, :user:`yarnabrina`
* [ENH] dependency and diff test switch for individual estimators to decorate non-suite tests (:pr:`5084`) :user:`fkiraly`

Maintenance
~~~~~~~~~~~

* [MNT] add ``statsforecast`` to the ``pandas2`` compatible dependency set (:pr:`4878`) :user:`fkiraly`
* [MNT] bound ``dask<2023.7.1`` to diagnose and remove bug #4925 from ``main`` (:pr:`4928`) :user:`fkiraly`
* [MNT] [Dependabot](deps-dev): Update sphinx-design requirement from <0.5.0 to <0.6.0 (:pr:`4969`) :user:`dependabot[bot]`
* [MNT] speed up ``test_gscv_proba`` test (:pr:`4962`) :user:`fkiraly`
* [MNT] speed up ``test_stat`` benchmarking test (:pr:`4990`) :user:`fkiraly`
* [MNT] speed up clustering dunder test (:pr:`4982`) :user:`fkiraly`
* [MNT] speed up various tests in the forecasting module (:pr:`4963`) :user:`fkiraly`
* [MNT] speed up basic ``check_estimator`` tests (:pr:`4980`) :user:`fkiraly`
* [MNT] speed up costly redundant ``ElasticEnsemble`` classifier doctest (:pr:`4981`) :user:`fkiraly`
* [MNT] address various deprecation warnings (:pr:`5018`) :user:`fkiraly`
* [MNT] rename ``TestedMockClass`` to ``MockTestedClass`` (:pr:`5005`) :user:`fkiraly`
* [MNT] updated sphinx intersphinx links for other libraries (:pr:`5016`) :user:`yarnabrina`
* [MNT] fix duplication of ``pytest`` ``durations`` parameter in CI (:pr:`5034`) :user:`fkiraly`
* [MNT] speed up various non-suite tests (:pr:`5027`) :user:`fkiraly`
* [MNT] speed up various non-suite tests, part 2 (:pr:`5071`) :user:`fkiraly`
* [MNT] add more soft dependencies to ``show_versions`` (:pr:`5059`) :user:`fkiraly`

Documentation
~~~~~~~~~~~~~

* [DOC] minor improvements to the dependencies guide (:pr:`4896`) :user:`fkiraly`
* [DOC] remove outdated references from transformers API (:pr:`4895`) :user:`fkiraly`
* [DOC] Installation documentation: Pip install without soft dependencies for conda environments (:pr:`4936`) :user:`Verogli`
* [DOC] clarifications to different installations in install documentation (:pr:`4937`) :user:`julia-kraus`
* [DOC] Contributors update (:pr:`4892`) :user:`fkiraly`
* [DOC] correct docstring of ``BaseForecaster.score``, reference to use of non-symmetric MAPE (:pr:`4948`) :user:`MBristle`
* [DOC] Contributors update (:pr:`4944`) :user:`fkiraly`
* [DOC] remove duplication of troubleshooting 'matches_not_found' in install instructions (:pr:`4956`) :user:`julia-kraus`
* [DOC] Contributors update (:pr:`4961`) :user:`fkiraly`
* [DOC] Resolve broken link (governance) in README.md (:pr:`4942`) :user:`eyjo`
* [ENH] in doc build, add copy clipboard button for Example sections (#5015) (:pr:`5015`) :user:`yarnabrina`
* [DOC] improve description of ``scoring`` in docstrings of tuning forecasters such as ``ForecastingGridSearchCV`` (:pr:`5022`) :user:`fkiraly`
* [DOC] API reference for time series aligners (:pr:`5074`) :user:`fkiraly`
* [DOC] Contributors update (:pr:`5010`) :user:`fkiraly`
* [DOC] improve formatting of docstring examples (:pr:`5078`) :user:`yarnabrina`
* [DOC] Contributors update (:pr:`5085`) :user:`fkiraly`
* [DOC] docstring example for ``PinballLoss`` (#5068) (:pr:`5068`) :user:`Ram0nB`
* [DOC] Contributors update (:pr:`5088`) :user:`fkiraly`

Fixes
~~~~~

BaseObject and base framework
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] in ``craft``, fix false positive detection of ``True``, ``False`` as class names (:pr:`5066`) :user:`fkiraly`

Benchmarking, Metrics, Splitters
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] use correct arguments in ``geometric_mean_absolute_error`` (:pr:`4987`) :user:`yarnabrina`

Data types, checks, conversions
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] Fix ``vectorize_est`` returning jumbled rows for row vectorization, pd.DataFrame return, if row names were not lexicographically ordered (:pr:`5110`) :user:`fkiraly`, :user:`hoesler`

Forecasting
^^^^^^^^^^^

* [BUG] clarify forecasting tuning estimators' docstrings and error messages in case of ``refit=False`` (:pr:`4945`) :user:`fkiraly`
* [BUG] fix ``ConformalIntervals`` failure if wrapped estimator supports hierarchical mtypes (:pr:`5091`, :pr:`5093`) :user:`fkiraly`

Parameter estimators
^^^^^^^^^^^^^^^^^^^^

* [BUG] fix ``PluginParamsForecaster`` in ``params: dict`` case (:pr:`4922`) :user:`fkiraly`

Time series alignment
^^^^^^^^^^^^^^^^^^^^^

* [BUG] fix missing transpose in ``AlignerDtwNumba`` (:pr:`5080`) :user:`fkiraly`

Time series classification
^^^^^^^^^^^^^^^^^^^^^^^^^^

* [BUG] fix ``sklearn`` interface non-conformance for estimators in ``_proximity_forest.py``, add further test parameter sets (:pr:`3520`) :user:`Abelarm`, :user:`fkiraly`

Time series clustering
^^^^^^^^^^^^^^^^^^^^^^

* [BUG] add informative error messages for incompatible ``scitype`` in ``BaseClusterer`` (:pr:`4958`) :user:`achieveordie`

Transformations
^^^^^^^^^^^^^^^

* [BUG] fix ``DataConversionWarning`` in ``FeatureSelection`` (:pr:`4883`) :user:`fkiraly`
* [BUG] Fix forecaster based imputation strategy in ``Imputer`` if forecaster requires ``fh`` in ``fit`` (:pr:`4999`) :user:`MCRE-BE`
* [BUG] fix ``Differencer`` for integer index (:pr:`4984`) :user:`fkiraly`
* [BUG] Fix ``Differencer.inverse_transform`` on train data if ``na_handling=fill_zero`` (:pr:`4998`) :user:`benHeid`, :user:`MCRE-BE`
* [BUG] fix wrong logic for ``index_out="shift"`` in ``Lag`` transformer (:pr:`5069`) :user:`fkiraly`

Contributors
~~~~~~~~~~~~

:user:`Abelarm`,
:user:`achieveordie`,
:user:`Alex-JG3`,
:user:`benHeid`,
:user:`davidgilbertson`,
:user:`eenticott-shell`,
:user:`eyjo`,
:user:`fkiraly`,
:user:`Gigi1111`,
:user:`hazrulakmal`,
:user:`hliebert`,
:user:`janpipek`,
:user:`julia-kraus`,
:user:`luca-miniati`,
:user:`MBristle`,
:user:`MCRE-BE`,
:user:`Ram0nB`,
:user:`tarpas`,
:user:`Verogli`,
:user:`VyomkeshVyas`,
:user:`yarnabrina`

Version 0.21.0 - 2023-07-19
---------------------------

Maintenance release - dependency updates, scheduled deprecations.

For last non-maintenance content updates, see 0.20.1.

Contents
~~~~~~~~

* ``sktime`` is now compatible with ``sklearn 1.3.X``
* start of change in column naming convention for univariate probabilistic forecasts,
  in preparation for 0.23.0 - see below for details for users and developers
* scheduled 0.21.0 deprecation actions

Dependency changes
~~~~~~~~~~~~~~~~~~

* ``scikit-learn`` version bounds now allow versions ``1.3.X``
* the ``deprecated`` package is deprecated as a core dependency of ``sktime``, and
  will cease to be a dependency from 0.22.0 onwards. No action is required of users
  or developers, as the package was used only for internal deprecation actions.
* ``pycatch22`` has been added back as a soft dependency, after python 3.7 EOL

Deprecations and removals
~~~~~~~~~~~~~~~~~~~~~~~~~

Forecasting - change of column naming for univariate probabilistic forecasts
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

From 0.23.0, returns of forecasters' ``predict_quantiles`` and ``predict_intervals``
in the univariate case will be made consistent with the multivariate case:
the name of the uppermost (0-indexed) column level will always be the variable name.
Previously, in the univariate case, it was always ``Coverage`` or ``Quantiles``,
irrespective of the variable name present in ``y``, whereas in the multivariate case,
it was always the variable names present in ``y``.

The change will take place over two MINOR cycles, 0.21.X (early phase) and 0.22.X (late phase),
the union of which makes up the change period.
We explain the schedule below, for users, and then for maintainers of third party forecasters ("extenders").

Users should use a new, temporary ``legacy_interface`` argument to handle the change:

* Users - change period. The two forecaster methods ``predict_quantiles`` and ``predict_intervals``
  will have a new boolean argument, ``legacy_interface``. If ``True``, the methods
  produce returns with the current naming convention. If ``False``, the methods produce
  returns with the future, post-change naming convention.
* Users - early and late phase. In the early phase (0.21.X), the default value of ``legacy_interface``
  will be ``True``. In the late phase (0.22.X), the default value of ``legacy_interface`` will be ``False``.
  This change of default will occur in 0.22.0, and may be breaking for users who do not specify the argument.
* Users - post-deprecation. In 0.23.0, the ``legacy_interface`` argument will be removed.
  The methods will always produce returns with the future, post-change naming convention.
  This change may be breaking for users who do not remove the argument by 0.23.0.
* Appropriate deprecation warnings will be raised from 0.21.0 onwards, until 0.22.last.
* Users - recommended change actions. Users should aim to upgrade dependent code to ``legacy_interface=False`` behaviour by 0.21.last,
  and to remove ``legacy_interface`` arguments after 0.22.0 and before 0.23.0.
  Users who need more time to upgrade dependent code can set ``legacy_interface=True`` until 0.22.last.

Extenders should use the new ``"pred_int:legacy_interface:testcfg"`` config field to upgrade their third party extensions:

* Extenders - change period. The config field ``"pred_int:legacy_interface:testcfg"`` has been added
  to all descendants of the ``BaseForecaster`` class. This config controls the contract
  that the ``check_estimator`` and ``pytest`` tests check against, and can be set by ``set_config``.
* The default value of the tag is ``"auto"`` - this means that the tests will check against the current
  naming convention in the early phase (0.21.X), and against the future naming convention in the late phase (0.22.X),
  for ``_predict_quantiles`` or ``_predict_intervals`` having the standard signature, without ``legacy_interface``.
  From 0.23.0 on, the tag will have no effect.
* In the change period: if the tag is set to ``"new"``, the tests will always check against the new interface;
  if the tag is set to ``"old"``, the tests will check against the old interface, irrespective of the phase.
  From 0.23.0, the setting will have no effect and the tests will always check against the new interface.
* Extenders - recommended change actions: Extenders should aim to upgrade their third party extensions
  to ``"pred_int:legacy_interface:testcfg=new"`` behaviour by 0.21.last. Tests against late stage
  and post-deprecation behaviour can be enforced by setting ``forecaster.set_config({"pred_int:legacy_interface:testcfg": "new"})``,
